2013-04-24  Claudio Saavedra  <csaavedra@igalia.com>

        Build break after r149004
        https://bugs.webkit.org/show_bug.cgi?id=115091

        Reviewed by Csaba Osztrogonác.

        * WebProcess/WebPage/gtk/LayerTreeHostGtk.cpp:
        (WebKit::LayerTreeHostGtk::pageBackgroundTransparencyChanged):
        (WebKit): Add dummy method for new virtual method.
        * WebProcess/WebPage/gtk/LayerTreeHostGtk.h:
        (LayerTreeHostGtk): Ditto.

2013-04-23  Ryuan Choi  <ryuan.choi@samsung.com>

        [EFL][WK2] Build break after r149004
        https://bugs.webkit.org/show_bug.cgi?id=115066

        Reviewed by Tim Horton.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::pageBackgroundTransparencyChanged):
        Added dummy method for new virtual method.
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.h:
        (CoordinatedLayerTreeHost): Ditto.

2013-04-23  Simon Fraser  <simon.fraser@apple.com>

        Turn off tiled drawing in the Web Inspector
        https://bugs.webkit.org/show_bug.cgi?id=115064

        Reviewed by Tim Horton.
        
        We get little benefit from making the Web Inspector use tiled drawing;
        it doesn't scroll the main frame, so doesn't benefit from the ScrollingCoordinator.
        Not using tiled drawing also means that we won't make compositing
        layers for position: -webkit-sticky, which avoids a number of issues
        with compositing layer proliferation in the inspector.
        
        Also turn off accelerated drawing, since that pref will force a single
        compositing layer.

        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::createInspectorPageGroup):
        * UIProcess/mac/WebInspectorProxyMac.mm:

2013-04-23  Simon Fraser  <simon.fraser@apple.com>

        When the web page transparency changes, DrawingAreaImpl needs to know about it
        https://bugs.webkit.org/show_bug.cgi?id=115062

        Reviewed by Tim Horton.
        
        The non-composited contents layer owned by LayerTreeHostMac needs to
        be marked as opaque or not depending on whether the WebPage draws
        a background (or transparent background). It computed this at creation,
        but did not dynamically update the state. Fix it so it does.
        
        This fixes cases of garbage pixels in the Web Inspector toolbar area
        in some configurations.

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::pageBackgroundTransparencyChanged):
        * WebProcess/WebPage/DrawingAreaImpl.h:
        (DrawingAreaImpl):
        * WebProcess/WebPage/LayerTreeHost.h:
        * WebProcess/WebPage/mac/LayerTreeHostMac.h:
        * WebProcess/WebPage/mac/LayerTreeHostMac.mm:
        (WebKit::LayerTreeHostMac::pageBackgroundTransparencyChanged):

2013-04-23  Anders Carlsson  <andersca@apple.com>

        REGRESSION(r148922): Crash opening web archives or loading web pages
        https://bugs.webkit.org/show_bug.cgi?id=115061
        <rdar://problem/13714228>

        Reviewed by Sam Weinig.

        * WebProcess/Network/WebResourceLoader.cpp:
        (WebKit::WebResourceLoader::didReceiveResponseWithCertificateInfo):
        Calling ResourceLoader::didReceiveResponse can cause the WebResourceLoader object to go away,
        so protect it here and guard against a null core loader.

2013-04-23  Tim Horton  <timothy_horton@apple.com>

        Web process crashes at WebPage::determinePrimarySnapshottedPlugInTimerFired + 8
        https://bugs.webkit.org/show_bug.cgi?id=115056
        <rdar://problem/13719543>

        Reviewed by Simon Fraser.

        Stop the primary plugin detection timer if the WebPage is torn down.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::close):

2013-04-23  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Add webkit_uri_request_get_http_headers to WebKit2 GTK+ API
        https://bugs.webkit.org/show_bug.cgi?id=112160

        Reviewed by Andreas Kling.

        It allows to load requests with custom headers, or to update the
        headers of a request before being sent to the server in the
        WebKitWebPage::send-request callback.

        * UIProcess/API/gtk/WebKitURIRequest.cpp:
        (_WebKitURIRequestPrivate): Add SoupMessageHeaders.
        (webkit_uri_request_get_http_headers): Return the HTTP headers of
        the request as a SoupMessageHeaders if the request is HTTP. A new
        SoupMessageHeaders is created on demand using the existing headers
        of the request.
        (webkitURIRequestGetResourceRequest): Instead of returning a const
        reference of the internal ResourceRequest, set a request passed as
        a reference and update its HTTP headers using the
        SoupMessageHeaders if present.
        * UIProcess/API/gtk/WebKitURIRequest.h:
        * UIProcess/API/gtk/WebKitURIRequestPrivate.h:
        * UIProcess/API/gtk/WebKitWebView.cpp:
        (webkit_web_view_load_request): Update to the new
        webkitURIRequestGetResourceRequest API.
        * UIProcess/API/gtk/docs/webkit2gtk-sections.txt: Add
        webkit_uri_request_get_http_headers symbol.
        * UIProcess/API/gtk/tests/TestLoaderClient.cpp:
        (testWebPageURI):
        (testURIRequestHTTPHeaders):
        (serverCallback):
        (beforeAll):
        * WebProcess/InjectedBundle/API/gtk/WebKitWebPage.cpp:
        (willSendRequestForFrame): Update to the new
        webkitURIRequestGetResourceRequest API.

2013-04-23  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [WK2] Make EFL WKView API shareable between ports
        https://bugs.webkit.org/show_bug.cgi?id=114734

        Reviewed by Anders Carlsson.

        EFL-independent part of WKView API (and its implementation) is now
        shareable between ports that use Coordinated Graphics and put to
        CoordinatedGraphics folders.

        * PlatformEfl.cmake:
        * UIProcess/API/C/CoordinatedGraphics/WKView.cpp: Renamed from Source/WebKit2/UIProcess/API/C/efl/WKView.cpp.
        (WKViewCreate):
        (WKViewInitialize):
        (WKViewGetSize):
        (WKViewSetSize):
        (WKViewSetViewClient):
        (WKViewIsFocused):
        (WKViewSetIsFocused):
        (WKViewIsVisible):
        (WKViewSetIsVisible):
        (WKViewGetContentScaleFactor):
        (WKViewSetContentScaleFactor):
        (WKViewGetContentPosition):
        (WKViewSetContentPosition):
        (WKViewSetUserViewportTranslation):
        (WKViewUserViewportToContents):
        (WKViewPaintToCurrentGLContext):
        (WKViewGetPage):
        (WKViewSetDrawsBackground):
        (WKViewGetDrawsBackground):
        (WKViewSetDrawsTransparentBackground):
        (WKViewGetDrawsTransparentBackground):
        (WKViewSetThemePath):
        (WKViewSuspendActiveDOMObjectsAndAnimations):
        (WKViewResumeActiveDOMObjectsAndAnimations):
        (WKViewSetShowsAsSource):
        (WKViewGetShowsAsSource):
        (WKViewExitFullScreen):
        * UIProcess/API/C/CoordinatedGraphics/WKView.h: Renamed from Source/WebKit2/UIProcess/API/C/efl/WKView.h.
        * UIProcess/API/C/efl/WKViewEfl.cpp: Added.
        (WKViewPaintToCairoSurface):
        (WKViewCreateSnapshot):
        * UIProcess/API/C/efl/WKViewEfl.h: Added.
        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::EwkView):
        * UIProcess/API/efl/EwkView.h:
        * UIProcess/CoordinatedGraphics/WebView.cpp: Renamed from Source/WebKit2/UIProcess/efl/WebView.cpp.
        (WebKit):
        (WebKit::WebView::WebView):
        (WebKit::WebView::~WebView):
        (WebKit::WebView::initialize):
        (WebKit::WebView::setSize):
        (WebKit::WebView::setFocused):
        (WebKit::WebView::setVisible):
        (WebKit::WebView::setUserViewportTranslation):
        (WebKit::WebView::userViewportToContents):
        (WebKit::WebView::paintToCurrentGLContext):
        (WebKit::WebView::setThemePath):
        (WebKit::WebView::setDrawsBackground):
        (WebKit::WebView::drawsBackground):
        (WebKit::WebView::setDrawsTransparentBackground):
        (WebKit::WebView::drawsTransparentBackground):
        (WebKit::WebView::suspendActiveDOMObjectsAndAnimations):
        (WebKit::WebView::resumeActiveDOMObjectsAndAnimations):
        (WebKit::WebView::setShowsAsSource):
        (WebKit::WebView::showsAsSource):
        (WebKit::WebView::exitFullScreen):
        (WebKit::WebView::initializeClient):
        (WebKit::WebView::didChangeContentsSize):
        (WebKit::WebView::transformFromScene):
        (WebKit::WebView::transformToScene):
        (WebKit::WebView::coordinatedGraphicsScene):
        (WebKit::WebView::updateViewportSize):
        (WebKit::WebView::dipSize):
        (WebKit::WebView::createDrawingAreaProxy):
        (WebKit::WebView::setViewNeedsDisplay):
        (WebKit::WebView::displayView):
        (WebKit::WebView::scrollView):
        (WebKit::WebView::viewSize):
        (WebKit::WebView::isViewWindowActive):
        (WebKit::WebView::isViewFocused):
        (WebKit::WebView::isViewVisible):
        (WebKit::WebView::isViewInWindow):
        (WebKit::WebView::processDidCrash):
        (WebKit::WebView::didRelaunchProcess):
        (WebKit::WebView::pageClosed):
        (WebKit::WebView::toolTipChanged):
        (WebKit::WebView::setCursor):
        (WebKit::WebView::setCursorHiddenUntilMouseMoves):
        (WebKit::WebView::registerEditCommand):
        (WebKit::WebView::clearAllEditCommands):
        (WebKit::WebView::canUndoRedo):
        (WebKit::WebView::executeUndoRedo):
        (WebKit::WebView::screenToWindow):
        (WebKit::WebView::windowToScreen):
        (WebKit::WebView::doneWithKeyEvent):
        (WebKit::WebView::doneWithTouchEvent):
        (WebKit::WebView::createPopupMenuProxy):
        (WebKit::WebView::createContextMenuProxy):
        (WebKit::WebView::createColorChooserProxy):
        (WebKit::WebView::setFindIndicator):
        (WebKit::WebView::enterAcceleratedCompositingMode):
        (WebKit::WebView::exitAcceleratedCompositingMode):
        (WebKit::WebView::updateAcceleratedCompositingMode):
        (WebKit::WebView::didCommitLoadForMainFrame):
        (WebKit::WebView::didFinishLoadingDataForCustomRepresentation):
        (WebKit::WebView::customRepresentationZoomFactor):
        (WebKit::WebView::setCustomRepresentationZoomFactor):
        (WebKit::WebView::flashBackingStoreUpdates):
        (WebKit::WebView::findStringInCustomRepresentation):
        (WebKit::WebView::countStringMatchesInCustomRepresentation):
        (WebKit::WebView::updateTextInputState):
        (WebKit::WebView::handleDownloadRequest):
        (WebKit::WebView::convertToDeviceSpace):
        (WebKit::WebView::convertToUserSpace):
        (WebKit::WebView::didChangeViewportProperties):
        (WebKit::WebView::pageDidRequestScroll):
        (WebKit::WebView::didRenderFrame):
        (WebKit::WebView::pageTransitionViewportReady):
        * UIProcess/CoordinatedGraphics/WebView.h: Renamed from Source/WebKit2/UIProcess/efl/WebView.h.
        (WebCore):
        (WebKit):
        (WebView):
        (WebKit::WebView::size):
        (WebKit::WebView::isFocused):
        (WebKit::WebView::isVisible):
        (WebKit::WebView::setContentScaleFactor):
        (WebKit::WebView::contentScaleFactor):
        (WebKit::WebView::setContentPosition):
        (WebKit::WebView::contentPosition):
        (WebKit::WebView::pageRef):
        (WebKit::WebView::page):
        * UIProcess/CoordinatedGraphics/WebViewClient.cpp: Renamed from Source/WebKit2/UIProcess/efl/WebViewClient.cpp.
        (WebKit):
        (WebKit::WebViewClient::viewNeedsDisplay):
        (WebKit::WebViewClient::didChangeContentsSize):
        (WebKit::WebViewClient::webProcessCrashed):
        (WebKit::WebViewClient::webProcessDidRelaunch):
        (WebKit::WebViewClient::didChangeContentsPosition):
        (WebKit::WebViewClient::didRenderFrame):
        (WebKit::WebViewClient::didCompletePageTransition):
        (WebKit::WebViewClient::didChangeViewportAttributes):
        (WebKit::WebViewClient::didChangeTooltip):
        * UIProcess/CoordinatedGraphics/WebViewClient.h: Renamed from Source/WebKit2/UIProcess/efl/WebViewClient.h.
        (WebCore):
        (WebKit):
        * UIProcess/efl/WebViewEfl.cpp: Added.
        (WebKit):
        (WebKit::WebView::create):
        (WebKit::WebViewEfl::WebViewEfl):
        (WebKit::WebViewEfl::setEwkView):
        (WebKit::WebViewEfl::paintToCairoSurface):
        (WebKit::WebViewEfl::createPopupMenuProxy):
        (WebKit::WebViewEfl::createContextMenuProxy):
        (WebKit::WebViewEfl::setCursor):
        (WebKit::WebViewEfl::updateTextInputState):
        (WebKit::WebViewEfl::handleDownloadRequest):
        * UIProcess/efl/WebViewEfl.h: Added.
        (WebKit):
        (WebViewEfl):
        (WebKit::WebViewEfl::ewkView):

2013-04-23  Antoine Quint  <graouts@apple.com>

        Initial advance of text runs should be taken into account
        https://bugs.webkit.org/show_bug.cgi?id=114949

        Reviewed by Darin Adler.

        Adding support for new method CTRunGetInitialAdvance in WebKitSystemInterface.

        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface):

2013-04-23  Noam Rosenthal  <noam@webkit.org>

        [Coordinated Graphics] Remove the lockAnimations code path
        https://bugs.webkit.org/show_bug.cgi?id=114899

        Remove locking/unlocking animations and checks for the lock state.
        The animation locking has been tested to create not-so-smooth animations,
        while the use case where the composited animations run out of sync from
        the non-composited animations is very rare and unnoticeable.

        Reviewed by Benjamin Poulain.

        * UIProcess/CoordinatedGraphics/CoordinatedLayerTreeHostProxy.cpp:
        * UIProcess/CoordinatedGraphics/CoordinatedLayerTreeHostProxy.messages.in:
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::flushPendingLayerChanges):
        (WebKit::CoordinatedLayerTreeHost::performScheduledLayerFlush):
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.h:

2013-04-22  Sam Weinig  <sam@webkit.org>

        Need WebKit SPI to detect whether a page contains form controls
        <rdar://problem/13686661>
        https://bugs.webkit.org/show_bug.cgi?id=115003

        Reviewed by Beth Dakin.

        * WebProcess/InjectedBundle/API/c/WKBundleFrame.cpp:
        (WKBundleFrameContainsAnyFormControls):
        * WebProcess/InjectedBundle/API/c/WKBundleFramePrivate.h:
        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::containsAnyFormControls):
        * WebProcess/WebPage/WebFrame.h:

2013-04-22  Alexey Proskuryakov  <ap@apple.com>

        [Mac] REGRESSION (r142806): "Just Leaking" Console errors on launch
        https://bugs.webkit.org/show_bug.cgi?id=115002
        <rdar://problem/13254212>

        Reviewed by Sam Weinig.

        * Shared/EntryPointUtilities/mac/LegacyProcess/ChildProcessMain.mm:
        (WebKit::BootstrapMain): Added an autorelease pool for code that uses Objective-C.

2013-04-22  Anders Carlsson  <andersca@apple.com>

        Web process should decide when to continue main resource loads
        https://bugs.webkit.org/show_bug.cgi?id=114995

        Reviewed by Sam Weinig.

        Main resource loads can be converted to downloads, so we need the ability to let the web process decide when
        to continue loading after a response has been received.

        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::didReceiveResponseAsync):
        For non-main resources, just call continueDidReceiveResponse directly; there's no need to ping-pong to the web process in that case.

        (WebKit::NetworkResourceLoader::continueDidReceiveResponse):
        Just call ResourceHandle::continueDidReceiveResponse.

        * NetworkProcess/NetworkResourceLoader.messages.in:
        Add ContinueDidReceiveResponse message.
        
        * NetworkProcess/SchedulableLoader.cpp:
        (WebKit::SchedulableLoader::SchedulableLoader):
        Initialize m_isLoadingMainResource.

        * NetworkProcess/SchedulableLoader.h:
        (WebKit::SchedulableLoader::isLoadingMainResource):
        Add getter.

        (SchedulableLoader):
        Move m_shouldClearReferrerOnHTTPSToHTTPRedirect next to the rest of the booleans.

        * Shared/Network/NetworkResourceLoadParameters.cpp:
        (WebKit::NetworkResourceLoadParameters::NetworkResourceLoadParameters):
        (WebKit::NetworkResourceLoadParameters::encode):
        (WebKit::NetworkResourceLoadParameters::decode):
        * Shared/Network/NetworkResourceLoadParameters.h:
        (NetworkResourceLoadParameters):
        Add isMainResource flag.

        * WebProcess/Network/WebResourceLoadScheduler.cpp:
        (WebKit::WebResourceLoadScheduler::scheduleSubresourceLoad):
        Pass the cached resource to scheduleLoad.

        (WebKit::WebResourceLoadScheduler::schedulePluginStreamLoad):
        Pass null to scheduleLoad.

        (WebKit::WebResourceLoadScheduler::scheduleLoad):
        Initialize isMainResource.

        * WebProcess/Network/WebResourceLoader.cpp:
        (WebKit::WebResourceLoader::didReceiveResponseWithCertificateInfo):
        If this is a main resource load, send back a ContinueDidReceiveResponse message.

2013-04-22  Tim Horton  <timothy_horton@apple.com>

        Plugin Snapshotting: Don't consume insane amounts of time detecting the primary plugin
        https://bugs.webkit.org/show_bug.cgi?id=114994
        <rdar://problem/13696269>

        Reviewed by Anders Carlsson.

        On some pages, we currently waste a lot of time on every subframe load
        and every addPluginView doing primary plugin detection. This patch
        attempts to address this via a few minor changes:

        - Only allow detection after the main frame's didFinishLoad comes, instead of the first subframe.

        - Only explicitly detect on the main frame's didFinishLoad (not subframes).

        - Coalesce calls to determinePrimarySnapshottedPlugIn from both addPluginView
        (in case JS is adding lots of plugins in a loop) and didFinishLoad.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::addPluginView): Coalesce calls to determinePrimarySnapshottedPlugIn.
        (WebKit::WebPage::didFinishLoad):
        Coalesce calls to determinePrimarySnapshottedPlugIn.
        Bail on subframe loads, we're only interested in the main frame being complete.
        (WebKit::WebPage::determinePrimarySnapshottedPlugInTimerFired):
        Call determinePrimarySnapshottedPlugIn.
        * WebProcess/WebPage/WebPage.h:
        Add m_determinePrimarySnapshottedPlugInTimer and determinePrimarySnapshottedPlugInTimerFired

2013-04-22  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13334446> [Mac] Tweak sandbox profiles.

        Reviewed by Anders Carlsson.

        Unbreak Lion, which doesn't provide detailed control over IPC.

        * WebProcess/com.apple.WebProcess.sb.in:

2013-04-22  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Enable introspection always for developer builds
        https://bugs.webkit.org/show_bug.cgi?id=114983

        Reviewed by Gustavo Noronha Silva.

        * GNUmakefile.am: Make warnings during gir scanning cause the build to fail. Eliminate
        warnings about deprecated API that the g-ir-scanner uses when generating
        the scanner program. Use --quiet.

2013-04-22  Anders Carlsson  <andersca@apple.com>

        Make it easier to extend NetworkResourceLoadParameters
        https://bugs.webkit.org/show_bug.cgi?id=114992

        Reviewed by Sam Weinig.

        Turn NetworkResourceLoadParameters into a struct which matches all our other parameter classes in WebKit2. Fill in the struct manually
        instead of having a constructor with 9 parameters.

        * NetworkProcess/NetworkConnectionToWebProcess.cpp:
        (WebKit::NetworkConnectionToWebProcess::scheduleResourceLoad):
        (WebKit::NetworkConnectionToWebProcess::performSynchronousLoad):
        * NetworkProcess/SchedulableLoader.cpp:
        (WebKit::SchedulableLoader::SchedulableLoader):
        * Shared/Network/NetworkResourceLoadParameters.cpp:
        (WebKit::NetworkResourceLoadParameters::NetworkResourceLoadParameters):
        (WebKit::NetworkResourceLoadParameters::encode):
        (WebKit::NetworkResourceLoadParameters::decode):
        * Shared/Network/NetworkResourceLoadParameters.h:
        (NetworkResourceLoadParameters):
        * WebProcess/Network/WebResourceLoadScheduler.cpp:
        (WebKit::WebResourceLoadScheduler::scheduleLoad):
        * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
        (WebKit::WebPlatformStrategies::loadResourceSynchronously):

2013-04-22  Tim Horton  <timothy_horton@apple.com>

        PDFPlugin: Support unlocking encrypted PDFs
        https://bugs.webkit.org/show_bug.cgi?id=114938
        <rdar://problem/12872888>

        Reviewed by Alexey Proskuryakov and Oliver Hunt.

        If we try to load an encrypted PDF, we need to provide a sane mechanism
        through which the user can provide the password. Add a slightly-below-center
        password field to match PDFKit's normal behavior.

        * WebKit2.xcodeproj/project.pbxproj: Add PDFPluginPasswordField.{h,mm}
        * WebProcess/Plugins/PDF/PDFLayerControllerDetails.h: Add attemptToUnlockWithPassword:
        * WebProcess/Plugins/PDF/PDFPlugin.h:
        Add createPasswordEntryForm, attemptToUnlockPDF, m_passwordField.
        * WebProcess/Plugins/PDF/PDFPlugin.mm:
        (annotationStyle): Make #annotationContainer a flexbox that centers its contents.
        This won't affect the normal absolutely-positioned form fields, but the inline
        password field will be centered vertically and horizontally.

        (WebKit::PDFPlugin::pdfDocumentDidLoad):
        If the document is locked when loaded, create a password field.

        (WebKit::PDFPlugin::createPasswordEntryForm):
        Create a PDFPluginPasswordField and attach it to the document.

        (WebKit::PDFPlugin::attemptToUnlockPDF):
        Try to unlock the PDF with the given password. If this succeeds, remove
        the password field and relayout the scroll view.

        (WebKit::PDFPlugin::calculateSizes):
        Make the document 0x0 if it is locked, preventing scrolling.

        (WebKit::PDFPlugin::handleMouseEvent):
        Don't pass mouse events to PDFLayerController while it is locked,
        as it has no useful events to provide, and will try to present a
        dialog asking for the password if we let a click through.

        * WebProcess/Plugins/PDF/PDFPluginAnnotation.h:
        (WebKit::PDFPluginAnnotation::eventListener): Added.
        * WebProcess/Plugins/PDF/PDFPluginAnnotation.mm:
        (WebKit::PDFPluginAnnotation::handleEvent):
        Move event-handling code here from PDFPluginAnnotationEventListener::handleEvent
        so that subclasses can override this instead of having to have their own
        event listeners (this is also why we now expose eventListener()).

        (WebKit::PDFPluginAnnotation::PDFPluginAnnotationEventListener::handleEvent):
        Forward the event to our owning PDFPluginAnnotation.

        * WebProcess/Plugins/PDF/PDFPluginPasswordField.h: Added.
        (WebKit::PDFPluginPasswordField::PDFPluginPasswordField):
        * WebProcess/Plugins/PDF/PDFPluginPasswordField.mm: Added.
        (WebKit::PDFPluginPasswordField::create):
        (WebKit::PDFPluginPasswordField::~PDFPluginPasswordField):
        Unregister for keyup.

        (WebKit::PDFPluginPasswordField::createAnnotationElement):
        Register for keyup, and set our element's class to "password".

        (WebKit::PDFPluginPasswordField::updateGeometry):
        Added. Override updateGeometry and do nothing, as the password field
        has a geometry defined by CSS instead of by the PDF content.

        (WebKit::PDFPluginPasswordField::handleEvent):
        If the enter/return key is pressed, attempt to unlock the PDF. Also,
        we do not call either of our superclass' implementations of handleEvent,
        because blurring the password field should not destroy it, and tabbing
        between fields has no relevance when there can only be one field.

        * WebProcess/Plugins/PDF/PDFPluginTextAnnotation.h:
        (WebKit::PDFPluginTextAnnotation::PDFPluginTextAnnotationEventListener):
        Removed. We now share our superclass' event listener.

        (WebKit::PDFPluginTextAnnotation::textAnnotation): Const.
        * WebProcess/Plugins/PDF/PDFPluginTextAnnotation.mm:
        (WebKit::PDFPluginTextAnnotation::~PDFPluginTextAnnotation):
        PDFPluginTextAnnotation no longer has its own event listener,
        so there's nothing left to clear here. Just make sure to unregister
        our event from PDFPluginAnnotation's shared event listener!

        (WebKit::PDFPluginTextAnnotation::createAnnotationElement):
        Ensure that we can create a PDFPluginTextAnnotation with a null annotation.

        (WebKit::PDFPluginTextAnnotation::commit): Use value().
        (WebKit::PDFPluginTextAnnotation::value):
        Factor retrieving the value of the form control out of commit().

        (WebKit::PDFPluginTextAnnotation::handleEvent):
        Call up to PDFPluginAnnotation's handler so that defocus destroys the annotation.

2013-04-22  Anders Carlsson  <andersca@apple.com>

        Slow/beachballing when using the find bar on a page with plug-ins
        https://bugs.webkit.org/show_bug.cgi?id=114990
        <rdar://problem/12832313>

        Reviewed by Tim Horton.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::notifyWidget):
        Call shouldCreateTransientPaintingSnapshot().

        (WebKit::PluginView::shouldCreateTransientPaintingSnapshot):
        Don't create a painting snapshot if we're asked to paint the find indicator.

        * WebProcess/Plugins/PluginView.h:
        Add new member function.

2013-04-22  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13334446> [Mac] Tweak sandbox profiles.

        Reviewed by Sam Weinig.

        * NetworkProcess/mac/com.apple.WebKit.NetworkProcess.sb.in:
        * WebProcess/com.apple.WebProcess.sb.in:

2013-04-22  Anders Carlsson  <andersca@apple.com>

        Don't kill our XPC services in response to memory pressure
        https://bugs.webkit.org/show_bug.cgi?id=114985
        <rdar://problem/13229217>

        Reviewed by Mark Rowe.

        * Shared/EntryPointUtilities/mac/XPCService/XPCServiceEntryPoint.h:
        (WebKit::XPCServiceInitializer):
        Call xpc_transaction_begin() so we'll never be killed by the kernel when there's memory pressure;
        we prefer to manage our own lifetime thank you very much!

        * Shared/mac/ChildProcessMac.mm:
        (WebKit::ChildProcess::platformInitialize):
        Remove call to disable sudden termination.

2013-04-22  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13681842> [Mac] Tweak WebProcess sandbox profile to use
        system-graphics function when available.

        Reviewed by Sam Weinig.

        * WebProcess/com.apple.WebProcess.sb.in:

2013-04-22  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Set up libPlatform.la
        https://bugs.webkit.org/show_bug.cgi?id=114168

        Reviewed by Martin Robinson.

        * GNUmakefile.am: Add the new libPlatform.la library to the libwebkitgtk library. Link the WebKitPluginProcess
        executable against libPlatform.la as well.

2013-04-22  Sam Weinig  <sam@webkit.org>

        Hard code plug-in sandbox profile lookup directories and move
        the profiles to WebKit2.

        Reviewed by Anders Carlsson.

        * PluginProcess/EntryPoint/mac/LegacyProcess/PluginProcessMain.mm:
        (WebKit::PluginProcessMainDelegate::getExtraInitializationData):
        * PluginProcess/EntryPoint/mac/XPCService/PluginServiceEntryPoint.mm:
        (WebKit::PluginServiceInitializerDelegate::getExtraInitializationData):
        * UIProcess/Plugins/mac/PluginProcessProxyMac.mm:
        (WebKit::PluginProcessProxy::platformGetLaunchOptions):
        Stop passing the sandbox-profile-directory-path to the plug-in process.

        * PluginProcess/mac/PluginProcessMac.mm:
        (WebKit::loadSandboxProfileForDirectory):
        (WebKit::loadSandboxProfile):
        (WebKit::PluginProcess::initializeSandbox):
        Hard code the plug-in sandbox profile lookup to only look in the WebKit2 bundle
        and /System/Library/Sandbox/Profiles/.

        * Resources/PlugInSandboxProfiles: Added.
        Add profiles.

        * WebKit2.xcodeproj/project.pbxproj:
        Copy the profiles to the bundle.

2013-04-15  Jer Noble  <jer.noble@apple.com>

        Refactor creation of the full screen window into an (overridable) method.
        https://bugs.webkit.org/show_bug.cgi?id=110369

        Reviewed by Eric Carlson.

        Add a new WKView method -(NSWindow)createFullScreenWindow which can be overridden
        by subclasses to provide custom full screen windows to the WKFullScreenWindowController.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView fullScreenWindowController]):
        (-[WKView createFullScreenWindow]):
        * UIProcess/API/mac/WKViewPrivate.h:
        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController initWithWindow:]):

2013-04-22  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Add webkit_web_context_set_disk_cache_directory to WebKit2 GTK+ API
        https://bugs.webkit.org/show_bug.cgi?id=111848

        Reviewed by Anders Carlsson.

        This allow applications to set a custom directory for the disk
        cache.

        * UIProcess/API/gtk/WebKitWebContext.cpp:
        (webkit_web_context_set_disk_cache_directory):
        * UIProcess/API/gtk/WebKitWebContext.h:
        * UIProcess/API/gtk/docs/webkit2gtk-sections.txt: Add new symbol.
        * UIProcess/API/gtk/tests/TestMain.cpp:
        (removeNonEmptyDirectory):
        (main): Use a different temporary disk cache directory for every
        test.

2013-04-22  Carlos Garcia Campos  <cgarcia@igalia.com>

        [SOUP] Soup disk cache should respect the diskCacheDirectory from the process initial parameters
        https://bugs.webkit.org/show_bug.cgi?id=111845

        Reviewed by Anders Carlsson.

        Move the cache initialization to platformInitializeWebProcess() to
        create the cache using the directory received from the UI
        process. This allows to add public API to set a different disk
        cache directory from the UI process.

        * UIProcess/efl/WebContextEfl.cpp:
        (WebKit::WebContext::platformDefaultDiskCacheDirectory): Return
        default disk cache directory.
        * UIProcess/gtk/WebContextGtk.cpp:
        (WebKit::WebContext::platformDefaultDiskCacheDirectory): Ditto.
        * WebProcess/efl/WebProcessMainEfl.cpp:
        (WebKit::WebProcessMainEfl): Remove soup cache initialization.
        * WebProcess/gtk/WebProcessMainGtk.cpp:
        (WebKit::WebProcessMainGtk): Ditto.
        * WebProcess/soup/WebProcessSoup.cpp:
        (WebKit::WebProcess::platformInitializeWebProcess): Initialize
        soup cache.

2013-04-22  Krzysztof Wolanski  <k.wolanski@samsung.com>:

        [WK2] Fix build warning when GESTURE_EVENTS is ON.
        https://bugs.webkit.org/show_bug.cgi?id=114812

        Reviewed by Andreas Kling.

        Handle GestureSingleTap in the event type switch.

        * WebProcess/Plugins/Netscape/x11/NetscapePluginX11.cpp:
        (WebKit::NetscapePlugin::platformHandleMouseEvent):

2013-04-21  Carlos Garcia Campos  <cgarcia@igalia.com>

        [WebKit2] Plugins without a MIME Type fail to load
        https://bugs.webkit.org/show_bug.cgi?id=112834

        Reviewed by Benjamin Poulain.

        The problem is that when the plugin is created and the MIME Type
        is empty, since the MIME Type guessed in the UI process using the
        plugin extension is not passed to the WebProcess, when the plugin
        is instantiated, the value of NPMIMEType parameter passed to
        NPP_New is NULL, and NPERR_INVALID_INSTANCE_ERROR is returned.
        GetPluginPath message has been renamed to FindPlugin, since it
        doesn't only return the path but also the new MIME Type and load
        policy.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::findPlugin): Receive an output newMIMEType
        parameter that is passed to PluginModuleInfo::findPlugin() so that
        in case of guessing the MIME Type, the new one is passed back to
        the WebProcess.
        * UIProcess/WebPageProxy.h:
        (WebPageProxy):
        * UIProcess/WebPageProxy.messages.in:
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::createPlugin): Pass the MIME Type
        from the parameters to WebPage::createPlugin.
        (WebKit::WebFrameLoaderClient::recreatePlugin): Pass a newMIMEType
        parameter to WebPage::createPlugin.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::createPlugin): Add newMIMEType out parameter and
        pass it to the FindPlugin message.
        (WebKit::WebPage::canPluginHandleResponse): Pass newMIMEType to
        FindPlugin message.
        * WebProcess/WebPage/WebPage.h:
        (WebPage):

2013-04-21  Carlos Garcia Campos  <cgarcia@igalia.com>

        Widget should not depend on AXObjectCache
        https://bugs.webkit.org/show_bug.cgi?id=114514

        Reviewed by Chris Fleizach.

        Update to API changes.

        * WebProcess/Plugins/PDF/PDFPlugin.mm:
        (WebKit::PDFPlugin::createScrollbar):
        * WebProcess/Plugins/PDF/SimplePDFPlugin.mm:
        (WebKit::SimplePDFPlugin::createScrollbar):
        (WebKit::SimplePDFPlugin::destroyScrollbar):

2013-04-20  Manuel Rego Casasnovas  <rego@igalia.com>

        [GTK] Fix unit test webkit2/WebKitFindController/hide
        https://bugs.webkit.org/show_bug.cgi?id=89810

        Reviewed by Carlos Garcia Campos.

        The test had some hacks in order to compare a page with highlighted
        results after using the find command with the original page. Now it uses
        the snapshots API that allows to make the test simpler and more
        reliable.

        * UIProcess/API/gtk/tests/TestMain.h:
        (Test::cairoSurfacesEqual): Moved helper function to compare two cairo
        surfaces from TestWebKitWebView.
        (Test):
        * UIProcess/API/gtk/tests/TestWebKitFindController.cpp:
        (testFindControllerHide): Modify test to use snapshots.
        * UIProcess/API/gtk/tests/TestWebKitWebView.cpp:
        (testWebViewSnapshot): Move basic snapshop methods to WebViewTest to
        share them with TestWebKitFindController test.
        * UIProcess/API/gtk/tests/WebViewTest.cpp:
        (WebViewTest::WebViewTest): Initialize cairo surface.
        (WebViewTest::~WebViewTest): Destroy cairo surface.
        (onSnapshotReady): Callback to set the cairo surface when the snapshot
        is ready.
        (WebViewTest::getSnapshotAndWaitUntilReady): Method that takes a
        snapshot and returns the cairo surface when it is ready.
        * UIProcess/API/gtk/tests/WebViewTest.h: Add new method headers and
        attribute for the cairo surface.

2013-04-19  Jer Noble  <jer.noble@apple.com>

        Unreviewed, revert r148782. It was not reviewed by a WebKit2 owner.

        * PluginProcess/mac/PluginProcessShim.mm:
        * Shared/mac/CookieStorageShim.cpp: Removed.
        * Shared/mac/CookieStorageShim.h: Removed.
        * Shared/mac/CookieStorageShimLibrary.cpp: Removed.
        * Shared/mac/CookieStorageShimLibrary.h: Removed.
        * Shared/mac/DYLDInterpose.h: Removed.
        * UIProcess/Launcher/mac/ProcessLauncherMac.mm:
        (WebKit::addDYLDEnvironmentAdditions):
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/EntryPoint/mac/LegacyProcess/WebContentProcessMain.mm:
        (WebKit::WebContentProcessMainDelegate::doPreInitializationWork):
        * WebProcess/EntryPoint/mac/XPCService/WebContentService/Info.plist:
        * WebProcess/EntryPoint/mac/XPCService/WebContentServiceEntryPoint.mm:
        (WebContentServiceInitializer):
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::initializeWebProcess):
        * WebProcess/mac/SecItemShimLibrary.mm:
        * WebProcess/EntryPoint/mac/XPCService/WebContentService.Development/Info.plist:
        * WebProcess/EntryPoint/mac/XPCService/WebContentService/Info.plist:


2013-04-19  Jer Noble  <jer.noble@apple.com>

        WWDC session videos don’t play at developer.apple.com
        https://bugs.webkit.org/show_bug.cgi?id=114858

        Reviewed by Eric Carlson.

        AVFoundation uses CFNetwork to store and retrieve cookies from the global store.
        However, in the case where network access happens in the NetworkProcess, session
        cookies are stored in-memory, and are not accessable in the WebProcess. Until such
        a time as AVFoundation can provide an API which would allow us to provide cookies
        for a specific request, we will interpose the CFNetwork method which they use to
        retrieve the cookie string from the cookie store for their pending request.

        Duplicate the previous SecItemShim target to a new, WebProcessShim target. This
        target includes the SecItemShim functionality, but will add a new shim for cookie
        retrieval:
        * Shared/mac/CookieStorageShimLibrary.h: Added
        (CookieStorageShimCallbacks):
        * Shared/mac/CookieStorageShimLibrary.cpp: Added.
        (WebKit::ShimProtector::ShimProtector): A simple stack-based counter class.
        (WebKit::ShimProtector::~ShimProtector):
        (WebKit::ShimProtector::count):
        (WebKit::shimCFHTTPCookieStorageCopyRequestHeaderFieldsForURL): Interpose
            the CFNetwork call, and pass to the registered callback.
        (WebKit::WebKitCookieStorageShimInitialize): Register the callbacks.

        Add a helper singleton class which will talk to the shim through the 
        registered callbacks:
        * Shared/mac/CookieStorageShim.h: Added
        (WebKit::CookieStorageShim::CookieStorageShim):
        * Shared/mac/CookieStorageShim.cpp: Added.
        (WebKit::webKitCookieStorageCopyRequestHeaderFieldsForURL): Pass the request
            over to the NetworkProcess.
        (WebKit::CookieStorageShim::shared): Simple singleton.
        (WebKit::CookieStorageShim::initialize): Call the library initializer.

        Initialize the shim only when the WebProcess is delegating network loading
        to the NetworkProcess:
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::initializeWebProcess):

        Rename the WebProcess's shim from SecItemShim -> WebProcessShim:
        * UIProcess/Launcher/mac/ProcessLauncherMac.mm:
        (WebKit::addDYLDEnvironmentAdditions):
        * WebProcess/EntryPoint/mac/LegacyProcess/WebContentProcessMain.mm:
        (WebKit::WebContentProcessMainDelegate::doPreInitializationWork):
        * WebProcess/EntryPoint/mac/XPCService/WebContentService/Info.plist:
        * WebProcess/EntryPoint/mac/XPCService/WebContentServiceEntryPoint.mm:
        (WebContentServiceInitializer):

        As the DYLD_INTERPOSE macro is used in multiple files now, put it in its
        own header:
        * Shared/mac/DYLDInterpose.h: Added.
        * PluginProcess/mac/PluginProcessShim.mm:
        * WebProcess/mac/SecItemShimLibrary.mm:

        Add new files to the project:
        * WebKit2.xcodeproj/project.pbxproj:

2013-04-19  Brady Eidson  <beidson@apple.com>

        Add JoinExistingSession to the WebContext XPC.
        <rdar://problem/13541540> and https://bugs.webkit.org/show_bug.cgi?id=114882

        Reviewed by Sam Weinig.

        This fixes <keygen> and maybe other things.

        * WebProcess/EntryPoint/mac/XPCService/WebContentService.Development/Info.plist:
        * WebProcess/EntryPoint/mac/XPCService/WebContentService/Info.plist:

2013-04-19  Martin Robinson  <mrobinson@igalia.com>

        [GTK] JSCore.gir.in has a few problems
        https://bugs.webkit.org/show_bug.cgi?id=114710

        Reviewed by Philippe Normand.

        * GNUmakefile.am: Updated to reflect new location of JavaScriptCore gir file. Share the
        same autotools data task as the WebKit1 and JavaScriptCore gir installations.

2013-04-19  Noam Rosenthal  <noam@webkit.org>

        [Texmap] Implementation for pattern compositing
        https://bugs.webkit.org/show_bug.cgi?id=109588

        Reviewed by Allan Sandfeld Jensen.

        Serialize the two new properties from CoordinatedGraphicsLayer to CoordinatedGraphicsScene.

        * Shared/CoordinatedGraphics/CoordinatedGraphicsArgumentCoders.cpp:
        (CoreIPC::::encode):
        (CoreIPC::::decode):
            Encode/decode the new tiling properties.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::CoordinatedLayerTreeHost):
            Enable pattern compositing for coordinated graphics.
            This is needed since we don't want to enable pattern compositing for
            WebKit1 yet.

2013-04-18  Tim Horton  <timothy_horton@apple.com>

        PDFPlugin: Update PDFLayerController's scale factors earlier
        https://bugs.webkit.org/show_bug.cgi?id=114843

        Reviewed by Simon Fraser.

        Inform PDFLayerController of the initial page/device scale factors so that
        it renders at the correct scale the first time, instead of first rendering
        at 1x and then flashing to 2x (on 2x devices).

        * WebProcess/Plugins/PDF/PDFPlugin.mm:
        (WebKit::PDFPlugin::pdfDocumentDidLoad):

2013-04-18  Tim Horton  <timothy_horton@apple.com>

        PDFPlugin: Hook up the search-in-Spotlight menu item
        https://bugs.webkit.org/show_bug.cgi?id=114837
        <rdar://problem/13583591>

        Reviewed by Mark Rowe.

        * WebProcess/Plugins/PDF/PDFLayerControllerDetails.h:
        Add performSpotlightSearch: delegate callback.

        * WebProcess/Plugins/PDF/PDFPlugin.h:
        (WebKit::PDFPlugin::performSpotlightSearch):
        Add performSpotlightSearch() PDFPlugin method.

        * WebProcess/Plugins/PDF/PDFPlugin.mm:
        (-[WKPDFLayerControllerDelegate performSpotlightSearch:]): Hand the search string to PDFPlugin.
        (WebKit::PDFPlugin::performSpotlightSearch): Hand the search string to WebPageProxy.

2013-04-18  Anders Carlsson  <andersca@apple.com>

        Dispatch local storage events
        https://bugs.webkit.org/show_bug.cgi?id=114838

        Reviewed by Beth Dakin.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::StorageArea::dispatchEvents):
        Pass 0 as the storage area ID if the event originally comes from another process.

        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::dispatchLocalStorageEvent):
        Gather all the frames for which we want to dispatch events.

2013-04-18  Anders Carlsson  <andersca@apple.com>

        Use the page group id from the UI process as the local storage namespace ID
        https://bugs.webkit.org/show_bug.cgi?id=114836

        Reviewed by Beth Dakin.

        The WebCore PageGroup identifier is different across processes, so use the one given to us by the UI process.

        * WebProcess/Storage/StorageNamespaceImpl.cpp:
        (WebKit::StorageNamespaceImpl::createLocalStorageNamespace):
        * WebProcess/WebPage/WebPageGroupProxy.h:
        (WebKit::WebPageGroupProxy::corePageGroup):
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::webPageGroup):
        * WebProcess/WebProcess.h:

2013-04-18  Tim Horton  <timothy_horton@apple.com>

        Add a synchronous version of WKView endDeferringViewInWindowChanges
        https://bugs.webkit.org/show_bug.cgi?id=114780
        <rdar://problem/12821901>

        Reviewed by Simon Fraser.

        Add new WKView SPI, endDeferringViewInWindowChangesSync, which synchronously
        (though with a 250 ms timeout) does the work required to reparent a WKView
        without flashing white.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView beginDeferringViewInWindowChanges]):
        (-[WKView endDeferringViewInWindowChanges]):
        Make begin/endDeferringViewInWindowChanges not allow nested deferrals,
        as we don't need them, and they complicate synchronous-end a lot.

        (-[WKView endDeferringViewInWindowChangesSync]):
        Add a sync version of endDeferringViewInWindowChanges which waits
        for DidUpdateInWindowState.

        (-[WKView isDeferringViewInWindowChanges]):

        * UIProcess/API/mac/WKViewPrivate.h: Add endDeferringViewInWindowChangesSync.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::waitForDidUpdateInWindowState):
        Add waitForDidUpdateInWindowState(), which blocks for
        250ms or until the WebProcess reparents all of its layers and spins
        the runloop once, to prevent flashing when parenting a WKView.
        If we've already timed out waiting for the WebProcess, don't block, as
        it's probably quite busy and is likely to time out again.

        * UIProcess/WebPageProxy.h:
        (WebKit::WebPageProxy::isInWindow): Added.
        (WebKit::WebPageProxy::waitForDidUpdateInWindowState): Added.
        (WebKit::WebPageProxy::didUpdateInWindowState): Added.

        * UIProcess/WebPageProxy.messages.in: Add DidUpdateInWindowState()

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::didUpdateInWindowStateTimerFired): Send DidUpdateInWindowState to WebPageProxy.
        (WebKit::WebPage::setIsInWindow): When setIsInWindow completes, TileController
        tiles have been reparented, and the TiledCoreAnimationDrawingArea has
        reconnected the layer tree to the context, start a 0-delay runloop timer
        to allow painting and layer flushing to finish; when the timer fires,
        we'll send the UIProcess a DidUpdateInWindowState so it can stop blocking.

        * WebProcess/WebPage/WebPage.h:
        (WebPage): Add didUpdateInWindowStateTimerFired and m_sendDidUpdateInWindowStateTimer.

2013-04-18  Anders Carlsson  <andersca@apple.com>

        StorageManager should keep track of local storage namespaces
        https://bugs.webkit.org/show_bug.cgi?id=114831

        Reviewed by Beth Dakin.

        * UIProcess/Storage/StorageManager.cpp:
        (StorageManager::StorageArea):
        Add the local storage namespace, and security origin as member variables.

        (StorageManager::LocalStorageNamespace):
        New class that represents a local storage namespace.

        (WebKit::StorageManager::StorageArea::~StorageArea):
        If this storage area belongs to a local storage namespace, notify it that we've been destroyed.

        (WebKit::StorageManager::StorageArea::clone):
        Assert that we don't have a local storage namespace.

        (WebKit::StorageManager::LocalStorageNamespace::getOrCreateStorageArea):
        If we already have a storage area for the given security origin, return it. Otherwise, create a new storage area.
        Note that LocalStorageNamespace does not hold strong references to its StorageArea objects; they are being kept alive
        by a mapping inside the StorageManager.

        (WebKit::StorageManager::LocalStorageNamespace::didDestroyStorageArea):
        Remove the storage area from the map. If there are no more areas, remove the namespace from the manager.

        (WebKit::StorageManager::SessionStorageNamespace::getOrCreateStorageArea):
        StorageArea::create now takes the security origin.

        (WebKit::StorageManager::createLocalStorageMap):
        Get (or create) the right local storage namespace and then create a storage area.

2013-04-17  Geoffrey Garen  <ggaren@apple.com>

        Renamed JSGlobalData to VM
        https://bugs.webkit.org/show_bug.cgi?id=114777

        Reviewed by Phil Pizlo.

        * Shared/linux/WebMemorySamplerLinux.cpp:
        (WebKit::WebMemorySampler::sampleWebKit):
        * Shared/mac/WebMemorySampler.mac.mm:
        (WebKit::WebMemorySampler::sampleWebKit):
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::javaScriptObjectsCount):
        * WebProcess/Plugins/Netscape/JSNPMethod.cpp:
        (WebKit::JSNPMethod::finishCreation):
        * WebProcess/Plugins/Netscape/JSNPMethod.h:
        (WebKit::JSNPMethod::create):
        (JSNPMethod):
        (WebKit::JSNPMethod::createStructure):
        * WebProcess/Plugins/Netscape/JSNPObject.cpp:
        (WebKit::JSNPObject::JSNPObject):
        (WebKit::JSNPObject::finishCreation):
        (WebKit::JSNPObject::callMethod):
        (WebKit::JSNPObject::callObject):
        (WebKit::JSNPObject::callConstructor):
        (WebKit::JSNPObject::put):
        (WebKit::JSNPObject::deleteProperty):
        (WebKit::JSNPObject::getOwnPropertyNames):
        (WebKit::JSNPObject::propertyGetter):
        * WebProcess/Plugins/Netscape/JSNPObject.h:
        (WebKit::JSNPObject::create):
        (WebKit::JSNPObject::createStructure):
        * WebProcess/Plugins/Netscape/NPJSObject.cpp:
        (WebKit::NPJSObject::create):
        (WebKit::NPJSObject::initialize):
        * WebProcess/Plugins/Netscape/NPJSObject.h:
        (JSC):
        (NPJSObject):
        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.cpp:
        (WebKit::NPRuntimeObjectMap::getOrCreateNPObject):
        (WebKit::NPRuntimeObjectMap::convertJSValueToNPVariant):
        (WebKit::NPRuntimeObjectMap::evaluate):
        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.h:
        (JSC):
        (NPRuntimeObjectMap):
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::windowScriptNPObject):
        (WebKit::PluginView::pluginElementNPObject):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::runJavaScriptInMainFrame):
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::getWebCoreStatistics):

2013-04-18  Anders Carlsson  <andersca@apple.com>

        Differentiate between creating local storage maps and session storage maps
        https://bugs.webkit.org/show_bug.cgi?id=114823

        Reviewed by Beth Dakin.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::createLocalStorageMap):
        (WebKit::StorageManager::createSessionStorageMap):
        * UIProcess/Storage/StorageManager.h:
        * UIProcess/Storage/StorageManager.messages.in:
        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::StorageAreaMap):

2013-04-18  Anders Carlsson  <andersca@apple.com>

        StorageAreaMaps should not assume that a zero storage namespace ID is used for local storage
        https://bugs.webkit.org/show_bug.cgi?id=114822

        Reviewed by Beth Dakin.

        Store the storage type directly in the storage area map.

        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::StorageAreaMap):
        * WebProcess/Storage/StorageAreaMap.h:
        (WebKit::StorageAreaMap::storageType):

2013-04-18  Anders Carlsson  <andersca@apple.com>

        Begin fleshing out UI side local storage
        https://bugs.webkit.org/show_bug.cgi?id=114820

        Reviewed by Beth Dakin.

        * WebProcess/Storage/StorageNamespaceImpl.cpp:
        (WebKit::StorageNamespaceImpl::createLocalStorageNamespace):
        (WebKit::StorageNamespaceImpl::createSessionStorageNamespace):
        (WebKit::StorageNamespaceImpl::StorageNamespaceImpl):
        (WebKit::StorageNamespaceImpl::~StorageNamespaceImpl):
        * WebProcess/Storage/StorageNamespaceImpl.h:
        * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
        (WebKit::WebPlatformStrategies::localStorageNamespace):

2013-04-18  Sam Weinig  <sam@webkit.org>

        Fix spelling I thought I had fixed.

        * UIProcess/API/mac/WKBrowsingContextGroup.mm:
        (-[WKBrowsingContextGroup initWithIdentifier:]):

2013-04-18  Sam Weinig  <sam@webkit.org>

        WebKit should not write WKPreferences to app user defaults when using the ObjC API
        <rdar://problem/13593578>
        https://bugs.webkit.org/show_bug.cgi?id=114821

        Reviewed by Anders Carlsson.

        * UIProcess/API/mac/WKBrowsingContextGroup.mm:
        (-[WKBrowsingContextGroup initWithIdentifier:]):
        Use a identifier-less preferences for the ObjC-API. I think we will probably want this
        to be the default for the C-API at some point as well, but Safari currently uses this
        behavior.

2013-04-17  Anders Carlsson  <andersca@apple.com>

        Change storage factory functions to take a PageGroup and Page respectively
        https://bugs.webkit.org/show_bug.cgi?id=114776

        Reviewed by Beth Dakin.

        Update for WebCore changes.

        * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
        (WebKit::WebPlatformStrategies::localStorageNamespace):
        (WebKit::WebPlatformStrategies::sessionStorageNamespace):
        * WebProcess/WebCoreSupport/WebPlatformStrategies.h:
        (WebPlatformStrategies):

2013-04-18  Timothy Hatcher  <timothy@apple.com>

        Remove an ASSERT that is causing flakeyness in Debug builds.

        https://webkit.org/b/113020

        Reviewed by Jessie Berlin.

        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::WebInspectorProxy::open): Removed ASSERT(m_createdInspectorPage).

2013-04-18  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Add WebKitWebPage::send-request signal to WebKit2 GTK+ API
        https://bugs.webkit.org/show_bug.cgi?id=83681

        Reviewed by Anders Carlsson.

        Add WebKitWebPage::send-request signal emitted in willSendRequest
        callback to allow web process extensions to modify requests before
        they are sent or cancel the resource load.
        This patch makes WebKitURIRequest and WebKitURIResponse objects
        shareable between UI process and web extensions APIs. Since both
        APIs force single header includes, the WebKitDefines.h header has
        been split moving the forward declarations specific to the UI
        process API to a new file WebKitForwardDeclarations.h. This way we
        can also  share the WebKitDefines.h header and remove the
        WebKitWebExtensionDefines.h header used in the web extensions API.

        * GNUmakefile.list.am: Add new files to compilation.
        * UIProcess/API/gtk/WebKitContextMenu.h: Include WebKitForward.h.
        * UIProcess/API/gtk/WebKitContextMenuItem.h: Ditto.
        * UIProcess/API/gtk/WebKitDefines.h: Remove forward declarations.
        * UIProcess/API/gtk/WebKitDownload.h: Include WebKitForward.h.
        * UIProcess/API/gtk/WebKitFindController.h: Ditto.
        * UIProcess/API/gtk/WebKitForwardDeclarations.h: Added. Contains
        the forward declarations moved from WebKitDefines.h.
        * UIProcess/API/gtk/WebKitPrintOperation.h: Include WebKitForward.h.
        * UIProcess/API/gtk/WebKitURIRequest.cpp:
        (webkitURIRequestSetProperty): Use webkit_uri_request_set_uri() to
        set the new URI.
        (webkit_uri_request_class_init): Make URI property construct
        instead of construct-only, since it can be updated once
        constructed. It should never be NULL, so set default value to
        about:blank instad of NULL.
        (webkit_uri_request_set_uri): New public method to set the URI of
        the WebKitURIRequest.
        * UIProcess/API/gtk/WebKitURIRequest.h: Allow to include this file
        from webkit-web-extension.h.
        * UIProcess/API/gtk/WebKitURIResponse.h: Ditto.
        * UIProcess/API/gtk/WebKitURISchemeRequest.h: Include
        WebKitForward.h.
        * UIProcess/API/gtk/WebKitWebView.h: Ditto.
        * UIProcess/API/gtk/docs/webkit2gtk-sections.txt: Add
        webkit_uri_request_set_uri.
        * UIProcess/API/gtk/tests/TestResources.cpp:
        (testWebResourceSendRequest):
        (serverCallback):
        (beforeAll):
        * UIProcess/API/gtk/tests/WebExtensionTest.cpp:
        (sendRequestCallback):
        (pageCreatedCallback):
        * UIProcess/API/gtk/webkit2marshal.list:
        * WebProcess/InjectedBundle/API/gtk/WebKitWebExtension.h: Include
        WebKitDefines.h instead of WebKitWebExtensionDefines.h.
        * WebProcess/InjectedBundle/API/gtk/WebKitWebPage.cpp:
        (willSendRequestForFrame): Emit WebKitWebPage::send-request and
        return early if the load is cancelled.
        (webkit_web_page_class_init): Add WebKitWebPage::send-request
        signal.
        * WebProcess/InjectedBundle/API/gtk/WebKitWebPage.h: Include
        WebKitDefines.h instead of WebKitWebExtensionDefines.h.
        * WebProcess/InjectedBundle/API/gtk/webkit-web-extension.h:

2013-04-18  Bruno de Oliveira Abinader  <bruno.abinader@basyskom.com>

        [WK2] CoordinatedGraphicsLayerState is a struct, not a class
        https://bugs.webkit.org/show_bug.cgi?id=108855

        Reviewed by Andreas Kling.

        Fixes the forward declaration which takes CoordinatedGraphicsLayerState
        as a class.

        * UIProcess/CoordinatedGraphics/CoordinatedLayerTreeHostProxy.h:
        (WebCore):

2013-04-18  Krzysztof Wolanski  <k.wolanski@samsung.com>:

        [EFL][WK2] Change inadequate return value in method setDone().
        https://bugs.webkit.org/show_bug.cgi?id=114806

        Reviewed by Andreas Kling.

        Fix possible warning in EFL port: no return statement in function returning non-void.
        Change return value from bool to void in method setDone().

        * UIProcess/API/efl/tests/UnitTestUtils/EWK2UnitTestBase.cpp:
        (EWK2UnitTest::CallbackDataTimer::setDone):

2013-04-18  Grzegorz Czajkowski  <g.czajkowski@samsung.com>

        [WK2][EFL] Text Checker's settings refactor
        https://bugs.webkit.org/show_bug.cgi?id=111713

        Reviewed by Andreas Kling.

        Use WK2's TextCheckerState object as the store for the text checker settings.
        It's shared between the client (Ewk API part) and WebProcess (read only).
        Thanks to it, we don't have to keep any additional structure with
        the settings on ewk side.

        In the consistency with WKTextChecker C API, move the Ewk's text checker settings APIs
        to the ewk_text_checker.h/cpp. They're not connected to Ewk_View/Ewk_Settings object to
        keep them in ewk_setting.h/cpp.

        Introduce a new class to implement WKTextCheckerClient callbacks to call spelling
        methods through WK2 C API.
        The main purpose of this change is to detach text checker initialization from ewk_context.

        * PlatformEfl.cmake:
        Add a new files to the build.

        * UIProcess/API/efl/ewk_context.cpp:
        (EwkContext::EwkContext):
        Detach the text checker initialization from context.
        There might be more than default context.
        There is one text checker object per application.

        * UIProcess/API/efl/ewk_settings.cpp:
        * UIProcess/API/efl/ewk_settings.h:
        Remove the text checker settings.

        * UIProcess/API/efl/ewk_text_checker.cpp:
        Add the text checker settings to the ewk_text_checker.h/cpp

        (convertLanguagesToEinaList):
        Add helper function to convert Vector's values to Eina_List.

        (clientCallbacks):
        Add the client callback responsible for the continuous spell checking
        setting change to the struct.

        (ewk_text_checker_continuous_spell_checking_enabled_set):
        Do not call the client's callback responsible for the setting
        change unless WebKit changes the setting (trough the context
        'Check Spelling While Typing' option).

        * UIProcess/API/efl/ewk_text_checker.h:
        Adjust APIs name to the ewk_text_checker syntax.
        Update the documentation according to the changes.

        * UIProcess/API/efl/ewk_text_checker_private.h:
        (ClientCallbacks):
        Move ClientCallbacks structure to TextCheckerClientEfl.
        The client callbacks (Ewk API) have to be accessible in WKTextCheckerClient callbacks
        to choose what implementation will be used - the client's (if definied) or Enchant impl.

        * UIProcess/API/efl/tests/test_ewk2_text_checker.cpp:
        Update the unit tests according to the APIs change.
        Update the test responsible for the notification about the setting change
        according to changes in 'ewk_text_checker_continuous_spell_checking_enabled_set'.

        * UIProcess/efl/TextCheckerClientEfl.cpp: Added.
        Implement WKTextCheckerClient callbacks.

        (TextCheckerClientEfl::TextCheckerClientEfl):
        (TextCheckerClientEfl::instance):
        Allow to get and create TextCheckerClientEfl object.

        (TextCheckerClientEfl::isContinuousSpellCheckingEnabled):
        Get the setting value based on WK2 C API.

        (TextCheckerClientEfl::ensureSpellCheckingLanguage):
        Load the default languages if user didn't specify any.

        (TextCheckerClientEfl::updateSpellCheckingLanguages):
        (TextCheckerClientEfl::languagesUpdateTimerFired):
        (TextCheckerClientEfl::availableSpellCheckingLanguages):
        (TextCheckerClientEfl::loadedSpellCheckingLanguages):
        (TextCheckerClientEfl::availableSpellCheckingLanguages):
        (TextCheckerClientEfl::loadedSpellCheckingLanguages):
        Provide support for languages.

        (TextCheckerClientEfl::spellCheckingSettingChangeTimerFired):
        (TextCheckerClientEfl::callContinuousSpellCheckingChangeCallbackAsync):
        Notify the client about the setting change.

        (TextCheckerClientEfl::isContinuousSpellCheckingEnabledCallback):
        (TextCheckerClientEfl::setContinuousSpellCheckingEnabledCallback):
        (TextCheckerClientEfl::uniqueSpellDocumentTagCallback):
        (TextCheckerClientEfl::closeSpellDocumentWithTagCallback):
        (TextCheckerClientEfl::checkSpellingOfStringCallback):
        (TextCheckerClientEfl::guessesForWordCallback):
        (TextCheckerClientEfl::learnWordCallback):
        (TextCheckerClientEfl::ignoreWordCallback):
        WKTextCheckerClient callbacks implementation.

        * UIProcess/efl/TextCheckerClientEfl.h: Added.
        (TextCheckerClientEfl):
        (TextCheckerClientEfl::clientCallbacks):
        Return the client callbacks to be used in ewk_text_checker.cpp.

        * UIProcess/efl/TextCheckerEfl.cpp:
        (WebKit::TextChecker::state):
        Initialize the TextCheckerState's members to false.

        (WebKit::TextChecker::setContinuousSpellCheckingEnabled):
        Set the default language if user didn't specify any.
        Notify the client about the setting change.
        This method is called when context menu 'Check Spelling While Typing'
        option has been toggled.

        (WebKit::TextChecker::continuousSpellCheckingEnabledStateChanged):
        Set the default language if user didn't specify any.
        Called by WKTextChecker's API.

2013-04-18  Manuel Rego Casasnovas  <rego@igalia.com>

        [GTK][WK2] Add WebKitWebPage::webkit_web_page_get_uri to WebKit2 GTK+ API
        https://bugs.webkit.org/show_bug.cgi?id=111288

        Reviewed by Anders Carlsson.

        Add new property URI to WebKitWebPage providing a method
        webkit_web_page_get_uri to get it and the signal "notify::uri" to
        monitor changes in the URI.

        * UIProcess/API/gtk/docs/webkit2gtk-sections.txt: Include new method in
        GTK+ doc.
        * UIProcess/API/gtk/tests/TestLoaderClient.cpp:
        (testWebPageURI):
        (beforeAll):
        (afterAll): Add test to check that WebKitWebPage URI matches with
        WebKitWebView value. The tests is listening for changes in WebKitWebPage
        URI via D-Bus and checks that value is the same than WebKitWebView URI.
        It also checks that the order of the URIs in a redirection is right.
        When the test finishes the signals are disconnected properly.
        * UIProcess/API/gtk/tests/WebExtensionTest.cpp:
        (uriChangedCallback):
        (pageCreatedCallback): Add new D-Bus signal "URIChanged" connected to
        "notify::uri" signal of WebKitWebPage.
        * UIProcess/API/gtk/tests/WebKitTestBus.cpp:
        (WebKitTestBus::getOrCreateConnection): Rename method connection() to
        getOrCreateConnection().
        (WebKitTestBus::createProxy): Use the new method name.
        * UIProcess/API/gtk/tests/WebKitTestBus.h:
        (WebKitTestBus::connection): Add public getter for m_connection.
        (WebKitTestBus): Add private method header getOrCreateConnection().
        * WebProcess/InjectedBundle/API/gtk/WebKitWebPage.cpp:
        (_WebKitWebPagePrivate): Add new URI attribute.
        (webkitWebPageSetURI): Method to set the URI and emit the "notify:uri"
        signal if it has changed.
        (didStartProvisionalLoadForFrame): At this point it use the unreachable
        URL from provisional document loader if any. Otherwise, it uses the URL
        from provisional document loader.
        (didReceiveServerRedirectForProvisionalLoadForFrame): In the case of
        redirections it works like for didStartProvisionalLoadForFrame getting
        the unreachable URL if any.
        (didSameDocumentNavigationForFrame): In this case it gets the URL from
        the document loader.
        (webkitWebPageGetProperty): Add code related to URI property.
        (webkit_web_page_class_init): Add bits related to URI property.
        (webkitWebPageCreate): Implement callbacks to monitor URI changes.
        (webkit_web_page_get_uri): Return URI attribute.
        * WebProcess/InjectedBundle/API/gtk/WebKitWebPage.h: Add new method
        header.

2013-04-18  Xan Lopez  <xan@igalia.com>

        [GTK] When the WebProcess crashes, a signal should be emitted
        https://bugs.webkit.org/show_bug.cgi?id=105180

        Emit a "web-process-crashed" signal when the WebProcess crashes. This
        is useful, for example, to show an error page in a web browser
        like Chrome does.

        Reviewed Carlos Garcia Campos.

        * UIProcess/API/gtk/WebKitLoaderClient.cpp:
        (processDidCrash):
        (attachLoaderClientToView):
        * UIProcess/API/gtk/WebKitWebContextPrivate.h:
        * UIProcess/API/gtk/WebKitWebView.cpp:
        (webkit_web_view_class_init):
        (webkitWebViewWebProcessCrashed):
        * UIProcess/API/gtk/tests/TestWebExtensions.cpp:
        (testWebExtensionGetTitle):
        (webProcessCrashedCallback):
        (testWebKitWebViewProcessCrashed):
        (beforeAll):
        * UIProcess/API/gtk/tests/WebExtensionTest.cpp:
        (methodCallCallback):

2013-04-18  Kenneth Rohde Christiansen  <kenneth@webkit.org>

        [EFL][WK2] Add tooltip API to the WKView client
        https://bugs.webkit.org/show_bug.cgi?id=111563

        Reviewed by Andreas Kling.

        Add tooltip to the barebone Tizen C API, and implement
        the method so that the EFL API keeps working.

        * UIProcess/API/C/efl/WKView.h:
        * UIProcess/efl/ViewClientEfl.cpp:
        (WebKit::ViewClientEfl::didChangeTooltip):
        (WebKit):
        (WebKit::ViewClientEfl::ViewClientEfl):
        * UIProcess/efl/ViewClientEfl.h:
        (ViewClientEfl):
        * UIProcess/efl/WebView.cpp:
        (WebKit::WebView::toolTipChanged):
        * UIProcess/efl/WebViewClient.cpp:
        (WebKit::WebViewClient::didChangeTooltip):
        (WebKit):
        * UIProcess/efl/WebViewClient.h:

2013-04-17  Joone Hur  <joone.hur@intel.com>

        [EFL][AC] m_pendingSurfaceResize needs to be guarded by USE(ACCELERATED_COMPOSITING)
        https://bugs.webkit.org/show_bug.cgi?id=114770

        AC related code is guarded by USE(ACCELERATED_COMPOSITING) in order to build 
        WebKitEfl with no-tiled-backing-store(r147792), but m_pendingSurfaceResize is 
        not included. This patch allows m_pendingSurfaceResize to be guarded by 
        USE(ACCELERATED_COMPOSITING). 

        Reviewed by Simon Fraser.

        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::EwkView):
        (EwkView::displayTimerFired):
        (EwkView::handleEvasObjectCalculate):
        * UIProcess/API/efl/EwkView.h:
        (EwkView):

2013-04-17  Anders Carlsson  <andersca@apple.com>

        The storage manager should know the local storage directory
        https://bugs.webkit.org/show_bug.cgi?id=114765

        Reviewed by Beth Dakin.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::create):
        (WebKit::StorageManager::setLocalStorageDirectory):
        (WebKit::StorageManager::setLocalStorageDirectoryInternal):
        * UIProcess/Storage/StorageManager.h:
        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::WebContext):
        (WebKit::WebContext::setLocalStorageDirectory):
        * UIProcess/WebContext.h:

2013-04-17  Joone Hur  <joone.hur@intel.com>

        [EFL][AC] MiniBrowser starts with a black empty view before painting a web page
        https://bugs.webkit.org/show_bug.cgi?id=103745

        Reviewed by Kenneth Rohde Christiansen.

        Evas paints empty evas objects before rendering a web page, so it shows 
        a black empty view for a moment. This patch prevents from painting the empty 
        evas objects until a GL surface is ready for rendering.  

        * UIProcess/API/efl/EwkView.cpp:
        (showEvasObjectsIfNeeded):
        (EwkView::displayTimerFired):
        (EwkView::handleEvasObjectShow):

2013-04-16  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Add webkit_web_page_get_id() to WebKit2 GTK+ API
        https://bugs.webkit.org/show_bug.cgi?id=111938

        Reviewed by Anders Carlsson.

        Add API to the web extensions API to get the identifier of a web
        page.

        * UIProcess/API/gtk/docs/webkit2gtk-sections.txt: Add new symbol.
        * UIProcess/API/gtk/tests/WebExtensionTest.cpp:
        (methodCallCallback): Check the page ID matches the one returned
        by webkit_web_page_get_id().
        * WebProcess/InjectedBundle/API/gtk/WebKitWebPage.cpp:
        (webkit_web_page_get_id):
        * WebProcess/InjectedBundle/API/gtk/WebKitWebPage.h:

2013-04-16  Anders Carlsson  <andersca@apple.com>

        Clone storage namespaces for window.open
        https://bugs.webkit.org/show_bug.cgi?id=114703

        Reviewed by Sam Weinig.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::StorageArea::clone):
        New helper function for cloning a storage area.

        (WebKit::StorageManager::StorageArea::setItem):
        Correctly handle the copy-on-write feature of StorageMap if it has multiple storage areas pointing to it.

        (WebKit::StorageManager::StorageArea::removeItem):
        Ditto.

        (WebKit::StorageManager::SessionStorageNamespace::cloneTo):
        Add cloned storage areas.

        * WebProcess/Storage/StorageNamespaceImpl.cpp:
        (WebKit::StorageNamespaceImpl::copy):
        Create a new session storage namespace for the new page.

2013-04-16  Beth Dakin  <bdakin@apple.com>

        Need a new layout milestone to notify bundle clients when the header has been 
        flushed
        https://bugs.webkit.org/show_bug.cgi?id=114706
        -and corresponding-
        <rdar://problem/13657284>

        Reviewed by Simon Fraser.

        Make this new LayoutMilestone private at the API layer. 
        * Shared/API/c/WKPageLoadTypes.h:
        * Shared/API/c/WKPageLoadTypesPrivate.h: Added.

        Handle the new milestone.
        * Shared/API/c/WKSharedAPICast.h:
        (WebKit::toWKLayoutMilestones):
        (WebKit::toLayoutMilestones):

        New file to make the milestone private.
        * WebKit2.xcodeproj/project.pbxproj:

        Add or remove the DidFirstFlushForHeaderLayer millstone based on whether we just 
        added or removed a header.
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::setHeaderLayerWithHeight):

2013-04-16  Ryosuke Niwa  <rniwa@webkit.org>

        Another EFL build fix.

        * WebProcess/WebPage/efl/WebPageEfl.cpp:

2013-04-15  Sam Weinig  <sam@webkit.org>

        Remove more #includes from Frame.h
        https://bugs.webkit.org/show_bug.cgi?id=114642

        Reviewed by Anders Carlsson.

        * WebProcess/InjectedBundle/InjectedBundleNavigationAction.cpp:
        * WebProcess/Plugins/PluginView.cpp:
        * WebProcess/WebPage/WebFrame.cpp:
        * WebProcess/WebPage/gtk/WebPageGtk.cpp:
        * WebProcess/WebPage/mac/WebPageMac.mm:
        * WebProcess/WebPage/qt/WebPageQt.cpp:

2013-04-16  Timothy Hatcher  <timothy@apple.com>

        Make resizing the docked Web Inspector stay in sync with the inspected view.

        https://webkit.org/b/114682

        Reviewed by Joseph Pecoraro.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::inspectedViewFrameDidChange):
        Disable screen updates to make sure the layers for both views resize in sync.

2013-04-15  Anders Carlsson  <andersca@apple.com>

        Remove unneeded headers from ScriptExecutionContext.h
        https://bugs.webkit.org/show_bug.cgi?id=114631

        Reviewed by Alexey Proskuryakov.

        * WebProcess/InjectedBundle/API/c/WKBundlePage.cpp:
        * WebProcess/WebPage/PageOverlay.cpp:

2013-04-16  Maciej Stachowiak  <mjs@apple.com>

        Remove even yet still more traces of v8
        https://bugs.webkit.org/show_bug.cgi?id=114693

        Reviewed by Anders Carlsson.

        * Scripts/generate-forwarding-headers.pl: Remove v8 from list of platforms.

2013-04-16  Alexey Proskuryakov  <ap@apple.com>

        Remove unused AlternativeTextClient::dismissDictationAlternativeUI
        https://bugs.webkit.org/show_bug.cgi?id=114598

        Reviewed by Ryosuke Niwa.

        * UIProcess/API/mac/PageClientImpl.h:
        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::dictationAlternatives):
        * UIProcess/PageClient.h:
        * UIProcess/WebPageProxy.cpp:
        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.messages.in:
        * WebProcess/WebCoreSupport/WebAlternativeTextClient.h:
        * WebProcess/WebCoreSupport/mac/WebAlternativeTextClient.cpp:

2013-04-16  Claudio Saavedra  <csaavedra@igalia.com>

        [GTK][WK2] Add API to retrieve a snapshot from a webview
        https://bugs.webkit.org/show_bug.cgi?id=98270

        Reviewed by Anders Carlsson.

        This adds the GTK+ API necessary to retrieve a snapshot from a
        webview asynchronously. The API uses the injected bundle
        internally to get the snapshot from the WebProcess.

        * UIProcess/API/gtk/WebKitError.cpp:
        (webkit_snapshot_error_quark): Add snapshot API related error
        quark.
        * UIProcess/API/gtk/WebKitError.h: Add snapshot error handling.
        * UIProcess/API/gtk/WebKitInjectedBundleClient.cpp:
        (didReceiveWebViewMessageFromInjectedBundle): Handle the new
        "DidGetSnapshot" message.
        * UIProcess/API/gtk/WebKitPrivate.h: Add SnapshotRegion enum.
        * UIProcess/API/gtk/WebKitWebView.cpp:
        (_WebKitWebViewPrivate): Add a map for the snapshot results.
        (GetSnapshotAsyncData):
        (webKitWebViewDidReceiveSnapshot):
        (webKitSnapshotRegionToSnapshotRegion): Helper method for casting
        the region option enumeration.
        (generateSnapshotCallbackID): Method to generate unique callback
        ids.
        (webkit_web_view_get_snapshot):
        (webkit_web_view_get_snapshot_finish): New snapshotting API.
        * UIProcess/API/gtk/WebKitWebView.h: Ditto.
        * UIProcess/API/gtk/WebKitWebViewPrivate.h: Add the private method
        to handle a received snapshot.
        * UIProcess/API/gtk/docs/webkit2gtk-sections.txt: Add the new API
        bits.
        * UIProcess/API/gtk/tests/TestWebKitWebView.cpp:
        (cairoSurfacesEqual): Add helper to compare cairo_surface_t
        structs.
        (testWebViewSnapshot): New test.
        (beforeAll): Add the new test.
        * UIProcess/API/gtk/tests/WebViewTest.cpp:
        (WebViewTest::selectAll): Add method to help test snapshots
        including selection.
        * UIProcess/API/gtk/tests/WebViewTest.h: Ditto
        * WebProcess/InjectedBundle/API/gtk/WebKitWebExtension.cpp:
        (didReceiveMessageToPage): Ditto.
        (webkitWebExtensionCreate): Register method above.
        * WebProcess/InjectedBundle/API/gtk/WebKitWebPage.cpp:
        (webkitWebPageDidReceiveMessage): Add this method. It
        handles the new message "GetSnapshot".
        * WebProcess/InjectedBundle/API/gtk/WebKitWebPagePrivate.h:
        Add method above.

2013-04-16  Timothy Hatcher  <timothy@apple.com>

        Create full rects for the inspector and inspected views when
        adjusting to an inspected view frame change. 

        This ensures switching dock sides restores the inspected view
        and inspector to fill the parent's bounds.

        https://webkit.org/b/114666
        rdar://problem/13660796

        Reviewed by Joseph Pecoraro.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::inspectedViewFrameDidChange):

2013-04-16  Balazs Kelemen  <kbalazs@webkit.org>

        Initialize logging channels for web processes
        https://bugs.webkit.org/show_bug.cgi?id=114621

        Reviewed by Sam Weinig.

        Use InitializeWebKit2 for initializing the web and plugin processes.
        It handles initializing the logging channels and it's better to have
        shared core for this. For the plugin process now we always create
        a RunLoop object which is not necessary with the -scanPlugin argument
        but it shouldn't be a problem.

        * PluginProcess/qt/PluginProcessMainQt.cpp:
        (WebKit::PluginProcessMain):
        * PluginProcess/unix/PluginProcessMainUnix.cpp:
        (WebKit::PluginProcessMainUnix):
        * WebProcess/efl/WebProcessMainEfl.cpp:
        (WebKit::WebProcessMainEfl):
        * WebProcess/gtk/WebProcessMainGtk.cpp:
        (WebKit::WebProcessMainGtk):
        * WebProcess/qt/WebProcessMainQt.cpp:
        (WebKit::WebProcessMainQt):

2013-04-16  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFL][WK2] Add an API for getting context menu item's parent menu
        https://bugs.webkit.org/show_bug.cgi?id=107510

        Reviewed by Kenneth Rohde Christiansen.

        Added parent menu support and API for Ewk_Context_Menu_Item, to
        allow selecting context menus using Elementary widgets.
        Context menu unit test updated with new function. 

        * UIProcess/API/efl/ewk_context_menu.cpp:
        (EwkContextMenu::EwkContextMenu):
        * UIProcess/API/efl/ewk_context_menu_item.cpp:
        (EwkContextMenuItem::EwkContextMenuItem):
        (ewk_context_menu_item_parent_menu_get):
        * UIProcess/API/efl/ewk_context_menu_item.h:
        * UIProcess/API/efl/ewk_context_menu_item_private.h:
        (EwkContextMenuItem::create):
        (EwkContextMenuItem::parentMenu):
        (EwkContextMenuItem::setParentMenu):
        (EwkContextMenuItem):
        * UIProcess/API/efl/tests/test_ewk2_context_menu.cpp:
        (showContextMenu):

2013-04-16  Andreas Kling  <akling@apple.com>

        Fix release builds with !LOG_DISABLED.

        * Platform/mac/Logging.mac.mm:

2013-04-16  Manuel Rego Casasnovas  <rego@igalia.com>

        [GTK][EFL] Remove deprecated libsoup API usage
        https://bugs.webkit.org/show_bug.cgi?id=104894

        Reviewed by Philippe Normand.

        Remove LIBSOUP_USE_UNSTABLE_REQUEST_API and only include
        libsoup/soup.h.

        * WebProcess/Cookies/soup/WebKitSoupCookieJarSqlite.h:
        * WebProcess/efl/WebProcessMainEfl.cpp:
        * WebProcess/gtk/WebProcessMainGtk.cpp:
        * WebProcess/soup/WebKitSoupRequestGeneric.h:
        * WebProcess/soup/WebProcessSoup.cpp:
        * WebProcess/soup/WebSoupRequestManager.cpp:
        (WebKit::WebSoupRequestManager::registerURIScheme): Remove requester and
        use method soup_session_add_feature_by_type().

2013-04-15  Dean Jackson  <dino@apple.com>

        Plugins that resize might need to be snapshotted.
        https://bugs.webkit.org/show_bug.cgi?id=102157
        <rdar://problem/12696259>

        Reviewed by Tim Horton.

        Allow a running plugin to be snapshotted. All this
        means is that we start the snapshot timer again.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::beginSnapshottingRunningPlugin): Restart
            the timer.
        * WebProcess/Plugins/PluginView.h: Virtual method declaration.

2013-04-15  Seokju Kwon  <seokju.kwon@gmail.com>

        [EFL][WK2] build fix after r148434
        https://bugs.webkit.org/show_bug.cgi?id=114647

        Reviewed by Benjamin Poulain.

        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::showContextMenu):

2013-04-15  Jer Noble  <jer.noble@apple.com>

        After switching to another space and back, video races to catch up with audio
        https://bugs.webkit.org/show_bug.cgi?id=114634

        Reviewed by Tim Horton.

        In Mountain Lion and previous, report that a view is "not visible" when its window
        is not in the active space. This causes us to notify AVFoundation that its CAImageQueues
        will not be serviced and results in not having the "catch up" behavior when returning
        to the browser's space.

        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::isViewVisible):

2013-04-15  Seulgi Kim  <seulgikim@company100.net>

        Schedule rendering at regular interval (60fps)
        https://bugs.webkit.org/show_bug.cgi?id=114617

        Reviewed by Martin Robinson.

        Schedule rendering reguarly regardless of the time taken to render a
        frame. Otherwise, next flush delayed by the amount of the rendering
        time.

        * WebProcess/WebPage/gtk/LayerTreeHostGtk.cpp:
        (WebKit::LayerTreeHostGtk::LayerTreeHostGtk):
        (WebKit::LayerTreeHostGtk::layerFlushTimerFired):
        (WebKit::LayerTreeHostGtk::flushAndRenderLayers):
        * WebProcess/WebPage/gtk/LayerTreeHostGtk.h:

2013-04-15  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFL][WK2] Use C API in ewk_context_menu
        https://bugs.webkit.org/show_bug.cgi?id=109698

        Reviewed by Andreas Kling.

        EFL port unlike others does not handle context menus inside WebKit but exposes an API:
        ewk_context_menu and ewk_context_menu_item, and leaves context menu to application.
        Currently EFL port's context menu API uses internal C++ classes, while it should use WK2 C API,
        to avoid violating layering.
        This patch changes EFL context menu API to use only WK2 C API.

        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::showContextMenu):
        * UIProcess/API/efl/EwkView.h:
        (WebKit):
        (EwkView):
        * UIProcess/API/efl/ewk_context_menu.cpp:
        (EwkContextMenu::EwkContextMenu):
        (EwkContextMenu::contextMenuItemSelected):
        (ewk_context_menu_item_select):
        (getWKTagFromEwkAction):
        * UIProcess/API/efl/ewk_context_menu_item.cpp:
        (EwkContextMenuItem::EwkContextMenuItem):
        (getEwkActionFromWKTag):
        * UIProcess/API/efl/ewk_context_menu_item.h:
        * UIProcess/API/efl/ewk_context_menu_item_private.h:
        (EwkContextMenuItem::create):
        (EwkContextMenuItem):
        * UIProcess/API/efl/ewk_context_menu_private.h:
        (EwkContextMenu::create):
        (EwkContextMenu):
        * UIProcess/efl/ContextMenuClientEfl.cpp:
        (showContextMenu):
        (hideContextMenu):
        (ContextMenuClientEfl::ContextMenuClientEfl):
        * UIProcess/efl/ContextMenuClientEfl.h:
        (WebKit::ContextMenuClientEfl::view):
        * UIProcess/efl/WebContextMenuProxyEfl.cpp:
        (WebKit::WebContextMenuProxyEfl::showContextMenu):
        (WebKit::WebContextMenuProxyEfl::hideContextMenu):
        * UIProcess/efl/WebContextMenuProxyEfl.h:
        (WebContextMenuProxyEfl):

2013-04-15  Balazs Kelemen  <kbalazs@webkit.org>

        [CoordGfx] Background color should not be part of GraphicsLayerState
        https://bugs.webkit.org/show_bug.cgi?id=113785

        Reviewed by Andreas Kling.

        Page background is independent from layer state, send it to the UI
        as soon as possible.

        * Shared/CoordinatedGraphics/CoordinatedGraphicsArgumentCoders.cpp:
        (CoreIPC::::encode):
        (CoreIPC::::decode):
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::setBackgroundColor):

2013-04-15  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [WK2] Add new callbacks and a function for WebKit2 context menu API
        https://bugs.webkit.org/show_bug.cgi?id=111552

        Reviewed by Anders Carlsson.

        Add contextMenuHide and contextMenuShow callbacks to WKPageContextMenuClient
        and WKPageContextMenuSelected API so context menus can be handled outside
        WebKit. API version of this client was bumped so older client version still
         can be used

        * Shared/APIClientTraits.cpp:
        (WebKit):
        * Shared/APIClientTraits.h:
        * UIProcess/API/C/WKPage.cpp:
        (WKPageSelectContextMenuItem):
        * UIProcess/API/C/WKPage.h:
        * UIProcess/API/gtk/WebKitContextMenuClient.cpp:
        (attachContextMenuClientToView):
        * UIProcess/WebPageContextMenuClient.cpp:
        (WebKit::WebPageContextMenuClient::getContextMenuFromProposedMenu):
        (WebKit::WebPageContextMenuClient::showContextMenu):
        (WebKit):
        (WebKit::WebPageContextMenuClient::hideContextMenu):
        * UIProcess/WebPageContextMenuClient.h:
        (WebPageContextMenuClient):
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::internalShowContextMenu):
        * UIProcess/efl/ContextMenuClientEfl.cpp:
        (ContextMenuClientEfl::ContextMenuClientEfl):

2013-04-14  Christophe Dumez  <ch.dumez@sisa.samsung.com>

        [EFL][WK2] Regression(r148274): Broke rendering in the browser
        https://bugs.webkit.org/show_bug.cgi?id=114593

        Reviewed by Anders Carlsson.

        r148274 added a new "didChangeViewportAttributes" callback to
        WKView but did not hook it up in ViewClientEfl. This patch
        fixes this and makes rendering work again in the browser.

        * UIProcess/efl/ViewClientEfl.cpp:
        (WebKit::ViewClientEfl::ViewClientEfl):

2013-04-14  Andreas Kling  <akling@apple.com>

        Move CSSOM classes to using MutableStylePropertySet over StylePropertySet.
        <http://webkit.org/b/114581>

        Reviewed by Anders Carlsson.

        * WebProcess/WebCoreSupport/WebEditorClient.cpp:
        (WebKit::WebEditorClient::shouldApplyStyle):

2013-04-14  Christophe Dumez  <ch.dumez@sisa.samsung.com>

        Unreviewed build fix for WebKit2 EFL after r148373 due to missing
        header includes.

        * UIProcess/InspectorServer/efl/WebInspectorServerEfl.cpp:
        * UIProcess/efl/InputMethodContextEfl.cpp:

2013-04-13  Sam Weinig  <sam@webkit.org>

        Add ObjC API for setting initialization data for the WKWebProcessPlugIn
        https://bugs.webkit.org/show_bug.cgi?id=103846

        Reviewed by Darin Adler.

        * UIProcess/API/mac/WKProcessGroup.h:
        Adds a new optional processGroupWillCreateConnectionToWebProcessPlugIn: method for the WKProcessGroupDelegate protocol,
        which allows the user to pass (via an autoreleased return value) initialization data to the web process plugin.

        * UIProcess/API/mac/WKProcessGroup.mm:
        (getInjectedBundleInitializationUserData):
        (setUpInectedBundleClient):
        (-[WKProcessGroup initWithInjectedBundleURL:]):
        (-[WKProcessGroup dealloc]):
        Use the existing WKContextInjectedBundleClient infrastructure to pass the initialization data to the bundle
        via the new ObjCObjectGraph APIObject.

        * WebProcess/InjectedBundle/API/mac/WKWebProcessPlugIn.h:
        Adds webProcessPlugIn:initializeWithObject: to the WKWebProcessPlugIn protocol, replacing webProcessPlugInInitialize:.

        * WebProcess/InjectedBundle/mac/InjectedBundleMac.mm:
        (WebKit::InjectedBundle::load):
        Pass the initialization data to the web process plugin.

2013-04-13  Sam Weinig  <sam@webkit.org>

        Attempt Build Fix.

        * WebProcess/Plugins/Netscape/NPJSObject.cpp:

2013-04-12  Sam Weinig  <sam@webkit.org>

        Make Frame's ScriptController an OwnPtr and remove the #include
        https://bugs.webkit.org/show_bug.cgi?id=114105

        Reviewed by Dean Jackson.

        * Shared/WebHitTestResult.cpp:
        * Shared/WebHitTestResult.h:
        * UIProcess/Plugins/PlugInAutoStartProvider.cpp:
        * UIProcess/WebContext.h:
        * UIProcess/WebPageProxy.h:
        * WebProcess/InjectedBundle/API/c/WKBundleFrame.cpp:
        * WebProcess/InjectedBundle/InjectedBundleDOMWindowExtension.cpp:
        * WebProcess/Plugins/Netscape/NPJSObject.cpp:
        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.cpp:
        * WebProcess/Plugins/PDF/PDFPlugin.h:
        * WebProcess/Plugins/PluginView.cpp:
        * WebProcess/Storage/StorageAreaImpl.cpp:
        * WebProcess/Storage/StorageAreaMap.cpp:
        * WebProcess/WebPage/WebFrame.cpp:
        * WebProcess/WebPage/WebPage.cpp:

2013-04-13  Zan Dobersek  <zdobersek@igalia.com>

        Unreviewed GTK build fix after r148311.

        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (resizeWebKitWebViewBaseFromAllocation): Passing IntSize() as the scroll offset
        argument to the DrawingAreaProxy::setSize method.

2013-04-12  Gavin Barraclough  <barraclough@apple.com>

        Add private interface to WKView to asynchronously update the drawing area size
        https://bugs.webkit.org/show_bug.cgi?id=114549

        Reviewed by Simon Fraser.

        This will allow a client using the WKView to resize the contents without blocking waiting for the web process to repaint.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView _setDrawingAreaSize:]):
            - if the new size of teh drawing area does not match the frame size, position it according to the contentAnchor.
        (-[WKView updateLayer]):
            - Don't let a subsequent frame size change block on a prior async resize.
        (-[WKView forceAsyncDrawingAreaSizeUpdate:]):
            - resize the drawing area asynchronously, even if frame size udpates are disabled.
        (-[WKView waitForAsyncDrawingAreaSizeUpdate]):
            - wait for asynchronous updates to complete.

        * UIProcess/API/mac/WKViewPrivate.h:
            - declare new methods.

        * UIProcess/DrawingAreaProxy.cpp:
        (WebKit):
        * UIProcess/DrawingAreaProxy.h:
        (DrawingAreaProxy):
        (WebKit::DrawingAreaProxy::waitForPossibleGeometryUpdate):
        * UIProcess/mac/TiledCoreAnimationDrawingAreaProxy.h:
        (TiledCoreAnimationDrawingAreaProxy):
        * UIProcess/mac/TiledCoreAnimationDrawingAreaProxy.mm:
        (WebKit::TiledCoreAnimationDrawingAreaProxy::waitForPossibleGeometryUpdate):
            - pass timeout for waitForPossibleGeometryUpdate as a parameter.

2013-04-12  Jessie Berlin  <jberlin@apple.com>

        32-bit build fix.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView setFrameSize:]):

2013-04-12  Jeffrey Pfau  <jpfau@apple.com>

        Query directly for cache partition names
        https://bugs.webkit.org/show_bug.cgi?id=114538

        Reviewed by David Kilzer.

        Call back into WebKitSystemInterface to ask it for the cache
        partition names instead of trying to figure them out.

        * WebProcess/ResourceCache/WebResourceCacheManager.cpp:
        (WebKit::WebResourceCacheManager::getCacheOrigins):
        (WebKit):
        (WebKit::WebResourceCacheManager::returnCacheOrigins):
        * WebProcess/ResourceCache/WebResourceCacheManager.h:
        (WebResourceCacheManager):
        * WebProcess/ResourceCache/cf/WebResourceCacheManagerCFNet.cpp:
        (WebKit::WebResourceCacheManager::cfURLCacheHostNames):
        (WebKit):
        (WebKit::WebResourceCacheManager::cfURLCacheHostNamesWithCallback):

2013-04-12  Gavin Barraclough  <barraclough@apple.com>

        Build fix - too soon!

        * UIProcess/API/mac/WKViewPrivate.h:

2013-04-12  Gavin Barraclough  <barraclough@apple.com>

        Build fix - too soon!

        * UIProcess/API/mac/WKView.mm:
        (-[WKView setFrameSize:]):

2013-04-12  Adenilson Cavalcanti  <cavalcantii@gmail.com>

        [WK2] WebPageProxy loadURL() won't work when called just after terminateProcess()
        https://bugs.webkit.org/show_bug.cgi?id=110743

        Reviewed by Benjamin Poulain.

        A call to loadURL() just after terminating WebProcess will fail thanks to
        WebPageProxy being in an undefined state since it is in the middle of its own
        cleanup after process termination.

        To properly fix this, not only WebPageProxy cleanup should be made
        at WebProcess termination request, but also WebProcessProxy needs
        to only return to its caller after terminating the process and
        closing connections. Otherwise, WebPageProxy can even be able to
        detect that WebProcess is no longer running, but a call to respawn
        the process will fail.

        To fix these issues, this patch moves the cleanup code to a shared private function
        that is used for both the cases i.e. user termination and real crash. WebProcess
        shutdown is done using a new method that ensures that all cleanup was done before
        returning.

        A last change introduced in this patch is that for user requested termination,
        clients are no longer notified of a crash (since it is not a crash).

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::terminateProcess):
        (WebKit::WebPageProxy::processDidCrash):
        (WebKit):
        (WebKit::WebPageProxy::resetStateAfterProcessExited):
        * UIProcess/WebPageProxy.h:
        (WebPageProxy):
        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::userRequestedTerminate):
        (WebKit):
        * UIProcess/WebProcessProxy.h:
        (WebProcessProxy):

2013-04-12  Gavin Barraclough  <barraclough@apple.com>

        Add contentAnchor to WKView
        http://bugs.webkit.org/show_bug.cgi?id=114469
        
        Currently if you call setFrameSize: while frame size updates are disabled, or if the geometry
        update times out, then the previously rendered page content will be rendered anchored to the
        top left corner of the frame.

        This is appropriate if the frame is being resized from the bottom right corner. In order to
        achieve a more desirable appearance if the frame is being resized from another corner we
        should allow the corner at which the content anchors to be specified.

        Reviewed by Simon Fraser.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView setFrameSize:]):
            - If the content anchor has been set, then updating the frame size moves the origin within the layer.
        (-[WKView _setDrawingAreaSize:]):
            - Instruct the drawing area to paint at the correct position within the layer.
        (-[WKView _setAcceleratedCompositingModeRootLayer:]):
            - If the root layer is cleared this implicitly resets any origin position we had set within it.
        (-[WKView initWithFrame:contextRef:pageGroupRef:relatedToPage:]):
            - initialize new data members.
        (-[WKView setContentAnchor:]):
        (-[WKView contentAnchor]):
            - Accessor implementation for @property contentAnchor.

        * UIProcess/API/mac/WKViewPrivate.h:
        (NS_ENUM):
            - Added WKContentAnchor enum type, and @property contentAnchor.

        * UIProcess/DrawingAreaProxy.cpp:
        (WebKit::DrawingAreaProxy::setSize):
            - Don't suppress geometry updates where the layer poistion has changed.

        * UIProcess/DrawingAreaProxy.h:
        (DrawingAreaProxy):
            - Added m_layerPosition, layerPosition argument to setSize

        * UIProcess/mac/TiledCoreAnimationDrawingAreaProxy.h:
        (TiledCoreAnimationDrawingAreaProxy):
            - Added m_lastSentLayerPosition

        * UIProcess/mac/TiledCoreAnimationDrawingAreaProxy.mm:
        (WebKit::TiledCoreAnimationDrawingAreaProxy::didUpdateGeometry):
            - Don't suppress geometry updates where the layer poistion has changed.

        (WebKit::TiledCoreAnimationDrawingAreaProxy::sendUpdateGeometry):
            - Pass layer position in UpdateGeometry message.

        * WebProcess/WebPage/DrawingArea.h:
        (WebKit::DrawingArea::updateGeometry):
            - Added layerPosition argument to updateGeometry

        * WebProcess/WebPage/DrawingArea.messages.in:
            - Added layerPosition argument to updateGeometry

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
        (TiledCoreAnimationDrawingArea):
            - Added layerPosition argument to updateGeometry

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::updateGeometry):
            - Added layerPosition argument to updateGeometry

2013-04-12  Commit Queue  <rniwa@webkit.org>

        Unreviewed, rolling out r148296 and r148297.
        http://trac.webkit.org/changeset/148296
        http://trac.webkit.org/changeset/148297
        https://bugs.webkit.org/show_bug.cgi?id=114536

        Needs more thought (Requested by ap on #webkit).

        * NetworkProcess/mac/com.apple.WebKit.NetworkProcess.sb.in:

2013-04-12  Tim Horton  <timothy_horton@apple.com>

        REGRESSION (r138858): GIFs don't start playing when they come out of background tabs
        https://bugs.webkit.org/show_bug.cgi?id=108864
        <rdar://problem/13140489>

        Reviewed by Antti Koivisto.

        Don't repaint the world when animations resume; instead, FrameView
        will cause all animated images to repaint. This line also had no effect for
        TiledCoreAnimationDrawingArea, which does not implement setNeedsDisplay.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::resumeActiveDOMObjectsAndAnimations):

2013-04-12  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13334446> [Mac] Tweak sandbox profile.

        Apply a post-landing review comment.

        * NetworkProcess/mac/com.apple.WebKit.NetworkProcess.sb.in:

2013-04-12  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13334446> [Mac] Tweak sandbox profile.

        Reviewed by Jessie Berlin.

        * NetworkProcess/mac/com.apple.WebKit.NetworkProcess.sb.in:

2013-04-12  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Split GtkAuthenticationDialog in two widgets
        https://bugs.webkit.org/show_bug.cgi?id=103644

        Reviewed by Xan Lopez.

        * GNUmakefile.list.am: Add new files to compilation.
        * UIProcess/API/gtk/WebKit2GtkAuthenticationDialog.cpp: Removed.
        * UIProcess/API/gtk/WebKit2GtkAuthenticationDialog.h: Removed.
        * UIProcess/API/gtk/WebKitAuthenticationDialog.cpp: Added.
        (webkitAuthenticationDialogAuthenticate): Use the
        AuthenticationChallengeProxy to authenticate and destroy the dialog.
        (okButtonClicked): Call webkitAuthenticationDialogAuthenticate()
        with the credential.
        (cancelButtonClicked): Call
        webkitAuthenticationDialogAuthenticate() with a NULL credential to
        continue without credential.
        (webkitAuthenticationDialogInitialize): Build the UI.
        (webkitAuthenticationDialogDraw): Draw a background.
        (webkitAuthenticationDialogMap): Grab default button.
        (webkitAuthenticationDialogConstructed): Create a GtkStyleContext
        with the GtkWindow path to draw the widget background like a real
        dialog.
        (webkit_authentication_dialog_class_init):
        (webkitAuthenticationDialogNew): Create a new
        WebKitAuthenticationDialog widget.
        * UIProcess/API/gtk/WebKitAuthenticationDialog.h: Added.
        * UIProcess/API/gtk/WebKitLoaderClient.cpp:
        * UIProcess/API/gtk/WebKitWebView.cpp:
        (webkitWebViewHandleAuthenticationChallenge): Create a
        WebKitAuthenticationDialog widget and pass add it to the
        container.
        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (_WebKitWebViewBasePrivate): Updated to use the widget directly.
        (webkitWebViewChildIsInternalWidget): Ditto.
        (webkitWebViewBaseAddAuthenticationDialog): Ditto.
        (webkitWebViewBaseCancelAuthenticationDialog): Ditto.
        (webkitWebViewBaseContainerRemove): Ditto.
        (webkitWebViewBaseContainerForall): Ditto.
        (resizeWebKitWebViewBaseFromAllocation): Ditto.
        (webkitWebViewBaseFocus): Ditto.
        (webkitWebViewBaseDestroy): Destroy the auth widget is present.
        (webkit_web_view_base_class_init): Add implementation for
        GtkWidgetClass::destroy.
        * UIProcess/API/gtk/WebKitWebViewBasePrivate.h:

2013-04-12  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Web Process crash when the UI process finishes too early
        https://bugs.webkit.org/show_bug.cgi?id=112729

        Reviewed by Anders Carlsson.

        The problem is when creating the GSocket in the WorkQeue for the
        socket descriptor. GLib considers a programmer error to create a
        GSocket providing an invalid socket and finishes the process with
        g_error(). We are actually providing a valid socket when creating
        the GSocket, but it can be invalidated by the worker thread while
        the GSocket is being created. This is because
        registerEventSourceHandler is called from the main thread and
        unregisterEventSourceHandler can be called from the worker
        thread. We are currently registering two event handlers, one to
        read data from the socket and another one to close the CoreIPC
        connection when the socket connection is broken. Every event
        source registered uses its own GSocket (even if the file
        descriptor is actually the same), so that when the UI process
        finishes too early, the first event handler can be executed in the
        worker thread, closing the socket descriptor, while the main
        thread is creating the GSocket for the second one.
        We don't really need to use a separate event handler to monitor
        the connection, because GSocket always notifies when condition is
        G_IO_HUP and G_IO_ERR even if they haven't been explicitly set in
        g_socket_create_source(). We can register socket event sources
        differently, providing also a function to be called when the
        connection is closed, using a single socket and the same even source.

        * Platform/CoreIPC/unix/ConnectionUnix.cpp:
        (CoreIPC::Connection::platformInvalidate):
        (CoreIPC::Connection::open): Register a single socket event
        handler providing also a function to be called when the connection
        is closed.
        * Platform/WorkQueue.h:
        (WorkQueue):
        * Platform/gtk/WorkQueueGtk.cpp: The EventSource class has been
        split, moving everyting specific to socket event source to a
        derived class SocketEventSource.
        (WorkQueue::EventSource::EventSource):
        (WorkQueue::EventSource::performWork):
        (WorkQueue::EventSource::performWorkOnce):
        (WorkQueue::EventSource::performWorkOnTermination):
        (WorkQueue::EventSource::deleteEventSource):
        (WorkQueue::EventSource):
        (WorkQueue::SocketEventSource):
        (WorkQueue::SocketEventSource::SocketEventSource):
        (WorkQueue::SocketEventSource::cancel):
        (WorkQueue::SocketEventSource::didClose):
        (WorkQueue::SocketEventSource::checkCondition):
        (WorkQueue::SocketEventSource::eventCallback):
        (WorkQueue::registerSocketEventHandler):
        (WorkQueue::unregisterSocketEventHandler):
        (WorkQueue::dispatchOnSource):

2013-04-12  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13126204> [Mac] Tweak sandbox profile.

        Reviewed by Anders Carlsson.

        * NetworkProcess/mac/com.apple.WebKit.NetworkProcess.sb.in:
        * WebProcess/com.apple.WebProcess.sb.in:

2013-04-12  Manuel Rego Casasnovas  <rego@igalia.com>

        [GTK][WK2] Add document-loaded signal to WebKitWebPage
        https://bugs.webkit.org/show_bug.cgi?id=110614

        Reviewed by Carlos Garcia Campos.

        Add a new signal document-loaded to WebKitWebPage that will be emitted
        when the DOM document has been loaded for the main frame.

        * UIProcess/API/gtk/tests/TestWebExtensions.cpp:
        (documentLoadedCallback):
        (testDocumentLoadedSignal):
        (beforeAll): Add test for document-loaded signal.
        * UIProcess/API/gtk/tests/WebExtensionTest.cpp:
        (documentLoadedCallback):
        (pageCreatedCallback):
        (methodCallCallback): Add new D-Bus signal DocumentLoaded in order to
        test document-loaded signal.
        * WebProcess/InjectedBundle/API/gtk/WebKitWebPage.cpp:
        (webkit_web_page_class_init):
        (webkitWebPageCreate): Add document-loaded signal and emit it when
        didFinishDocumentLoadForFrame is called.

2013-04-12  Hanyee Kim  <choco@company100.net>

        [GTK] Webkit fails to build webkit2gtk-tests-resources.gresource.
        https://bugs.webkit.org/show_bug.cgi?id=114485

        Reviewed by Martin Robinson.

        Generating webkit2gtk-tests-resources.gresource can be failed due to
        the non-existing target directory.
        We need to make target directory before generating it.

        * UIProcess/API/gtk/tests/GNUmakefile.am:

2013-04-12  Andreas Kling  <akling@apple.com>

        REGRESSION(r145869): Right-click on SWF contents displays the context menu at the wrong place.
        <http://webkit.org/b/113836>
        <rdar://problem/13587624>

        Reviewed by Anders "Wesley Crusher" Carlsson.

        Mac plugins expect flipped-Y screen coordinates, while DOM APIs speak in unflipped coordinates,
        and we were mixing them up in the window frame caching optimization.

        Solve this by having the UIProcess send both flipped and unflipped window frames to the WebProcess.
        The flipped frame is passed on to plugins, and the unflipped frame is used for window.screenX/Y etc.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView _updateWindowAndViewFrames]):

            No need to retrieve the window frame here as WebPageProxy::windowAndViewFramesChanged() will
            always override it anyway.

        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::windowAndViewFramesChanged):
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::windowRect):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::windowAndViewFramesChanged):
        * WebProcess/WebPage/WebPage.h:
        (WebKit::WebPage::windowFrameInUnflippedScreenCoordinates):
        * WebProcess/WebPage/WebPage.messages.in:

2013-04-12  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [WK2][EFL] WebView: Add callbacks to the WKViewClient to handle page viewport update
        https://bugs.webkit.org/show_bug.cgi?id=110463

        Reviewed by Anders Carlsson.

        * UIProcess/efl/ViewClientEfl.h:
        (ViewClientEfl):
        * UIProcess/efl/WebView.cpp:
        (WebKit::WebView::didChangeViewportProperties):
        * UIProcess/efl/WebViewClient.cpp:
        (WebKit::WebViewClient::didChangeViewportAttributes):
        (WebKit):
        * UIProcess/efl/WebViewClient.h:

            Added didChangeViewportAttributes callback to the WKViewClient to
            handle page viewport updates.

        * CMakeLists.txt:
        * Shared/API/c/WKBase.h:
        * Shared/APIObject.h:
        * UIProcess/API/C/WKAPICast.h:
        (WebKit):
        * UIProcess/API/C/WKViewportAttributes.cpp: Added.
        (WKViewportAttributesGetTypeID):
        * UIProcess/API/C/WKViewportAttributes.h: Added.
        * UIProcess/API/C/efl/WKView.h:
        * UIProcess/WebViewportAttributes.cpp: Added.
        (WebKit):
        (WebKit::WebViewportAttributes::WebViewportAttributes):
        (WebKit::WebViewportAttributes::~WebViewportAttributes):
        * UIProcess/WebViewportAttributes.h: Added.
        (WebKit):
        (WebViewportAttributes):
        (WebKit::WebViewportAttributes::create):
        (WebKit::WebViewportAttributes::originalAttributes):
        (WebKit::WebViewportAttributes::type):

            Added WKViewportAttributesRef - WK2 C API object that is wrapping 
            WebCore::ViewportAttributes structure and is passed in didChangeViewportAttributes
            WKViewClient callback.

        * UIProcess/efl/ViewClientEfl.cpp:
        (WebKit::ViewClientEfl::didChangeViewportAttributes):
        (WebKit):

            Added implementaion of didChangeViewportAttributes WKViewClient 
            callback so that existing EFL WK2 funtionality is kept.


2013-04-12  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] The style of visited links doesn't change in WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=112175

        Reviewed by Benjamin Poulain.

        The problem is that visited links were not tracked by the web
        process. There's a web process initial parameter to set whether
        web process should track visited links or not and it's disabled by
        default.

        * UIProcess/gtk/WebContextGtk.cpp:
        (WebKit::WebContext::platformInitializeWebProcess): Always set
        shouldTrackVisitedLinks to true.

2013-04-11  Tim Horton  <timothy_horton@apple.com>

        REGRESSION (r146956): ASSERTion failure: WebKit::WebProcess::pageWillLeaveWindow
        https://bugs.webkit.org/show_bug.cgi?id=114481
        <rdar://problem/13534784>

        Reviewed by Simon Fraser.

        Inform the WebProcess of WebPages which are already in a window when created.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::WebPage):

2013-04-11  Anders Carlsson  <andersca@apple.com>

        Add support for clearing storage areas
        https://bugs.webkit.org/show_bug.cgi?id=114479

        Reviewed by Beth Dakin.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::StorageArea::StorageArea):
        Store the quota size so we can recreate the underlying StorageMap when clearing.
        
        (WebKit::StorageManager::StorageArea::clear):
        Create a new storage map and dispatch events.

        (WebKit::StorageManager::clear):
        Find the right storage area and call clear.

        * UIProcess/Storage/StorageManager.messages.in:
        Add Clear message.

        * WebProcess/Storage/StorageAreaImpl.cpp:
        (WebKit::StorageAreaImpl::clear):
        Call the storage map.

        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::clear):
        Reset the cached values and send a clear message.

        (WebKit::StorageAreaMap::resetValues):
        New helper function.

        (WebKit::StorageAreaMap::didClear):
        New stub.

        * WebProcess/Storage/StorageAreaMap.messages.in:
        Add DidClear message.

2013-04-11  Beth Dakin  <bdakin@apple.com>

        WebKit should set the header and footer layers' contentsScale when the device 
        scale factor changes
        https://bugs.webkit.org/show_bug.cgi?id=114471
        -and corresponding-
        <rdar://problem/13621288>

        Reviewed by Simon Fraser.

        Update the header and footer contentsScale when the device scale factor has 
        changed.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::setDeviceScaleFactor):
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::updateHeaderAndFooterLayersForDeviceScaleChange):

2013-04-11  Anders Carlsson  <andersca@apple.com>

        Implement removing storage area items
        https://bugs.webkit.org/show_bug.cgi?id=114472

        Reviewed by Beth Dakin.

        * UIProcess/Storage/StorageManager.cpp:
        (StorageManager::StorageArea):
        (WebKit::StorageManager::StorageArea::setItem):
        Rename connection to sourceConnection.

        (WebKit::StorageManager::StorageArea::removeItem):
        Remove the item from the map and dispatch events if needed.

        (WebKit::StorageManager::removeItem):
        Find the right storage area, remove the item and send back a DidRemoveItem message.

        * UIProcess/Storage/StorageManager.messages.in:
        Add RemoveItem message.

        * WebProcess/Storage/StorageAreaImpl.cpp:
        (WebKit::StorageAreaImpl::removeItem):
        Call StorageAreaMap::removeItem.

        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::removeItem):
        Send a RemoveItem message to the storage manager.
        
        (WebKit::StorageAreaMap::didRemoveItem):
        Add empty stub.

        * WebProcess/Storage/StorageAreaMap.messages.in:
        Add DidRemoveItem message.

2013-04-11  Tim Horton  <timothy_horton@apple.com>

        InjectedBundleNodeHandle::imageForRect doesn't respect device scale factor or highlighting option
        https://bugs.webkit.org/show_bug.cgi?id=114466
        <rdar://problem/13508513>

        Reviewed by Simon Fraser.

        Respect the device scale factor when creating the snapshot image.
        Clear the snapshot image before drawing into it.
        Respect SnapshotOptionsExcludeSelectionHighlighting.

        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.cpp:
        (WebKit::imageForRect):

2013-04-11  Commit Queue  <rniwa@webkit.org>

        Unreviewed, rolling out r148034, r148052, r148097, and
        r148194.
        http://trac.webkit.org/changeset/148034
        http://trac.webkit.org/changeset/148052
        http://trac.webkit.org/changeset/148097
        http://trac.webkit.org/changeset/148194
        https://bugs.webkit.org/show_bug.cgi?id=114463

        broke mutiresolution favicons, among other things (Requested
        by thorton on #webkit).

        * UIProcess/WebIconDatabase.cpp:
        (WebKit::WebIconDatabase::setIconDataForIconURL):
        * UIProcess/WebIconDatabase.h:
        (WebIconDatabase):
        * UIProcess/WebIconDatabase.messages.in:
        * WebProcess/IconDatabase/WebIconDatabaseProxy.cpp:
        (WebKit::WebIconDatabaseProxy::setIconDataForIconURL):
        * WebProcess/Plugins/PDF/PDFPlugin.mm:
        (WebKit::PDFPlugin::destroy):

2013-04-11  Anders Carlsson  <andersca@apple.com>

        Implement StorageManager::getValues
        https://bugs.webkit.org/show_bug.cgi?id=114461

        Reviewed by Beth Dakin.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::StorageArea::items):
        (WebKit::StorageManager::getValues):
        Return the items from the right storage area.

2013-04-11  Anders Carlsson  <andersca@apple.com>

        Clean up related storage areas when a connection is destroyed
        https://bugs.webkit.org/show_bug.cgi?id=114459

        Reviewed by Beth Dakin.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::processWillCloseConnection):
        Dispatch invalidateConnectionInternal on the work queue.
        
        (WebKit::StorageManager::createStorageMap):
        (WebKit::StorageManager::destroyStorageMap):
        Rename m_storageAreas to m_storageAreasByConnection.

        (WebKit::StorageManager::invalidateConnectionInternal):
        Go over all known storage areas and remove this connection as a listener.

        (WebKit::StorageManager::findStorageArea):
        Rename m_storageAreas to m_storageAreasByConnection.

        * UIProcess/Storage/StorageManager.h:
        Rename m_storageAreas to m_storageAreasByConnection.

2013-04-11  Anders Carlsson  <andersca@apple.com>

        Make StorageAreaMap dispatch session storage events
        https://bugs.webkit.org/show_bug.cgi?id=114454

        Reviewed by Beth Dakin.

        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::dispatchStorageEvent):
        Depending on the storage area type, call dispatchSessionStorageEvent or dispatchLocalStorageEvent.

        (WebKit::StorageAreaMap::dispatchSessionStorageEvent):
        Enumerate all the frames in our page and dispatch the event to the relevant ones.

        (WebKit::StorageAreaMap::dispatchLocalStorageEvent):
        Add empty stub for now.

2013-04-11  Anders Carlsson  <andersca@apple.com>

        Implement more logic in StorageAreaMap
        https://bugs.webkit.org/show_bug.cgi?id=114451

        Reviewed by Alexey Proskuryakov.

        * Platform/CoreIPC/HandleMessage.h:
        (CoreIPC::callMemberFunction):
        Add new overload.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::StorageArea::addListener):
        (WebKit::StorageManager::StorageArea::removeListener):
        These take storage map IDs.

        (WebKit::StorageManager::StorageArea::setItem):
        Rename storageAreaID to sourceStorageAreaID.

        (WebKit::StorageManager::StorageArea::dispatchEvents):
        Remove the code that would not dispatch to the source connection, there may still be storage areas interested in those events.

        (WebKit::StorageManager::setItem):
        This now takes the source storage area ID.

        (WebKit::StorageManager::findStorageArea):
        This takes a storage map ID.

        * UIProcess/Storage/StorageManager.messages.in:
        SetItem now takes the source storage area ID as well.

        * WebProcess/Storage/StorageAreaImpl.cpp:
        (WebKit::StorageAreaImpl::setItem):
        Pass the source frame to StorageAreaMap::setItem.

        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::StorageAreaMap):
        Send CreateStorageMap and add the object as a message receiver.

        (WebKit::StorageAreaMap::~StorageAreaMap):
        Send DestroyStorageMap and remove the object as a message receiver.

        (WebKit::StorageAreaMap::length):
        (WebKit::StorageAreaMap::key):
        (WebKit::StorageAreaMap::item):
        (WebKit::StorageAreaMap::contains):
        Load values and forward calls to the storage map.

        (WebKit::StorageAreaMap::setItem):
        This now takes the source frame as well. Update the local storage map and send a SetItem message.
        
        (WebKit::StorageAreaMap::loadValuesIfNeeded):
        Get the values from the storage manager.

        (WebKit::StorageAreaMap::dispatchStorageEvent):
        This now takes the source storage area ID.

        * WebProcess/Storage/StorageAreaMap.messages.in:
        DispatchStorageEvent now takes the source storage area ID.

2013-04-10  Brady Eidson  <beidson@apple.com>

        Web/Plugin process deadlock initializing async plugins.
        <rdar://problem/13525232> and https://bugs.webkit.org/show_bug.cgi?id=114217

        Rubberstamped by Anders Carlsson.

        Rollout r147953 and r147968 as we identified other causes for this.

        * PluginProcess/WebProcessConnection.cpp:
        (WebKit::WebProcessConnection::createPluginAsynchronously):
        * WebProcess/Plugins/PluginProxy.messages.in:

2013-04-11  Alexey Proskuryakov  <ap@apple.com>

        Remove some ResourceHandle.h includes
        https://bugs.webkit.org/show_bug.cgi?id=114416

        Reviewed by Ryosuke Niwa.

        * WebProcess/Network/NetworkProcessConnection.cpp: Added an include that is now
        necessary.

2013-04-11  Allan Sandfeld Jensen  <allan.jensen@digia.com>

        [Qt] EventHandler should handle Space and BackSpace 
        https://bugs.webkit.org/show_bug.cgi?id=114428

        Reviewed by Jocelyn Turcotte.

        Remove our own handling of space and backspace.

        * WebProcess/WebPage/qt/WebPageQt.cpp:
        (WebKit::WebPage::performDefaultBehaviorForKeyEvent):

2013-04-11  Csaba Osztrogonác  <ossy@webkit.org>

        Unreviewed Qt buildfixes after r148147, r148148 and r148154.

        * DerivedSources.pri:
        * Target.pri:

2013-04-10  Zan Dobersek  <zdobersek@igalia.com>

        Unreviewed GTK build fix, fixing the WebKit2 build.

        * GNUmakefile.list.am:

2013-04-10  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [WK2] Build warning in didReceiveMessage() generated by messages.py
        https://bugs.webkit.org/show_bug.cgi?id=112513

        Reviewed by Anders Carlsson.

        Legacy receiver makes -Wunused-parameter build warnings. This patch is to fix them.

        * Scripts/webkit2/messages.py:
        (generate_message_handler):

2013-04-10  Jaehun Lim  <ljaehun.lim@samsung.com>

        [CMAKE] Build fix after StorageArea refactoring
        https://bugs.webkit.org/show_bug.cgi?id=114398

        Unreviewed build fix.

        Change StorageAreaImpl.messages.in with StorageAreaMap.messages.in.
        Add StorageAreaMap.cpp in CMakeLists.txt.

        * CMakeLists.txt:

2013-04-10  Anders Carlsson  <andersca@apple.com>

        Make StorageAreaImpl a wrapper around StorageAreaMap
        https://bugs.webkit.org/show_bug.cgi?id=114404

        Reviewed by Oliver Hunt.

        Prepare for moving all the code that deals with local storage values to StorageAreaMap,
        and make StorageAreaImpl a dumb wrapper that simply calls through to the map.

        * WebProcess/Storage/StorageAreaImpl.cpp:
        (WebKit::StorageAreaImpl::create):
        (WebKit::StorageAreaImpl::StorageAreaImpl):
        (WebKit::StorageAreaImpl::~StorageAreaImpl):
        (WebKit::StorageAreaImpl::storageType):
        (WebKit::StorageAreaImpl::length):
        (WebKit::StorageAreaImpl::key):
        (WebKit::StorageAreaImpl::getItem):
        (WebKit::StorageAreaImpl::setItem):
        (WebKit::StorageAreaImpl::contains):
        * WebProcess/Storage/StorageAreaImpl.h:
        (WebKit::StorageAreaImpl::storageAreaID):
        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::generateStorageMapID):
        (WebKit::StorageAreaMap::create):
        (WebKit::StorageAreaMap::StorageAreaMap):
        (WebKit::StorageAreaMap::storageType):
        (WebKit::StorageAreaMap::length):
        (WebKit::StorageAreaMap::key):
        (WebKit::StorageAreaMap::item):
        (WebKit::StorageAreaMap::setItem):
        (WebKit::StorageAreaMap::contains):
        (WebKit::StorageAreaMap::didSetItem):
        (WebKit::StorageAreaMap::dispatchStorageEvent):
        * WebProcess/Storage/StorageAreaMap.h:
        * WebProcess/Storage/StorageNamespaceImpl.cpp:
        (WebKit::StorageNamespaceImpl::storageArea):
        * WebProcess/Storage/StorageNamespaceImpl.h:
        (StorageNamespaceImpl):

2013-04-10  Anders Carlsson  <andersca@apple.com>

        Rename StorageManager messages to refer to the StorageMap instead of the StorageArea
        https://bugs.webkit.org/show_bug.cgi?id=114401

        Reviewed by Ryosuke Niwa.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::createStorageMap):
        (WebKit::StorageManager::destroyStorageMap):
        (WebKit::StorageManager::setItem):
        * UIProcess/Storage/StorageManager.h:
        * UIProcess/Storage/StorageManager.messages.in:
        * WebProcess/Storage/StorageAreaImpl.cpp:
        (WebKit::StorageAreaImpl::StorageAreaImpl):
        (WebKit::StorageAreaImpl::~StorageAreaImpl):

2013-04-10  Benjamin Poulain  <bpoulain@apple.com>

        Mass remove all the empty directories

        Rubberstamped by Ryosuke Niwa.

        * Platform/CoreIPC/gtk: Removed.
        * Platform/CoreIPC/qt: Removed.
        * PluginProcess/EntryPoint/mac/XPCService/PluginService.32: Removed.
        * PluginProcess/EntryPoint/mac/XPCService/PluginService.64: Removed.
        * PluginProcess/gtk: Removed.
        * Shared/API/c/win: Removed.
        * Shared/Plugins/Netscape/win: Removed.
        * Shared/cg/win: Removed.
        * Shared/win: Removed.
        * UIProcess/API/C/win: Removed.
        * UIProcess/API/gtk/webkit: Removed.
        * UIProcess/Launcher/win: Removed.
        * UIProcess/Plugins/gtk: Removed.
        * UIProcess/Plugins/win: Removed.
        * UIProcess/texmap: Removed.
        * UIProcess/win: Removed.
        * WebProcess/Authentication/mac: Removed.
        * WebProcess/Cookies/efl: Removed.
        * WebProcess/Cookies/gtk: Removed.
        * WebProcess/Downloads/cf/win: Removed.
        * WebProcess/Downloads/cfnet: Removed.
        * WebProcess/Downloads/curl: Removed.
        * WebProcess/Downloads/efl: Removed.
        * WebProcess/Downloads/gtk: Removed.
        * WebProcess/Downloads/mac: Removed.
        * WebProcess/Downloads/qt: Removed.
        * WebProcess/Downloads/soup: Removed.
        * WebProcess/FullScreen/gtk: Removed.
        * WebProcess/FullScreen/mac: Removed.
        * WebProcess/FullScreen/qt: Removed.
        * WebProcess/FullScreen/win: Removed.
        * WebProcess/InjectedBundle/API/c/win: Removed.
        * WebProcess/InjectedBundle/win: Removed.
        * WebProcess/KeyValueStorage: Removed.
        * WebProcess/Network/CustomProtocols/mac: Removed.
        * WebProcess/Plugins/Netscape/gtk: Removed.
        * WebProcess/Plugins/Netscape/win: Removed.
        * WebProcess/WebCoreSupport/win: Removed.
        * WebProcess/WebPage/LayerTreeCoordinator: Removed.
        * WebProcess/WebPage/ca/mac: Removed.
        * WebProcess/WebPage/ca/win: Removed.
        * WebProcess/WebPage/win: Removed.
        * WebProcess/win: Removed.
        * qt/Resources: Removed.

2013-04-10  Jaehun Lim  <ljaehun.lim@samsung.com>

        [CMAKE] Build fix after r148147, r148148
        https://bugs.webkit.org/show_bug.cgi?id=114395

        Unreviewed build fix.

        Use StorageAreaImpl, StorageNamespaceImpl instead of StorageAreaProxy, StorageNamespaceProxy.

        * CMakeLists.txt:

2013-04-10  Anders Carlsson  <andersca@apple.com>

        Add a stubbed out StorageAreaMap class
        https://bugs.webkit.org/show_bug.cgi?id=114392

        Reviewed by Andreas Kling.

        The intention is that StorageAreaMap is going to take over responsibility for storing the storage values in the
        web process, as well as dispatching events. A StorageAreaMap will be shared between multiple StorageAreaImpl objects,
        for example if multiple frames with the same origin use local storage.

        * DerivedSources.make:
        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::StorageArea::dispatchEvents):
        (WebKit::StorageManager::setItem):
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/Storage/StorageAreaImpl.cpp:
        (WebKit::StorageAreaImpl::StorageAreaImpl):
        (WebKit::StorageAreaImpl::~StorageAreaImpl):
        * WebProcess/Storage/StorageAreaMap.cpp: Added.
        (WebKit):
        (WebKit::StorageAreaMap::create):
        (WebKit::StorageAreaMap::StorageAreaMap):
        (WebKit::StorageAreaMap::~StorageAreaMap):
        (WebKit::StorageAreaMap::didSetItem):
        (WebKit::StorageAreaMap::dispatchStorageEvent):
        * WebProcess/Storage/StorageAreaMap.h: Added.
        (WebKit):
        (StorageAreaMap):
        * WebProcess/Storage/StorageAreaMap.messages.in: Renamed from Source/WebKit2/WebProcess/Storage/StorageAreaImpl.messages.in.

2013-04-10  Anders Carlsson  <andersca@apple.com>

        Rename StorageAreaProxy to StorageAreaImpl.

        Rubber-stamped by Beth Dakin.

        * DerivedSources.make:
        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::StorageArea::dispatchEvents):
        (WebKit::StorageManager::setItem):
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/Storage/StorageAreaImpl.cpp: Renamed from Source/WebKit2/WebProcess/Storage/StorageAreaProxy.cpp.
        * WebProcess/Storage/StorageAreaImpl.h: Renamed from Source/WebKit2/WebProcess/Storage/StorageAreaProxy.h.
        * WebProcess/Storage/StorageAreaImpl.messages.in: Renamed from Source/WebKit2/WebProcess/Storage/StorageAreaProxy.messages.in.
        * WebProcess/Storage/StorageNamespaceImpl.cpp:
        (WebKit::StorageNamespaceImpl::storageArea):
        * WebProcess/Storage/StorageNamespaceImpl.h:
        (WebKit):
        (StorageNamespaceImpl):

2013-04-10  Anders Carlsson  <andersca@apple.com>

        Rename StorageNamespaceProxy to StorageNamespaceImpl.

        Rubber-stamped by Beth Dakin.

        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/Storage/StorageAreaProxy.cpp:
        (WebKit::StorageAreaProxy::create):
        (WebKit::StorageAreaProxy::StorageAreaProxy):
        * WebProcess/Storage/StorageAreaProxy.h:
        (StorageAreaProxy):
        * WebProcess/Storage/StorageNamespaceImpl.cpp: Renamed from Source/WebKit2/WebProcess/Storage/StorageNamespaceProxy.cpp.
        * WebProcess/Storage/StorageNamespaceImpl.h: Renamed from Source/WebKit2/WebProcess/Storage/StorageNamespaceProxy.h.
        * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
        (WebKit::WebPlatformStrategies::sessionStorageNamespace):

2013-04-10  Tim Horton  <timothy_horton@apple.com>

        [wk2] Un-pollute TCADA methods with "PageOverlayLayerMap::iterator end"
        https://bugs.webkit.org/show_bug.cgi?id=114387

        Reviewed by Simon Fraser.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::updatePreferences):
        (WebKit::TiledCoreAnimationDrawingArea::paintContents):
        (WebKit::TiledCoreAnimationDrawingArea::flushLayers):
        (WebKit::TiledCoreAnimationDrawingArea::setExposedRect):
        (WebKit::TiledCoreAnimationDrawingArea::mainFrameScrollabilityChanged):
        (WebKit::TiledCoreAnimationDrawingArea::updateGeometry):
        (WebKit::TiledCoreAnimationDrawingArea::setRootCompositingLayer):

2013-04-10  Tim Horton  <timothy_horton@apple.com>

        [wk2] REGRESSION: Find highlight does not update when the view is resized
        https://bugs.webkit.org/show_bug.cgi?id=114382
        <rdar://problem/13599797>

        Reviewed by Simon Fraser.

        Invalidate the page overlays from TiledCoreAnimationDrawingArea::updateGeometry.
        This will have no effect if the page overlay hasn't previously asked to be painted
        (as drawsContent will remain false on the layer).

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
        (TiledCoreAnimationDrawingArea): Add invalidateAllPageOverlays.
        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::invalidateAllPageOverlays): Factor this out of didChangeScrollOffsetForAnyFrame.
        (WebKit::TiledCoreAnimationDrawingArea::didChangeScrollOffsetForAnyFrame): Call invalidateAllPageOverlays.
        (WebKit::TiledCoreAnimationDrawingArea::updateGeometry): Call invalidateAllPageOverlays.

2013-04-10  Beth Dakin  <bdakin@apple.com>

        FindBanner matches are offset when the WKView has a header or footer
        https://bugs.webkit.org/show_bug.cgi?id=114314
        -and corresponding-
        <rdar://problem/13522434>

        Reviewed by Simon Fraser.

        When calculating the matching rects, also adjust to the scroll offset that is  
        relative to the Document.
        * WebProcess/WebPage/FindController.cpp:
        (WebKit::FindController::rectsForTextMatches):

2013-04-10  Tobias Mueller  <tobiasmue@gnome.org>

        Fixed build failure in Plugin.h: FloatPoint was not in namespace WebCore

        make[1]: *** Waiting for unfinished jobs....
        In file included from Source/WebKit2/PluginProcess/PluginCreationParameters.h:31:0,
                         from Source/WebKit2/PluginProcess/PluginCreationParameters.cpp:27:
        ./Source/WebKit2/WebProcess/Plugins/Plugin.h:268:58: error: 'FloatPoint' in namespace 'WebCore' does not name a type
        ./Source/WebKit2/WebProcess/Plugins/Plugin.h:268:77: error: ISO C++ forbids declaration of 'parameter' with no type [-fpermissive]
        cc1plus: warning: unrecognized command line option "-Wno-c++11-extensions" [enabled by default]
        make[1]: *** [Source/WebKit2/PluginProcess/libwebkit2gtk_3_0_la-PluginCreationParameters.lo] Error 1

        It now passes that make target.

        https://bugs.webkit.org/show_bug.cgi?id=111862

        Reviewed by Darin Adler.

        * WebProcess/Plugins/Plugin.h:
        (WebCore): Added FloatPoint to the WebCore namespace

2013-04-08  Anders Carlsson  <andersca@apple.com>

        Remove unneeded headers from FrameLoader.h
        https://bugs.webkit.org/show_bug.cgi?id=114223

        Reviewed by Geoffrey Garen.

        Include HistoryController.h from WebCore.

        * WebProcess/Plugins/PDF/SimplePDFPlugin.h:
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        * WebProcess/WebPage/WebPage.cpp:

2013-04-09  Geoffrey Garen  <ggaren@apple.com>

        Removed bitrotted TimeoutChecker code
        https://bugs.webkit.org/show_bug.cgi?id=114336

        Reviewed by Alexey Proskuryakov.

        This mechanism hasn't worked for a while.

        MarkL is working on a new version of this feature with a distinct
        implementation.

        * WebProcess/Plugins/Netscape/NPJSObject.cpp:
        (WebKit::NPJSObject::construct):
        (WebKit::NPJSObject::invoke):
        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.cpp:
        (WebKit::NPRuntimeObjectMap::evaluate):

2013-04-09  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/13617144> WKNavigationData needs to expose the destination of the navigation

        Introduce WKNavigationDataCopyNavigationDestinationURL to access the destination of the navigation.

        Reviewed by Dan Bernstein.

        * UIProcess/API/C/WKNavigationData.cpp:
        (WKNavigationDataCopyURL): Add a note about returning the URL from the original request for sake of
        backwards-compatibility.
        (WKNavigationDataCopyNavigationDestinationURL): Return the URL from our underlying WebNavigationDataStore.
        * UIProcess/API/C/WKNavigationData.h:
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::updateGlobalHistory): Store the current URL in to the WebNavigationDataStore
        object. WKNavigationData can retrieve the value that we were previously storing here via the originalRequest.

2013-04-09  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/13617104> WKPageCopySessionState needs to provide more context to the filter callback

        Introduce a new value type for WKPageSessionStateFilterCallback that represents the passing
        of whole WKBackForwardListItemRefs to the filter callback. This allows clients to consider
        more than the original URL of the item when filtering entries from the session state.

        Reviewed by Darin Adler.

        * UIProcess/API/C/WKPage.cpp:
        (WKPageGetSessionBackForwardListItemValueType): Return a static string representing our new value type.
        * UIProcess/API/C/WKPage.h:
        * UIProcess/cf/WebBackForwardListCF.cpp:
        (WebKit::WebBackForwardList::createCFDictionaryRepresentation): Call the filter function with each of the
        possible value types in turn, respecting the first false value, if any, that is returned.

2013-04-10  Anton Obzhirov  <a.obzhirov@samsung.com>

        [GTK] Add support for Page Visibility
        https://bugs.webkit.org/show_bug.cgi?id=97324

        Reviewed by Sam Weinig.

        Added new unittest to test page visibility using GTK Widget visibility API.

        * UIProcess/API/gtk/tests/TestWebKitWebView.cpp:
        (testWebViewPageVisibility):
        (beforeAll):
        * UIProcess/API/gtk/tests/WebViewTest.cpp:
        (WebViewTest::showInWindow):
        * UIProcess/API/gtk/tests/WebViewTest.h:

2013-04-10  Zan Dobersek  <zdobersek@igalia.com>

        REGRESSION (r146518): WebKit2APITests/TestInspector is failing
        https://bugs.webkit.org/show_bug.cgi?id=113281

        Reviewed by Darin Adler.

        Changes to the WebInspectorProxy opening processing in r146518 caused the change in how the GTK-specific
        WebInspectorProxy code operates, specifically the 'bring-to-front' signal is not emitted anymore when opening the
        inspector due to the WebInspectorProxy::bringToFront method now only bringing the inspector window to front if it exists
        and opening it (and thus unable to bring it to front) otherwise.

        Closing of the inspector through the didClose method is now done immediately after sending the WebInspector::Close()
        message to the WebProcess rather than waiting for the WebProcess to communicate back the order of closing. Due to this
        the relevant code in the test cases had to be changed to not run the loop but rather just check that the closing was
        successful.

        (InspectorTest::InspectorTest): Remove the initialization of the now redundant m_quitOnBringToFront member variable.
        (InspectorTest::bringToFront): Quit the loop without checking the removed member variable.
        (InspectorTest::closed): Do not quit the loop as it is not run anymore.
        (InspectorTest::showIdle): A helper method that asynchronously calls the webkit_web_inspector_show method, removing some
        unnecessary complexity about under what exact circumstances to quit the loop in open-window/bring-to-front callbacks.
        (InspectorTest::show): Replaces the showAndWaitUntilFinished method, adding an idle invocation of the showIdle helper
        method and running the loop.
        (InspectorTest::close): Formerly closeAndWaitUntilClosed, now does not run the loop anymore as there's no need for it.
        (testInspectorDefault): Only the window opening event is now expected upon showing the inspector for the first time.
        Adjusting callsites to use InspectorTest::show and InspectorTest::close instead of
        InspectorTest::showAndWaitUntilFinished and InspectorTest::showAndWaitUntilFinished.
        (CustomInspectorTest::destroyWindow): Formerly destroyWindowAndWaitUntilClosed, the closing is not asynchronous anymore
        so the loop is not run.
        (testInspectorManualAttachDetach): Only the window opening event is now expected upon showing the inspector for the first time.
        Adjusting callsites to use InspectorTest::show and InspectorTest::close instead of
        InspectorTest::showAndWaitUntilFinished and InspectorTest::showAndWaitUntilFinished.
        (testInspectorCustomContainerDestroyed): Adjusting callsites to use InspectorTest::show and CustomInspectorTest::destroyWindow
        instead of InspectorTest::showAndWaitUntilFinished and CustomInspectorTest::destroyWindowAndWaitUntilClosed.
        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::WebInspectorProxy::show): When showing a connected WebInspectorProxy, call the bringToFront method which will
        open the inspector if it's not yet visible or bring it to the front otherwise. 

2013-04-10  Zan Dobersek  <zandobersek@gmail.com>

        [GTK][WK2] Implement WebInspectorProxy::platformInspectedWindowWidth
        https://bugs.webkit.org/show_bug.cgi?id=113498

        Reviewed by Martin Robinson.

        The method was introduced in r147004.

        * UIProcess/API/gtk/tests/TestInspector.cpp: Specify the gMinimumAttachedInspectorWidth variable, reflecting the value
        of WebInspectorProxy::minimumAttachedWidth. Use it as the width to which the inspected view should be resized in
        InspectorTest::resizeViewAndAttach.
        * UIProcess/gtk/WebInspectorProxyGtk.cpp:
        (WebKit::WebInspectorProxy::platformInspectedWindowHeight): Use the gtk_widget_get_allocated_height method to return the
        widget height.
        (WebKit::WebInspectorProxy::platformInspectedWindowWidth): Newly implemented, similarly uses the
        gtk_widget_get_allocated_width method to return the widget width.

2013-04-09  Antoine Quint  <graouts@apple.com>

        WKFrameIsDisplayingMarkupDocument should return true for Web Archives
        https://bugs.webkit.org/show_bug.cgi?id=114291

        Reviewed by Dean Jackson.

        Also return true for the Web Archive MIME type since a Web Archive
        is displaying a markup document by nature.

        * UIProcess/WebFrameProxy.cpp:
        (WebKit::WebFrameProxy::isDisplayingMarkupDocument):

2013-04-09  Anders Carlsson  <andersca@apple.com>

        REGRESSION (r147454): Youtube annotation links to new window broken
        https://bugs.webkit.org/show_bug.cgi?id=114242
        <rdar://problem/13609940>

        Reviewed by Beth Dakin.

        Set the current user gesture to "DefinitelyProcessingNewUserGesture" if popups are allowed.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::performFrameLoadURLRequest):

2013-04-09  Anders Carlsson  <andersca@apple.com>

        If we fail to decode a message name, pass the message length as the name
        https://bugs.webkit.org/show_bug.cgi?id=114305
        <rdar://problem/13605703>

        Reviewed by Sam Weinig.

        * Platform/CoreIPC/ArgumentDecoder.h:
        (CoreIPC::ArgumentDecoder::length):
        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::processIncomingMessage):

2013-04-08  Dean Jackson  <dino@apple.com>

        Don't create another plugin process for restarted plugins
        https://bugs.webkit.org/show_bug.cgi?id=114233

        Reviewed by Geoff Garen.

        A snapshotting plugin starts in a separate process from
        regular plugins. This can be a little confusing to users
        because they might see two plugin processes. We can set
        the minimum life and timeout on the snapshotting process
        to much smaller values, since the process doesn't need
        to live that long. This will reduce some potential
        confusion. Also, since there is another plugin process
        running real plugins, it should be paged in if it needs
        to restart.

        There was, however, a bug in the process management. A
        restarted plugin received a special PluginProcess::Type,
        so that it could cross fade into the page nicely. This
        caused it to start a *third* plugin process. Instead
        mark a restarted flag directly on the PluginProxy and
        revert back to two process types.

        * PluginProcess/PluginProcess.h: Remove TypeRestartedProcess.

        * UIProcess/Plugins/PluginProcessProxy.cpp: Add two new
            timeout values for snapshotting processes.
        (WebKit::PluginProcessProxy::didFinishLaunching): Chose which
            of the timeout pairs to use.

        * WebProcess/Plugins/Netscape/mac/PluginProxyMac.mm:
        (WebKit::PluginProxy::pluginLayer): Don't look at the process type, instead
            look at the process flag to see if we are restarted.
        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::create): Copy the new flag into constructor.
        (WebKit::PluginProxy::PluginProxy): Remember the flag.
        * WebProcess/Plugins/PluginProxy.h: Add a new m_restartedProcess flag.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::createPlugin): When we are creating the proxy, separate
            the concept of snapshotting and restarting.

2013-04-09  Tim Horton  <timothy_horton@apple.com>

        [wk2] IconDatabase images should be decoded in the WebProcess
        https://bugs.webkit.org/show_bug.cgi?id=112524
        <rdar://problem/10133914>

        Reviewed by Oliver Hunt.

        In the interests of keeping decoding of data coming in from the greater Internet
        in the WebProcess, move decoding of favicons from the UIProcess to the WebProcess.

        * UIProcess/WebIconDatabase.cpp:
        (WebKit::WebIconDatabase::setIconBitmapForIconURL):
        Receive a ShareableBitmap handle from the WebProcess instead of a DataReference.
        Use the new setIconBitmapForIconURL IconDatabase method.

        * UIProcess/WebIconDatabase.h:
        (WebIconDatabase):
        Rename setIconDataForIconURL to setIconBitmapForIconURL.

        * UIProcess/WebIconDatabase.messages.in: Ditto.

        * WebProcess/IconDatabase/WebIconDatabaseProxy.cpp:
        (WebKit::WebIconDatabaseProxy::setIconDataForIconURL):
        In the WebProcess, decode the incoming icon and draw it into a ShareableBitmap.

2013-04-09  Raphael Kubo da Costa  <raphael.kubo.da.costa@intel.com>

        [EFL] Declare TEST_THEME_DIR in a single place.
        https://bugs.webkit.org/show_bug.cgi?id=114285

        Reviewed by Anders Carlsson.

        * PlatformEfl.cmake: Remove definition of `TEST_THEME_DIR', which is
        now defined in OptionsEfl.cmake.

2013-04-09  Rafael Brandao  <rafael.lobo@openbossa.org>

        [CoordinatedGraphics] serviceScriptedAnimations expects time in seconds
        https://bugs.webkit.org/show_bug.cgi?id=112582

        Reviewed by Andreas Kling.

        We've been exposing different time unit for requestAnimationFrame because
        of wrong conversion before serviceScriptedAnimations function calls.
        Fixed it to use seconds instead of milliseconds.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::syncDisplayState): Remove unnecessary conversion.

2013-04-09  Michael Brüning  <michael.bruning@digia.com>

        [Qt][WK2] Remove obsolete QtWebPageFindClient forward declaration from qquickwebview_p.h.
        https://bugs.webkit.org/show_bug.cgi?id=114284

        Reviewed by Andreas Kling.

        The class QtWebPageFindClient was removed in r142073 when the functionality
        was folded into QQuickWebViewPrivate.

        * UIProcess/API/qt/qquickwebview_p.h:
        (WebKit):

2013-04-09  Michael Brüning  <michael.bruning@digia.com>

        Fix GTK WebKit2 build after r148005.
        https://bugs.webkit.org/show_bug.cgi?id=114270

        Reviewed by Andreas Kling.

        Fix GTK build break that went through the buildbot undetected.

        * UIProcess/API/gtk/WebKitFileChooserRequest.cpp:
        (webkit_file_chooser_request_get_selected_files):

2013-04-09  Michael Brüning  <michael.bruning@digia.com>

        [Qt][WK2] Remove direct references to WebPageProxy from QQuickWebPage.
        https://bugs.webkit.org/show_bug.cgi?id=112850

        Reviewed by Andreas Kling.

        Removes direct references to WebPageProxy from QQuickWebPage and prepares the
        class for the move to QRawWebView. The access to the device scale factor and
        CoordinatedGraphicsScene is provided through QQuickWebViewPrivate, and therefore
        accessors to these properties are temporarily added. Eventually, this access will
        be provided through QRawWebView when the move is complete.

        This also moves the pointer to QtWebPageEventHandler from QQuickWebPagePrivate
        to QQuickWebViewPrivate as it is mainly used from there.

        * UIProcess/API/qt/qquickwebpage.cpp:
        (QQuickWebPagePrivate::QQuickWebPagePrivate):
        (QQuickWebPagePrivate::paint):
        (QQuickWebPage::updatePaintNode):
        * UIProcess/API/qt/qquickwebpage_p.h:
        * UIProcess/API/qt/qquickwebpage_p_p.h:
        (QQuickWebPagePrivate):
        * UIProcess/API/qt/qquickwebview.cpp:
        (QQuickWebViewPrivate::initialize):
        (QQuickWebViewPrivate::handleMouseEvent):
        (QQuickWebViewPrivate::processDidCrash):
        (QQuickWebViewPrivate::coordinatedGraphicsScene):
        (QQuickWebViewPrivate::deviceScaleFactor):
        (QQuickWebViewPrivate::setIntrinsicDeviceScaleFactor):
        (QQuickWebViewFlickablePrivate::onComponentComplete):
        (QQuickWebView::keyPressEvent):
        (QQuickWebView::keyReleaseEvent):
        (QQuickWebView::inputMethodEvent):
        (QQuickWebView::focusInEvent):
        (QQuickWebView::itemChange):
        (QQuickWebView::touchEvent):
        (QQuickWebView::wheelEvent):
        (QQuickWebView::hoverEnterEvent):
        (QQuickWebView::hoverMoveEvent):
        (QQuickWebView::hoverLeaveEvent):
        (QQuickWebView::dragMoveEvent):
        (QQuickWebView::dragEnterEvent):
        (QQuickWebView::dragLeaveEvent):
        (QQuickWebView::dropEvent):
        * UIProcess/API/qt/qquickwebview_p_p.h:
        (WebCore):
        (WebKit):
        (QQuickWebViewPrivate):

2013-04-09  Michael Brüning  <michael.bruning@digia.com>

        [Qt][WK2] Use C API to enable Navigator Qt Object.
        https://bugs.webkit.org/show_bug.cgi?id=112810

        Reviewed by Andreas Kling.

        Replace the direct reference to the WebPageProxy with use of
        C API.

        * UIProcess/API/qt/qquickwebview.cpp:
        (QQuickWebViewPrivate::setNavigatorQtObjectEnabled):

2013-04-09  Michael Brüning  <michael.bruning@digia.com>

        [WK2] Add C API to copy selected files from WebOpenPanelParameters.
        https://bugs.webkit.org/show_bug.cgi?id=112339

        Reviewed by Andreas Kling.

        Replaces the existing WebOpenPanelParameters::selectedFileNames() method
        to return a copy of the selected file names and exposes it through the
        C API. This is done in order to reduce the direct use of WebKit2 internal
        classes. The implementation is very similar to the one in 
        WebOpenPanelParameters::acceptMIMETypes().

        This also updates the GTK port, which is the other user of selectedFileNames.

        * Shared/WebOpenPanelParameters.cpp:
        (WebKit::WebOpenPanelParameters::selectedFileNames):
        (WebKit):
        * Shared/WebOpenPanelParameters.h:
        (WebOpenPanelParameters):
        * UIProcess/API/C/WKOpenPanelParameters.cpp:
        (WKOpenPanelParametersCopySelectedFileNames):
        * UIProcess/API/C/WKOpenPanelParameters.h:
        * UIProcess/API/gtk/WebKitFileChooserRequest.cpp:
        (webkit_file_chooser_request_get_selected_files):
        * UIProcess/qt/QtWebPageUIClient.cpp:
        (WebKit::QtWebPageUIClient::runOpenPanel):

2013-04-09  Jinwoo Song  <jinwoo7.song@samsung.com>

        [WK2] Remove build warnings for unused parameters
        https://bugs.webkit.org/show_bug.cgi?id=114234

        Reviewed by Andreas Kling.

        Fix build warnings -Wunused-parameter.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::SessionStorageNamespace::cloneTo):
        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::requestNetworkingStatistics):
        (WebKit::WebContext::pluginInfoStoreDidLoadPlugins):
        * WebProcess/Storage/StorageAreaProxy.cpp:
        (WebKit::StorageAreaProxy::removeItem):
        (WebKit::StorageAreaProxy::clear):
        (WebKit::StorageAreaProxy::dispatchSessionStorageEvent):
        (WebKit::StorageAreaProxy::dispatchLocalStorageEvent):
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::didUninstallPageOverlay):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::didFinishLoad):
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::shouldPlugInAutoStartFromOrigin):

2013-04-09  Thiago Marcos P. Santos  <thiago.santos@intel.com>

        [WK2] Drop WebProcess capabilities on Linux using seccomp filters
        https://bugs.webkit.org/show_bug.cgi?id=89875

        Reviewed by Maciej Stachowiak.

        Introduce the foundations of the SeccompFilter-based sandbox. The
        hardening of the WebProcess (and potentially PluginProcess, etc)
        works by a combination of the two things:

        - Blocking syscalls that are not used, reducing the size of the attack
        surface.
        - Trapping sensitive syscalls and delegating the execution of these
        syscalls to a separated trusted process subject to a set of policies.

        The initial implementation traps the open()-family of syscalls on WebKit
        EFL's and Qt's WebProcess, but it could be easily used by any Linux port,
        since the code is suppose to be Linux-compliant. The list of syscalls handled
        by the broker process should definitely grow as we mature the
        implementation. Other syscalls needs to be handled to get this sandbox
        fully functional, like unlink(), mkdir(), etc.

        The broker process should be initialized as early as possible on the
        sandboxed process main() function, because it only does a fork(), which
        is cheap on Linux. That also aims to minimize the resident memory footprint
        of the broker process.

        Opening of files for upload and saving downloads is not supported yet,
        since it should be handled to the UIProcess in a similar fashion as
        the Mac port does.

        * PlatformEfl.cmake:
        * Shared/linux/SeccompFilters/OpenSyscall.cpp: Added.
        (WebKit):
        (WebKit::OpenSyscall::createFromOpenatContext):
        (WebKit::OpenSyscall::createFromCreatContext):
        (WebKit::OpenSyscall::OpenSyscall):
        (WebKit::OpenSyscall::setResult):
        (WebKit::OpenSyscall::execute):
        (WebKit::OpenSyscall::encode):
        (WebKit::OpenSyscall::decode):
        (WebKit::OpenSyscallResult::OpenSyscallResult):
        (WebKit::OpenSyscallResult::~OpenSyscallResult):
        (WebKit::OpenSyscallResult::encode):
        (WebKit::OpenSyscallResult::decode):
        * Shared/linux/SeccompFilters/OpenSyscall.h: Added.
        (CoreIPC):
        (WebKit):
        (OpenSyscall):
        (WebKit::OpenSyscall::setPath):
        (WebKit::OpenSyscall::setFlags):
        (WebKit::OpenSyscall::setMode):
        (OpenSyscallResult):
        (WebKit::OpenSyscallResult::fd):
        (WebKit::OpenSyscallResult::errorNumber):
        * Shared/linux/SeccompFilters/SeccompBroker.cpp: Added.
        (WebKit):
        (SeccompBrokerClient):
        (WebKit::sendMessage):
        (WebKit::receiveMessage):
        (WebKit::SIGSYSHandler):
        (WebKit::registerSIGSYSHandler):
        (WebKit::SeccompBrokerClient::shared):
        (WebKit::SeccompBrokerClient::SeccompBrokerClient):
        (WebKit::SeccompBrokerClient::~SeccompBrokerClient):
        (WebKit::SeccompBrokerClient::dispatch):
        (WebKit::SeccompBrokerClient::handleIfOpeningOnlineCPUCount):
        (WebKit::SeccompBroker::launchProcess):
        (WebKit::SeccompBroker::initialize):
        (WebKit::SeccompBroker::runLoop):
        * Shared/linux/SeccompFilters/SeccompBroker.h: Added.
        (WebKit):
        (SeccompBroker):
        (WebKit::SeccompBroker::setSyscallPolicy):
        (WebKit::SeccompBroker::SeccompBroker):
        * Shared/linux/SeccompFilters/SeccompFilters.cpp: Added.
        (WebKit):
        (WebKit::SeccompFilters::SeccompFilters):
        (WebKit::SeccompFilters::~SeccompFilters):
        (WebKit::SeccompFilters::addRule):
        (WebKit::SeccompFilters::initialize):
        * Shared/linux/SeccompFilters/SeccompFilters.h: Added.
        (WebKit):
        (SeccompFilters):
        (WebKit::SeccompFilters::context):
        (WebKit::SeccompFilters::platformInitialize):
        * Shared/linux/SeccompFilters/SigactionSyscall.cpp: Added.
        (WebKit):
        (WebKit::SigactionSyscall::createFromContext):
        * Shared/linux/SeccompFilters/SigactionSyscall.h: Added.
        (WebKit):
        (SigactionSyscall):
        * Shared/linux/SeccompFilters/SigprocmaskSyscall.cpp: Added.
        (WebKit):
        (WebKit::SigprocmaskSyscall::createFromContext):
        * Shared/linux/SeccompFilters/SigprocmaskSyscall.h: Added.
        (WebKit):
        (SigprocmaskSyscall):
        * Shared/linux/SeccompFilters/Syscall.cpp: Added.
        (WebKit):
        (WebKit::Syscall::createFromContext):
        (WebKit::Syscall::createFromDecoder):
        (WebKit::Syscall::Syscall):
        (WebKit::SyscallResult::createFromDecoder):
        (WebKit::SyscallResult::SyscallResult):
        * Shared/linux/SeccompFilters/Syscall.h: Added.
        (CoreIPC):
        (WebKit):
        (Syscall):
        (WebKit::Syscall::~Syscall):
        (WebKit::Syscall::type):
        (WebKit::Syscall::setContext):
        (WebKit::Syscall::context):
        (SyscallResult):
        (WebKit::SyscallResult::~SyscallResult):
        (WebKit::SyscallResult::type):
        * Shared/linux/SeccompFilters/SyscallPolicy.cpp: Added.
        (WebKit):
        (WebKit::removeTrailingSlash):
        (WebKit::SyscallPolicy::hasPermissionForPath):
        (WebKit::SyscallPolicy::addFilePermission):
        (WebKit::SyscallPolicy::addDirectoryPermission):
        (WebKit::SyscallPolicy::addDefaultWebProcessPolicy):
        * Shared/linux/SeccompFilters/SyscallPolicy.h: Added.
        (WebKit):
        (SyscallPolicy):
        * Target.pri:
        * WebKit2.pri:
        * WebProcess/efl/SeccompFiltersWebProcessEfl.cpp: Added.
        (WebKit):
        (WebKit::SeccompFiltersWebProcessEfl::SeccompFiltersWebProcessEfl):
        (WebKit::SeccompFiltersWebProcessEfl::platformInitialize):
        * WebProcess/efl/SeccompFiltersWebProcessEfl.h: Added.
        (WebKit):
        (SeccompFiltersWebProcessEfl):
        * WebProcess/qt/SeccompFiltersWebProcessQt.cpp: Added.
        (WebKit):
        (WebKit::SeccompFiltersWebProcessQt::SeccompFiltersWebProcessQt):
        (WebKit::SeccompFiltersWebProcessQt::platformInitialize):
        * WebProcess/qt/SeccompFiltersWebProcessQt.h: Added.
        (WebKit):
        (SeccompFiltersWebProcessQt):
        * WebProcess/qt/WebProcessQt.cpp:
        (WebKit::WebProcess::platformInitializeWebProcess):
        * WebProcess/soup/WebProcessSoup.cpp:
        (WebKit::WebProcess::platformInitializeWebProcess):

2013-04-08  Grzegorz Czajkowski  <g.czajkowski@samsung.com>

        [WK2][EFL] Mark not implemented methods in TextCheckerEfl.
        https://bugs.webkit.org/show_bug.cgi?id=112261

        Reviewed by Anders Carlsson.

        There's no need to call client's methods in TextCheckerEfl.cpp if they are not
        implemented. Mark them as not implemented until we provide proper implementation.

        * UIProcess/efl/TextCheckerEfl.cpp:
        (WebKit::TextChecker::isContinuousSpellCheckingAllowed):
        (WebKit::TextChecker::setGrammarCheckingEnabled):
        (WebKit::TextChecker::grammarCheckingEnabledStateChanged):
        (WebKit::TextChecker::checkGrammarOfString):
        (WebKit::TextChecker::spellingUIIsShowing):
        (WebKit::TextChecker::toggleSpellingUIIsShowing):
        (WebKit::TextChecker::updateSpellingUIWithMisspelledWord):
        (WebKit::TextChecker::updateSpellingUIWithGrammarString):

2013-04-08  Benjamin Poulain  <benjamin@webkit.org>

        Remove HTML Notification
        https://bugs.webkit.org/show_bug.cgi?id=114231

        Reviewed by Ryosuke Niwa.

        * Configurations/FeatureDefines.xcconfig:

2013-04-08  Tim Horton  <timothy_horton@apple.com>

        Don't run primary plugin detection if plugin snapshotting is off
        https://bugs.webkit.org/show_bug.cgi?id=114222
        <rdar://problem/13603988>

        Reviewed by Dean Jackson.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::determinePrimarySnapshottedPlugIn):

2013-04-08  Patrick Gansterer  <paroga@webkit.org>

        [WIN] Remove WebKit2 source code
        https://bugs.webkit.org/show_bug.cgi?id=114096

        Reviewed by Anders Carlsson.

        Remove conditional includes for the windows platform.

        * Shared/API/c/WKBase.h:
        * UIProcess/API/C/WKAPICast.h:

2013-04-08  Geoffrey Garen  <ggaren@apple.com>

        Stop #include-ing all of JavaScriptCore in every DOM-related file
        https://bugs.webkit.org/show_bug.cgi?id=114220

        Reviewed by Sam Weinig.

        * Shared/WebCoreArgumentCoders.cpp:
        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.h:

2013-04-08  Brady Eidson  <beidson@apple.com>

        Web/Plugin process deadlock initializing async plugins.
        <rdar://problem/13525232> and https://bugs.webkit.org/show_bug.cgi?id=114217

        Reviewed by Anders Carlsson.

       The "Async initialization complete" messages probably don't have to be synchronous.

        * PluginProcess/WebProcessConnection.cpp:
        (WebKit::WebProcessConnection::createPluginAsynchronously): Notify of initialization success/failure asynchronously.
        * WebProcess/Plugins/PluginProxy.messages.in: 

2013-04-08  Anders Carlsson  <andersca@apple.com>

        Add an async version of ResourceHandle::didReceiveResponse
        https://bugs.webkit.org/show_bug.cgi?id=114215

        Reviewed by Sam Weinig.

        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::didReceiveResponseAsync):
        Send the message and then call continueDidReceiveResponse.

2013-04-08  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Build Platform as a separate static library
        https://bugs.webkit.org/show_bug.cgi?id=114164

        Reviewed by Martin Robinson.

        This way we reduce a bit the amount of files compiled twice
        because of the plugin process.

        * GNUmakefile.am:
        * GNUmakefile.list.am:
        * Platform/gtk/WorkQueueGtk.cpp: Remove unused header.
        * Platform/unix/SharedMemoryUnix.cpp: Ditto.

2013-04-08  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [WK2][EFL] WebView: Add callbacks to the WKViewClient to remove direct access to page viewport controller
        https://bugs.webkit.org/show_bug.cgi?id=110741

        Reviewed by Anders Carlsson.

        Provided WKViewClient with didRequestScroll, didRenderFrame and didCompletePageTransition
        callbacks so that direct access from WebView to page viewport controller is avoided.

        Implementation of callbacks is also added to keep the current EFL WK2 functionality.

        * UIProcess/API/C/efl/WKView.h:
        * UIProcess/efl/PageLoadClientEfl.cpp:
        (WebKit::PageLoadClientEfl::didCommitLoadForFrame):

            Moved here code from deleted WebView::didCommitLoad.

        * UIProcess/efl/ViewClientEfl.cpp:
        (WebKit::ViewClientEfl::didChangeContentsPosition):
        (WebKit):
        (WebKit::ViewClientEfl::didRenderFrame):
        (WebKit::ViewClientEfl::didCompletePageTransition):
        (WebKit::ViewClientEfl::ViewClientEfl):
        * UIProcess/efl/ViewClientEfl.h:
        (ViewClientEfl):
        * UIProcess/efl/WebView.cpp:
        (WebKit::WebView::pageDidRequestScroll):
        (WebKit::WebView::didRenderFrame):
        (WebKit::WebView::pageTransitionViewportReady):
        * UIProcess/efl/WebViewClient.cpp:
        (WebKit::WebViewClient::didChangeContentsPosition):
        (WebKit):
        (WebKit::WebViewClient::didRenderFrame):
        (WebKit::WebViewClient::didCompletePageTransition):
        * UIProcess/efl/WebViewClient.h:
        (WebCore):

2013-04-08  Andras Becsi  <andras.becsi@digia.com>

        [Qt][WK2] WebView's interactive property is not fully respected
        https://bugs.webkit.org/show_bug.cgi?id=113066

        Reviewed by Jocelyn Turcotte.

        WK2 sign-off by Benjamin Poulain.

        The QML WebView inherits the "interactive" property from Flickable
        which is true by default, and disables the interaction with the
        Flickable if set to false.
        Resulting from the design of the WebView panning and flicking is
        disabled by Flickable but to be consistent we also need to disable
        double-tap gestures and pinch gestures since they would trigger
        scale and position changes.

        * UIProcess/qt/PageViewportControllerClientQt.cpp:
        (WebKit::PageViewportControllerClientQt::pinchGestureStarted):
        (WebKit::PageViewportControllerClientQt::pinchGestureRequestUpdate):
        (WebKit::PageViewportControllerClientQt::pinchGestureEnded):
        * UIProcess/qt/QtWebPageEventHandler.cpp:
        (WebKit::QtWebPageEventHandler::handleDoubleTapEvent):

2013-04-07  David Kilzer  <ddkilzer@apple.com>

        Remove the rest of SVG_DOM_OBJC_BINDINGS
        <http://webkit.org/b/114112>

        Reviewed by Geoffrey Garen.

        * Configurations/FeatureDefines.xcconfig:
        - Remove ENABLE_SVG_DOM_OBJC_BINDINGS macro.

2013-04-06  Geoffrey Garen  <ggaren@apple.com>

        Try to fix the WebKit2 build.

        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit):
        * NetworkProcess/NetworkResourceLoader.h:
        (NetworkResourceLoader): Removed a defunct function.

2013-04-05  Ed Bartosh  <bartosh@gmail.com>

        [WK2] --no-tiled-backing-store build fails because FloatPoint is not declared
        https://bugs.webkit.org/show_bug.cgi?id=113618

        Reviewed by Simon Fraser.

        * WebProcess/Plugins/Plugin.h: Forward declared FloatPoint

2013-04-05  Geoffrey Garen  <ggaren@apple.com>

        Made USE(JSC) unconditional
        https://bugs.webkit.org/show_bug.cgi?id=114058

        Reviewed by Anders Carlsson.

        * Shared/linux/WebMemorySamplerLinux.cpp:
        (WebKit::WebMemorySampler::sampleWebKit):
        * config.h:

2013-04-05  Ed Bartosh  <bartosh@gmail.com>

        [EFL] --no-tiled-backing-store build fails because of not used #if USE(ACCELERATED_COMPOSITING)
        https://bugs.webkit.org/show_bug.cgi?id=113627

        Reviewed by Simon Fraser.

        Wrapped code with #if USE(ACCELERATED_COMPOSITING) to make it compilable
        with --no-tiled-backing-store build option:
        * UIProcess/API/C/efl/WKView.cpp:
        * UIProcess/API/efl/EvasGLContext.cpp:
        * UIProcess/API/efl/EvasGLContext.h:
        * UIProcess/API/efl/EvasGLSurface.cpp:
        * UIProcess/API/efl/EvasGLSurface.h:
        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::EwkView):
        (EwkView::displayTimerFired):
        (EwkView::takeSnapshot):
        * UIProcess/API/efl/EwkView.h:
        (WebKit):
        (EwkView):
        * UIProcess/API/efl/SnapshotImageGL.cpp:
        * UIProcess/API/efl/SnapshotImageGL.h:
        * UIProcess/PageViewportController.cpp:
        * UIProcess/PageViewportController.h:
        * UIProcess/efl/PageViewportControllerClientEfl.cpp:
        * UIProcess/efl/ViewClientEfl.cpp:
        (WebKit::ViewClientEfl::didChangeContentsSize):
        * UIProcess/efl/WebView.cpp:
        (WebKit::WebView::didCommitLoad):
        (WebKit::WebView::updateViewportSize):
        (WebKit::WebView::didChangeViewportProperties):
        (WebKit::WebView::pageDidRequestScroll):
        (WebKit::WebView::didRenderFrame):
        (WebKit::WebView::pageTransitionViewportReady):

2013-04-05  Ed Bartosh  <bartosh@gmail.com>

        [EFL][WK2] --no-tiled-backing-store build fails because of not used #if USE(COORDINATED_GRAPHICS)
        https://bugs.webkit.org/show_bug.cgi?id=113629

        Reviewed by Simon Fraser.

        Wrapped code related to coordinated graphics with #if USE(COORDINATED_GRAPHICS)
        * UIProcess/API/CoordinatedGraphics/WKCoordinatedScene.cpp:
        * UIProcess/efl/WebView.cpp:
        (WebKit::WebView::initialize):
        (WebKit):
        (WebKit::WebView::paintToCairoSurface):
        (WebKit::WebView::updateViewportSize):

2013-04-05  Timothy Hatcher  <timothy@apple.com>

        Allow the Web Inspector to use WebSQL.

        This fixes an exception on load in the Safari Web Inspector.

        https://webkit.org/b/114040
        rdar://problem/13581422

        Reviewed by Anders Carlsson.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::exceededDatabaseQuota): Added.
        (WebKit::WebInspectorProxy::platformCreateInspectorPage): Hook up exceededDatabaseQuota.

2013-04-04  Brady Eidson  <beidson@apple.com>

        Add SPI to get a copy of the context menu at a given point.
        <rdar://problem/13450908> and https://bugs.webkit.org/show_bug.cgi?id=113958

        Reviewed by Andy Estes.

        Add the new accessor: 
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::contextMenuAtPoint):
        * WebProcess/WebPage/WebPage.h:

        Expose the new SPI:
        * WebProcess/InjectedBundle/API/c/WKBundlePage.cpp:
        (WKBundlePageCopyContextMenuAtPoint):
        * WebProcess/InjectedBundle/API/c/WKBundlePagePrivate.h:

2013-04-05  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [WK2][EFL] WebView should own page position and scale factor
        https://bugs.webkit.org/show_bug.cgi?id=111075

        Reviewed by Andreas Kling.

        View content position and content scale factor should belong to WebView
        rather than to EwkView as it decreases EwkView usage inside EFL-agnostic
        WebView and improves WebView encapsulation.

        * UIProcess/API/C/efl/WKView.cpp:
        (WKViewGetContentScaleFactor):
        (WKViewSetContentScaleFactor):

            New WKView API was added to set and get content scale factor.
            The view content scale factor is not the same as page scale factor:
            it always applies to content but not necessarily applies to the page.
            The view content scale factor is calculated by viewport controller
            and applies immediately for painting in UI process. Page scale factor
            is updated later after the frame is rendered to accomplish the pending
            scale change.

        (WKViewGetContentPosition):
        (WKViewSetContentPosition):

            New WKView API was added to set and get content position.
            Content position is set in UI units.

        * UIProcess/API/C/efl/WKView.h:
        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::EwkView):
        * UIProcess/API/efl/EwkView.h:
        (EwkView):
        * UIProcess/efl/PageViewportControllerClientEfl.cpp:
        (WebKit::PageViewportControllerClientEfl::setViewportPosition):
        (WebKit::PageViewportControllerClientEfl::setPageScaleFactor):
        * UIProcess/efl/WebView.cpp:
        (WebKit::WebView::WebView):
        (WebKit::WebView::paintToCairoSurface):
        (WebKit::WebView::transformToScene):
        (WebKit::WebView::updateViewportSize):
        (WebKit::WebView::pageDidRequestScroll):
        * UIProcess/efl/WebView.h:
        (WebKit::WebView::setContentScaleFactor):
        (WebKit::WebView::contentScaleFactor):
        (WebView):
        (WebKit::WebView::setContentPosition):
        (WebKit::WebView::contentPosition):

2013-04-05  Alberto Garcia  <agarcia@igalia.com>

        [GTK][WK2] WebKitLoaderClient: add missing initializers
        https://bugs.webkit.org/show_bug.cgi?id=112961

        Reviewed by Carlos Garcia Campos.

        There are two new attributes: pluginLoadPolicy and pluginDidFail.

        * UIProcess/API/gtk/WebKitLoaderClient.cpp:
        (attachLoaderClientToView):

2013-04-05  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [WK2][EFL] Encapsulate view states set-up within WebView
        https://bugs.webkit.org/show_bug.cgi?id=110877

        Reviewed by Benjamin Poulain.

        View states set-up is encapsulated within WebView. This change
        reduces both usage of EwkView inside WebView class and usage of
        WebPageProxy inside EwkView class.

        New WKView API was added so that EwkView can define whether or not
        the view is visible and focused.

        * UIProcess/API/C/efl/WKView.cpp:
        (WKViewIsFocused):
        (WKViewSetIsFocused):
        (WKViewIsVisible):
        (WKViewSetIsVisible):
        * UIProcess/API/C/efl/WKView.h:
        * UIProcess/API/efl/EwkView.cpp:
        (::handleEvent):
        (EwkView::handleEvasObjectShow):
        (EwkView::handleEwkViewFocusIn):
        (EwkView::handleEwkViewFocusOut):
        * UIProcess/API/efl/EwkView.h:
        * UIProcess/efl/WebView.cpp:
        (WebKit::WebView::WebView):
        (WebKit::WebView::setFocused):
        (WebKit):
        (WebKit::WebView::setVisible):
        (WebKit::WebView::isViewFocused):
        (WebKit::WebView::isViewVisible):
        * UIProcess/efl/WebView.h:
        (WebKit::WebView::isFocused):
        (WebView):
        (WebKit::WebView::isVisible):

2013-04-04  KwangYong Choi  <ky0.choi@samsung.com>

        [EFL][WK2] Add support for getting page contents as string
        https://bugs.webkit.org/show_bug.cgi?id=106752

        Reviewed by Andreas Kling.

        Modified ewk_view_page_contents_get() API to get page contents as string.
        EWK_PAGE_CONTENTS_TYPE_STRING is added to Ewk_Page_Contents_Type.
        Now, we can use both EWK_PAGE_CONTENTS_TYPE_MHTML and EWK_PAGE_CONTENTS_TYPE_STRING
        for getting page contents.

        * UIProcess/API/efl/ewk_view.cpp:
        (Ewk_Page_Contents_Context):
        (ewkViewPageContentsAsMHTMLCallback):
        (ewkViewPageContentsAsStringCallback):
        (ewk_view_page_contents_get):
        * UIProcess/API/efl/ewk_view.h:
        * UIProcess/API/efl/tests/test_ewk2_view.cpp:
        (PageContentsAsMHTMLCallback):
        (PageContentsAsStringCallback):
        (TEST_F):

2013-04-04  Christophe Dumez  <ch.dumez@sisa.samsung.com>

        [Cairo] Stop passing raw pointers to BitmapImage::create()
        https://bugs.webkit.org/show_bug.cgi?id=113945

        Reviewed by Martin Robinson.

        Pass a smart pointer in to BitmapImage::create() instead of a raw one
        for the cairo surface. The factory method prototype was updated for
        cairo in r147643.

        * Shared/cairo/ShareableBitmapCairo.cpp:
        (WebKit::ShareableBitmap::createImage):

2013-04-03  Dean Jackson  <dino@apple.com>

        Expose settings to disable plugin snapshotting autostart and primary detection
        https://bugs.webkit.org/show_bug.cgi?id=113918

        Reviewed by Tim Horton.

        Three new settings: snapshotAllPlugIns, primaryPlugInSnapshotDetectionEnabled and
        autostartOriginPlugInSnapshottingEnabled.
        These are exposed via WKPreferences (WebKit2 only, since that's the only port actively
        using the feature).

        * Shared/WebPreferencesStore.h: Add macros for new settings.
        * UIProcess/API/C/WKPreferences.cpp: Getters and setters for new settings.
        (WKPreferencesSetSnapshotAllPlugIns):
        (WKPreferencesGetSnapshotAllPlugIns):
        (WKPreferencesSetAutostartOriginPlugInSnapshottingEnabled):
        (WKPreferencesGetAutostartOriginPlugInSnapshottingEnabled):
        (WKPreferencesSetPrimaryPlugInSnapshotDetectionEnabled):
        (WKPreferencesGetPrimaryPlugInSnapshotDetectionEnabled):
        * UIProcess/API/C/WKPreferencesPrivate.h:
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::updatePreferences): Forward settings updates.
        (WebKit::WebPage::addPluginView): Don't run primary plugin detection if the setting is false.
        (WebKit::WebPage::didFinishLoad): Ditto.

2013-04-04  Christophe Dumez  <ch.dumez@sisa.samsung.com>

        [Cairo] Fix canvas drawing of SVG-based patterns and remove NativeImageCairo
        https://bugs.webkit.org/show_bug.cgi?id=113929

        Reviewed by Martin Robinson.

        Update code now that PassNativeImagePtr is now a typedef to PassRefPtr<cairo_surface_t>
        instead of NativeImageCairo*.

        * Shared/gtk/ArgumentCodersGtk.cpp:
        (CoreIPC::decodeImage):
        * UIProcess/API/C/cairo/WKIconDatabaseCairo.cpp:
        (WKIconDatabaseTryGetCairoSurfaceForURL):
        * UIProcess/API/gtk/WebKitFaviconDatabase.cpp:
        (getIconSurfaceSynchronously):

2013-04-04  Sze Howe Koh  <szehowe.koh@gmail.com>

        [Qt] docs: Fix module name format
        https://bugs.webkit.org/show_bug.cgi?id=113209

        Reviewed by Jocelyn Turcotte.

        Make QDoc-generated documentation follow the conventions at
        http://qt-project.org/wiki/Spelling_Module_Names_in_Qt_Documentation

        * UIProcess/API/qt/qquickwebview.cpp:

2013-04-04  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [WK2][EFL] WebView should own view size
        https://bugs.webkit.org/show_bug.cgi?id=110753

        Reviewed by Andreas Kling.

        WebView owns view size. WKViewGetSize and WKViewSetSize API
        is exposed accordingly. Usage of EFL-specific ewkView inside
        toolkit-agnostic WebView class is reduced.

        * UIProcess/API/C/efl/WKView.cpp:
        (WKViewGetSize):
        (WKViewSetSize):
        * UIProcess/API/C/efl/WKView.h:
        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::setDeviceScaleFactor):
        (EwkView::size):
        (EwkView::deviceSize):
        (EwkView::scheduleUpdateDisplay):
        (EwkView::handleEvasObjectCalculate):
        * UIProcess/API/efl/EwkView.h:
        (EwkView):
        * UIProcess/efl/WebView.cpp:
        (WebKit::WebView::setSize):
        (WebKit):
        (WebKit::WebView::paintToCurrentGLContext):
        (WebKit::WebView::updateViewportSize):
        (WebKit::WebView::viewSize):
        (WebKit::WebView::dipSize):
        * UIProcess/efl/WebView.h:
        (WebView):
        (WebKit::WebView::size):

2013-04-03  Anders Carlsson  <andersca@apple.com>

        Don't try to set the exception port for server connections
        https://bugs.webkit.org/show_bug.cgi?id=113910
        <rdar://problem/11248925>

        Reviewed by Darin Adler.

        Treat a SetExceptionPort message to the server connection as an invalid message.

        * Platform/CoreIPC/mac/ConnectionMac.cpp:
        (CoreIPC::Connection::receiveSourceEventHandler):

2013-04-02  Mark Rowe  <mrowe@apple.com>

        <http://webkit.org/b/113898> Eliminate some code duplication by introducing an array of handlers to register / unregister.

        Reviewed by Antti Koivisto.

        * UIProcess/mac/WebContextMac.mm:
        (OcclusionNotificationHandler): Structure containing the notification name, type and handler.
        (WebKit::registerOcclusionNotificationHandlers): Register all of the handlers in the array.
        (WebKit::unregisterOcclusionNotificationHandlers): Unregister all of the handlers in the array.

2013-04-02  Mark Rowe  <mrowe@apple.com>

        Enable process suppression when no windows in the application have drawn recently.
        <http://webkit.org/b/113854> / <rdar://problem/13540351>

        Reviewed by Darin Adler.

        * UIProcess/mac/WebContextMac.mm:
        (WebKit::applicationWindowModificationsStarted): Note that modifications are no longer stopped.
        (WebKit::applicationWindowModificationsStopped): Note that modifications have stopped.
        (WebKit::registerOcclusionNotificationHandlers): Register handlers for the start and stop notifications.
        (WebKit::unregisterOcclusionNotificationHandlers): Unregister handlers for the start and stop notifications.
        (WebKit::WebContext::canEnableProcessSuppressionForNetworkProcess): Allow suppression if the application is occluded
        or the application has not drawn recently.
        (WebKit::WebContext::canEnableProcessSuppressionForWebProcess): Ditto.
        (WebKit::WebContext::canEnableProcessSuppressionForGlobalChildProcesses): Ditto.

2013-04-03  Dean Jackson  <dino@apple.com>

        Cross fade into restarted plugin
        https://bugs.webkit.org/show_bug.cgi?id=113868

        Reviewed by Tim Horton.

        Add a new plugin process type that indicates this is a plugin that
        has been restarted from snapshotting. On Apple ports, this allows
        us to animate the appearance of the plugin so that it crossfades
        with the snapshot. Other ports will have to add their own fading.

        * PluginProcess/PluginProcess.h: New Type: TypeRestartedProcess.
        * WebProcess/Plugins/Netscape/mac/PluginProxyMac.mm:
        (WebKit::PluginProxy::pluginLayer): When the plugin's CALayer is created, if it
            is a restarted plugin, add an opacity animation to fade it in.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::createPlugin): Mark restarted plugins with the new process type.

2013-04-03  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13564588> Add a temporary workaround for a build failure.

        Fix suggested by Mark Rowe.

        * Shared/mac/ChildProcessMac.mm:

2013-04-03  Alexey Proskuryakov  <ap@apple.com>

        [WK2] XMLHttpRequest upload events don't work with NetworkProcess
        https://bugs.webkit.org/show_bug.cgi?id=113887

        Reviewed by Brady Eidson.

        Just forward didSendData client call to WebProcess.

        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::didSendData):
        (WebKit::NetworkResourceLoader::didCancelAuthenticationChallenge): Tweaked a comment.
        * WebProcess/Network/WebResourceLoader.cpp:
        (WebKit::WebResourceLoader::didSendData):
        * WebProcess/Network/WebResourceLoader.h:
        * WebProcess/Network/WebResourceLoader.messages.in:

2013-04-02  Ryosuke Niwa  <rniwa@webkit.org>

        Remove code for Mac 10.5 and earlier from WTF and WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=113844

        Reviewed by Benjamin Poulain.

        Removed the code for 10.5 and removed if-def for 10.6.

        * Shared/mac/PasteboardTypes.mm:
        (WebKit::PasteboardTypes::forEditing):

2013-04-02  Anders Carlsson  <andersca@apple.com>

        Be more robust against empty message receiver names in incoming messages
        https://bugs.webkit.org/show_bug.cgi?id=113833
        <rdar://problem/13284433>

        Reviewed by Beth Dakin.

        Turns out that we either send or receive messages whose receiver names are empty. This leads to bad things when we try to look
        up the message receiver name in a hash map since the empty name is used to represent an empty hash map value.

        * Platform/CoreIPC/Connection.cpp:
        (CoreIPC::Connection::addWorkQueueMessageReceiverOnConnectionWorkQueue):
        Sprinkle assertions.

        (CoreIPC::Connection::processIncomingMessage):
        If the message receiver name is not valid, make sure to call didReceiveInvalidMessage on the client thread.

        (CoreIPC::Connection::dispatchDidReceiveInvalidMessage):
        Add new helper function.

2013-04-02  Simon Cooper  <scooper@apple.com>

        [Mac][WK2] Don’t let plug-ins use System V shared memory
        https://bugs.webkit.org/show_bug.cgi?id=113466
        <rdar://problem/13159030>

        Reviewed, tweaked and landed by Alexey Proskuryakov.

        Instead of allowing plug-ins to request System V shm, give them a
        temporary but usable alternative if they try to request it.

        * PluginProcess/mac/PluginProcessShim.mm:

2013-04-02  Anders Carlsson  <andersca@apple.com>

        Add WKContextSetInvalidMessageFunction
        https://bugs.webkit.org/show_bug.cgi?id=113820
        <rdar://problem/12679817>

        Reviewed by Tim Horton.

        * UIProcess/API/C/WKContext.cpp:
        (WKContextSetInvalidMessageFunction):
        Call WebContext::didReceiveInvalidMessage.

        * UIProcess/API/C/WKContextPrivate.h:
        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::setInvalidMessageCallback):
        Set the global variable.

        (WebKit::WebContext::didReceiveInvalidMessage):
        Construct a message name string and call the invalid message callback.

        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::didReceiveInvalidMessage):
        Call WebContext::didReceiveInvalidMessage.

2013-04-02  Alexey Proskuryakov  <ap@apple.com>

        [Mac] Remove WKCreateNSURLConnectionDelegateProxy
        https://bugs.webkit.org/show_bug.cgi?id=113810

        Reviewed by Anders Carlsson.

        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface):

2013-04-02  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13551119> [WK2] Crashes in NetworkProcess when canceling loads
        https://bugs.webkit.org/show_bug.cgi?id=113803

        Reviewed by Darin Adler.

        * Shared/Downloads/mac/DownloadMac.mm: (WebKit::Download::startWithHandle):
        Just pass nil instead of proxy.

2013-04-02  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [WK2] Remove repeating code in declaration of WK2 API classes
        https://bugs.webkit.org/show_bug.cgi?id=112782

        Reviewed by Benjamin Poulain.

        The following two lines of code had been repeated in every WK2 API
        object class:
        1) static const Type APIType = SomeAPIType;
        2) virtual Type type() const { return APIType; }

        This patch introduces template class 'TypedAPIObject' inherited
        from WebKit::APIObject and it contains the common functionality. 
        So the new pattern is that API object classes are inherited from
        TypedAPIObject (rather than from WebKit::APIObject directly) passing
        the corresponding API object type as a template parameter.

        The existing API object classes are modified accordingly to the
        proposed pattern.

        * Shared/APIObject.h:
        (WebKit):
        (TypedAPIObject):
        (WebKit::TypedAPIObject::~TypedAPIObject):
        (WebKit::TypedAPIObject::TypedAPIObject):
        * Shared/ImmutableArray.h:
        (ImmutableArray):
        * Shared/ImmutableDictionary.h:
        (ImmutableDictionary):
        * Shared/WebArchive.h:
        (WebArchive):
        * Shared/WebArchiveResource.h:
        (WebArchiveResource):
        * Shared/WebBackForwardListItem.h:
        (WebBackForwardListItem):
        * Shared/WebBatteryStatus.h:
        (WebBatteryStatus):
        * Shared/WebCertificateInfo.h:
        * Shared/WebConnection.h:
        (WebConnection):
        * Shared/WebContextMenuItem.h:
        (WebContextMenuItem):
        * Shared/WebData.h:
        * Shared/WebError.h:
        (WebKit::WebError::errorCode):
        * Shared/WebGeolocationPosition.h:
        (WebGeolocationPosition):
        * Shared/WebGeometry.h:
        * Shared/WebGraphicsContext.h:
        (WebGraphicsContext):
        * Shared/WebHitTestResult.h:
        * Shared/WebImage.h:
        (WebImage):
        * Shared/WebNetworkInfo.h:
        (WebNetworkInfo):
        * Shared/WebNumber.h:
        * Shared/WebOpenPanelParameters.h:
        (WebOpenPanelParameters):
        * Shared/WebRenderLayer.h:
        * Shared/WebRenderObject.h:
        * Shared/WebSecurityOrigin.h:
        * Shared/WebSerializedScriptValue.h:
        (WebSerializedScriptValue):
        * Shared/WebString.h:
        * Shared/WebURL.h:
        * Shared/WebURLRequest.h:
        (WebURLRequest):
        * Shared/WebURLResponse.h:
        (WebURLResponse):
        * Shared/WebUserContentURLPattern.h:
        * Shared/mac/ObjCObjectGraph.h:
        * UIProcess/Authentication/AuthenticationChallengeProxy.h:
        (AuthenticationChallengeProxy):
        * UIProcess/Authentication/AuthenticationDecisionListener.h:
        (AuthenticationDecisionListener):
        * UIProcess/Authentication/WebCredential.h:
        (WebCredential):
        * UIProcess/Authentication/WebProtectionSpace.h:
        (WebProtectionSpace):
        * UIProcess/Downloads/DownloadProxy.h:
        (DownloadProxy):
        * UIProcess/GeolocationPermissionRequestProxy.h:
        (GeolocationPermissionRequestProxy):
        * UIProcess/Notifications/NotificationPermissionRequest.h:
        (NotificationPermissionRequest):
        * UIProcess/Notifications/WebNotification.h:
        (WebNotification):
        * UIProcess/Notifications/WebNotificationManagerProxy.h:
        (WebNotificationManagerProxy):
        * UIProcess/Plugins/WebPluginSiteDataManager.h:
        (WebPluginSiteDataManager):
        * UIProcess/WebApplicationCacheManagerProxy.h:
        (WebApplicationCacheManagerProxy):
        * UIProcess/WebBackForwardList.h:
        (WebBackForwardList):
        * UIProcess/WebBatteryManagerProxy.h:
        (WebBatteryManagerProxy):
        * UIProcess/WebContext.h:
        (WebContext):
        * UIProcess/WebCookieManagerProxy.h:
        (WebCookieManagerProxy):
        * UIProcess/WebDatabaseManagerProxy.h:
        (WebDatabaseManagerProxy):
        * UIProcess/WebEditCommandProxy.h:
        (WebEditCommandProxy):
        * UIProcess/WebFrameProxy.h:
        (WebFrameProxy):
        * UIProcess/WebGeolocationManagerProxy.h:
        (WebGeolocationManagerProxy):
        * UIProcess/WebGrammarDetail.h:
        (WebGrammarDetail):
        * UIProcess/WebIconDatabase.h:
        (WebIconDatabase):
        * UIProcess/WebInspectorProxy.h:
        (WebInspectorProxy):
        * UIProcess/WebKeyValueStorageManagerProxy.h:
        (WebKeyValueStorageManagerProxy):
        * UIProcess/WebMediaCacheManagerProxy.h:
        (WebMediaCacheManagerProxy):
        * UIProcess/WebNavigationData.h:
        (WebNavigationData):
        * UIProcess/WebNetworkInfoManagerProxy.h:
        (WebNetworkInfoManagerProxy):
        * UIProcess/WebOpenPanelResultListenerProxy.h:
        (WebOpenPanelResultListenerProxy):
        * UIProcess/WebPageGroup.h:
        (WebPageGroup):
        * UIProcess/WebPageProxy.h:
        (WebPageProxy):
        * UIProcess/WebPreferences.cpp:
        (WebKit::WebPreferences::WebPreferences):
        * UIProcess/WebPreferences.h:
        (WebPreferences):
        * UIProcess/WebResourceCacheManagerProxy.h:
        (WebResourceCacheManagerProxy):
        * UIProcess/WebTextChecker.h:
        (WebTextChecker):
        * UIProcess/WebVibrationProxy.h:
        (WebVibrationProxy):
        * UIProcess/efl/WebPopupItemEfl.h:
        (WebPopupItemEfl):
        * UIProcess/efl/WebView.h:
        * UIProcess/soup/WebSoupRequestManagerProxy.h:
        (WebSoupRequestManagerProxy):
        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.h:
        (InjectedBundleNodeHandle):
        * WebProcess/InjectedBundle/DOM/InjectedBundleRangeHandle.h:
        (InjectedBundleRangeHandle):
        * WebProcess/InjectedBundle/InjectedBundle.h:
        (InjectedBundle):
        * WebProcess/InjectedBundle/InjectedBundleBackForwardList.h:
        * WebProcess/InjectedBundle/InjectedBundleBackForwardListItem.h:
        * WebProcess/InjectedBundle/InjectedBundleDOMWindowExtension.h:
        (InjectedBundleDOMWindowExtension):
        * WebProcess/InjectedBundle/InjectedBundleHitTestResult.h:
        * WebProcess/InjectedBundle/InjectedBundleNavigationAction.h:
        (InjectedBundleNavigationAction):
        * WebProcess/InjectedBundle/InjectedBundleScriptWorld.h:
        (InjectedBundleScriptWorld):
        * WebProcess/WebPage/PageOverlay.h:
        (PageOverlay):
        * WebProcess/WebPage/WebFrame.h:
        (WebFrame):
        * WebProcess/WebPage/WebInspector.h:
        (WebInspector):
        * WebProcess/WebPage/WebPage.h:
        (WebPage):
        * WebProcess/WebPage/WebPageGroupProxy.h:
        (WebPageGroupProxy):

2013-04-01  Timothy Hatcher  <timothy@apple.com>

        Allow changing Web Inspector dock sides without undocking first.

        https://webkit.org/b/113661
        rdar://problem/13543127

        Reviewed by Joseph Pecoraro.

        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::WebInspectorProxy::createInspectorPage): Send AttachedBottom and
        AttachedRight messages so InspectorFrontendClientLocal knows which side we
        are attached.

        (WebKit::WebInspectorProxy::canAttach): If we are already attached, allow
        attaching again to allow switching sides.

2013-04-01  Anders Carlsson  <andersca@apple.com>

        Nor this! (Who reviewed this anyway!)

        * WebProcess/Storage/StorageNamespaceProxy.cpp:
        (WebKit::StorageNamespaceProxy::storageArea):

2013-04-01  Anders Carlsson  <andersca@apple.com>

        Didn't mean to commit this!

        * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:

2013-04-01  Alexey Proskuryakov  <ap@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=113721
        <rdar://problem/13549181> REGRESSION (r146929): HTTP auth credentials not reused during session

        Reviewed by Brady Eidson.

        * NetworkProcess/NetworkResourceLoader.h:
        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::shouldUseCredentialStorage): Added an override that
        we still need. It's not great, but causes no trouble for NetworkProcess.
        (WebKit::NetworkResourceLoader::shouldUseCredentialStorageAsync): Implement in
        terms of sync version to avoid duplicating logic.

2013-03-05  Anders Carlsson  <andersca@apple.com>

        Apply changes from storage events locally
        https://bugs.webkit.org/show_bug.cgi?id=111502

        Reviewed by Sam Weinig.

        * WebProcess/Storage/StorageAreaProxy.cpp:
        (WebKit::StorageAreaProxy::StorageAreaProxy):
        Store the security origin as a member variable.

        (WebKit::StorageAreaProxy::dispatchStorageEvent):
        Set the item and call the appropriate event dispatch function.
    
        (WebKit::StorageAreaProxy::dispatchSessionStorageEvent):
        (WebKit::StorageAreaProxy::dispatchLocalStorageEvent):
        Add stubs.

        * WebProcess/Storage/StorageAreaProxy.h:

2013-04-01  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13490123> Sandbox extension tracking is incorrect when restoring a session
        https://bugs.webkit.org/show_bug.cgi?id=113709

        Reviewed by Anders Carlsson.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::SandboxExtensionTracker::didStartProvisionalLoad): Added an assertion
        to catch extension tracking logic errors that could result in giving an extension to
        non-local pages.
        (WebKit::WebPage::SandboxExtensionTracker::didCommitProvisionalLoad): Just like
        below, clearing m_pendingProvisionalSandboxExtension appears incorrect, even though
        I am not aware of any scenarios where this happens in practice.
        (WebKit::WebPage::SandboxExtensionTracker::didFailProvisionalLoad): The load may
        be failing exactly because a new one cancels it, so we shouldn't be preventing
        the new one from using its extension.

2013-04-01  Brady Eidson  <beidson@apple.com>

        SharedMemory release build hardening.
        <rdar://problem/13546860> and https://bugs.webkit.org/show_bug.cgi?id=113710

        Reviewed by Anders Carlsson.

        Successful creation of a memory entry with a size less than the size we requested should be treated
        as a failure to create the SharedMemory object.

        * Platform/mac/SharedMemoryMac.cpp:
        (WebKit::SharedMemory::createFromVMBuffer): Early return if the port we get is bogus for our needs.
        (WebKit::SharedMemory::createHandle): Ditto.
        (WebKit::SharedMemory::create): Guarantee we pass valid input in to mach_vm_map.

2013-03-30  Csaba Osztrogonác  <ossy@webkit.org>

        Unreviewed buildfix after r147260.

        * WebProcess/qt/QtBuiltinBundlePage.cpp:
        (WebKit::QtBuiltinBundlePage::QtBuiltinBundlePage):

2013-03-29  Seokju Kwon  <seokju.kwon@gmail.com>

        [EFL] Unreviewed build fix after r147251
        https://bugs.webkit.org/show_bug.cgi?id=113631

        Unreviewed build fix.

        Add NETWORK_PROCESS guard.

        * UIProcess/WebResourceCacheManagerProxy.cpp:
        (WebKit::WebResourceCacheManagerProxy::clearCacheForAllOrigins):

2013-03-29  Brady Eidson  <beidson@apple.com>

        Crash when "willSendRequest" causes the ResourceLoader to be cancelled.
        <rdar://problem/13531679> and https://bugs.webkit.org/show_bug.cgi?id=113616

        Reviewed by Alexey Proskuryakov.

        These callbacks to the WebCore ResourceLoader can cause the WebResourceLoader to be destroyed.
        A RefPtr<> protector fixes that.

        Additionally we can invalidate the WebResourceLoader to avoid unnecessary callbacks to the NetworkProcess.

        * WebProcess/Network/WebResourceLoadScheduler.cpp:
        (WebKit::WebResourceLoadScheduler::remove): Call detachFromCoreLoader() on a removed WebResourceLoader.

        * WebProcess/Network/WebResourceLoader.cpp:
        (WebKit::WebResourceLoader::detachFromCoreLoader): Clear out the ResourceLoader pointer.
        (WebKit::WebResourceLoader::willSendRequest): Protect this, and don't message back to the NetworkProcess if its not needed.
        (WebKit::WebResourceLoader::canAuthenticateAgainstProtectionSpace): Ditto
        (WebKit::WebResourceLoader::didReceiveResource): Paranoid hardening - Protect this before delivering the data to the WebCore
          ResourceLoader, and null check it before delivering the "didFinishLoader" call.
        * WebProcess/Network/WebResourceLoader.h:

2013-03-29  Brady Eidson  <beidson@apple.com>

        Should never send events to plugins waiting on asynchronous initialization.
        <rdar://problem/13538945> and https://bugs.webkit.org/show_bug.cgi?id=113612

        Reviewed by Anders Carlsson.

        Sending mouse and keyboard events to a plugin in the middle of asynchronous initialization is silly.

        A quick audit of the sendSync() messages in PluginProxy suggests the following 8 can just have an early return:

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::handleMouseEvent):
        (WebKit::PluginProxy::handleWheelEvent):
        (WebKit::PluginProxy::handleMouseEnterEvent):
        (WebKit::PluginProxy::handleMouseLeaveEvent):
        (WebKit::PluginProxy::handleKeyboardEvent):
        (WebKit::PluginProxy::handleEditingCommand):
        (WebKit::PluginProxy::isEditingCommandEnabled):
        (WebKit::PluginProxy::handlesPageScaleFactor):

2013-03-29  Brady Eidson  <beidson@apple.com>

        Should never send events to plugins waiting on asynchronous initialization.
        <rdar://problem/13538945> and https://bugs.webkit.org/show_bug.cgi?id=113612

        Reviewed by Anders Carlsson.

        Sending mouse and keyboard events to a plugin in the middle of asynchronous initialization is silly.

        A quick audit of the sendSync() messages in PluginProxy suggests the following 8 can just have an early return:

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::handleMouseEvent):
        (WebKit::PluginProxy::handleWheelEvent):
        (WebKit::PluginProxy::handleMouseEnterEvent):
        (WebKit::PluginProxy::handleMouseLeaveEvent):
        (WebKit::PluginProxy::handleKeyboardEvent):
        (WebKit::PluginProxy::handleEditingCommand):
        (WebKit::PluginProxy::isEditingCommandEnabled):
        (WebKit::PluginProxy::handlesPageScaleFactor):

2013-03-29  Alexey Proskuryakov  <ap@apple.com>

        Expose FeatureObserver data to WebKit clients
        https://bugs.webkit.org/show_bug.cgi?id=113613

        Reviewed by Sam Weinig.

        * Shared/APIClientTraits.cpp:
        * Shared/APIClientTraits.h:
        * WebProcess/InjectedBundle/API/c/WKBundlePage.h:
        * WebProcess/InjectedBundle/InjectedBundlePageLoaderClient.cpp:
        (WebKit::InjectedBundlePageLoaderClient::featuresUsedInPage):
        * WebProcess/InjectedBundle/InjectedBundlePageLoaderClient.h:
        Added a new injected bundle client call, featuresUsedInPage.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::close):
        (WebKit::WebPage::didCommitLoad):
        (WebKit::WebPage::reportUsedFeatures):
        * WebProcess/WebPage/WebPage.h:
        Report features used in a page when navigating away, or when closing.

2013-03-29  Brady Eidson  <beidson@apple.com>

        Crash when "willSendRequest" causes the ResourceLoader to be cancelled.
        <rdar://problem/13531679> and https://bugs.webkit.org/show_bug.cgi?id=113616

        Reviewed by Alexey Proskuryakov.

        These callbacks to the WebCore ResourceLoader can cause the WebResourceLoader to be destroyed.
        A RefPtr<> protector fixes that.

        Additionally we can invalidate the WebResourceLoader to avoid unnecessary callbacks to the NetworkProcess.

        * WebProcess/Network/WebResourceLoadScheduler.cpp:
        (WebKit::WebResourceLoadScheduler::remove): Call detachFromCoreLoader() on a removed WebResourceLoader.

        * WebProcess/Network/WebResourceLoader.cpp:
        (WebKit::WebResourceLoader::detachFromCoreLoader): Clear out the ResourceLoader pointer.
        (WebKit::WebResourceLoader::willSendRequest): Protect this, and don't message back to the NetworkProcess if its not needed.
        (WebKit::WebResourceLoader::canAuthenticateAgainstProtectionSpace): Ditto
        (WebKit::WebResourceLoader::didReceiveResource): Paranoid hardening - Protect this before delivering the data to the WebCore
          ResourceLoader, and null check it before delivering the "didFinishLoader" call.
        * WebProcess/Network/WebResourceLoader.h:

2013-03-29  Brady Eidson  <beidson@apple.com>

        Should never send events to plugins waiting on asynchronous initialization.
        <rdar://problem/13538945> and https://bugs.webkit.org/show_bug.cgi?id=113612

        Reviewed by Anders Carlsson.

        Sending mouse and keyboard events to a plugin in the middle of asynchronous initialization is silly.

        A quick audit of the sendSync() messages in PluginProxy suggests the following 8 can just have an early return:

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::handleMouseEvent):
        (WebKit::PluginProxy::handleWheelEvent):
        (WebKit::PluginProxy::handleMouseEnterEvent):
        (WebKit::PluginProxy::handleMouseLeaveEvent):
        (WebKit::PluginProxy::handleKeyboardEvent):
        (WebKit::PluginProxy::handleEditingCommand):
        (WebKit::PluginProxy::isEditingCommandEnabled):
        (WebKit::PluginProxy::handlesPageScaleFactor):

2013-03-29  Brady Eidson  <beidson@apple.com>

        "Empty cache..." clears the disk cache from each WebProcess.
        <rdar://problem/12456652> and https://bugs.webkit.org/show_bug.cgi?id=113603

        Reviewed by Sam Weinig.

        * NetworkProcess/NetworkProcess.cpp:
        (WebKit::NetworkProcess::NetworkProcess):
        (WebKit::NetworkProcess::terminate): Override ChildProcess::terminate to allow us to finish clearing the cache.
        * NetworkProcess/NetworkProcess.h:

        * NetworkProcess/NetworkProcess.messages.in: Add the ClearCacheForAllOrigins message.

        * NetworkProcess/mac/NetworkProcessMac.mm:
        (WebKit::NetworkProcess::clearCacheForAllOrigins): Clear the disk cache.
        (WebKit::NetworkProcess::platformTerminate): Wait for the clear to complete.

        * UIProcess/WebResourceCacheManagerProxy.cpp:
        (WebKit::WebResourceCacheManagerProxy::clearCacheForAllOrigins): Message the network process, also.

        * WebProcess/mac/WebProcessMac.mm:
        (WebKit::WebProcess::platformClearResourceCaches): Don't clear the disk cache if we use the network process.

2013-03-28  Brady Eidson  <beidson@apple.com>

        We leak NetworkConnectionToWebProcess objects.
        <rdar://problem/13393118> and https://bugs.webkit.org/show_bug.cgi?id=113551

        Reviewed by Anders Carlsson.

        * NetworkProcess/NetworkConnectionToWebProcess.cpp:
        (WebKit::NetworkConnectionToWebProcess::didClose): Remove this from the global set
          of NetworkConnectionToWebProcess objects.

2013-03-28  Brady Eidson  <beidson@apple.com>

        Resources are never revalidated/reloaded if a cached response exists on disk.
        <rdar://problem/13479890> and https://bugs.webkit.org/show_bug.cgi?id=113542

        Reviewed by Alexey Proskuryakov.

        Trying to get a cached resource in didReceiveResponse and then aborting the load
        meant we never performed any new loads.

        We can check and see if the data is cached data inside didReceiveBuffer, instead.

        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::didReceiveResponse): Don't try for cached resources here.
        (WebKit::NetworkResourceLoader::didReceiveData): This callback should never be used.
        (WebKit::NetworkResourceLoader::didReceiveBuffer): Try to see if this data objected represents
          a file based mmaped buffer.
        * NetworkProcess/NetworkResourceLoader.h:

        Refactor these utility functions to start from either a CFURLCachedResponse or a SharedBuffer:
        * NetworkProcess/mac/NetworkResourceLoaderMac.mm:
        (CFCachedURLResponseGetMemMappedData):
        (CFURLCacheIsMemMappedData):
        (WebKit::tryGetShareableHandleFromCFData):
        (WebKit::NetworkResourceLoader::tryGetShareableHandleFromCFURLCachedResponse):
        (WebKit::NetworkResourceLoader::tryGetShareableHandleFromSharedBuffer):

2013-03-28  Tim Horton  <timothy_horton@apple.com>

        [wk2] REGRESSION (r125500): WebFrameLoaderClient's active m_pluginView can be zeroed by PluginDocuments leaving the page cache
        https://bugs.webkit.org/show_bug.cgi?id=113430
        <rdar://problem/12729564>

        Reviewed by Brady Eidson.

        http://trac.webkit.org/changeset/147152 was wrong, and should have been
        (as the ChangeLog stated) testing the argument to redirectDataToPlugin,
        not the value of m_pluginView.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::redirectDataToPlugin):

2013-03-28  Tim Horton  <timothy_horton@apple.com>

        [wk2] REGRESSION (r125500): WebFrameLoaderClient's active m_pluginView can be zeroed by PluginDocuments leaving the page cache
        https://bugs.webkit.org/show_bug.cgi?id=113430
        <rdar://problem/12729564>

        Reviewed by Brady Eidson.

        Ignore redirectDataToPlugin(0), which is only called from PluginDocument::detach(),
        and only after r125500. Otherwise, PluginDocuments that are put into the page cache
        but leave later can clear a totally different and legitimate PluginView from the
        WebFrameLoaderClient, causing data to be lost and PluginDocument loads to stall.

        This restores our behavior to the pre-r125500 state, which should be fine, as we
        clear WebFrameLoaderClient's m_pluginView when the load fails or finishes. This
        matches the changes made in r125500 for every platform other than Chromium and WebKit2.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::redirectDataToPlugin):

2013-03-28  Tim Horton  <timothy_horton@apple.com>

        PDFPlugin: shouldUsePDFPlugin can't use pdfLayerControllerClass() because it asserts if it's not available
        https://bugs.webkit.org/show_bug.cgi?id=113533
        <rdar://problem/13528720>

        Reviewed by Simon Fraser.

        * WebProcess/WebPage/WebPage.cpp:
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::shouldUsePDFPlugin):
        Move shouldUsePDFPlugin to WebPageMac, where it belongs, and explicitly look up PDFLayerController
        instead of using pdfLayerControllerClass(), which ASSERT()s if it isn't available.

2013-03-28  Brady Eidson  <beidson@apple.com>

        Reduce PluginProcess lifetime.
        <rdar://problem/12465479> and https://bugs.webkit.org/show_bug.cgi?id=113523

        Reviewed by Sam Weinig.

        Lower the minimum process lifetime from 30 minutes to 2 minutes.
        Lower the "shutdown after last plugin goes away" period from 10 minutes to 1 minute.

        * UIProcess/Plugins/PluginProcessProxy.cpp:

2013-03-28  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Build GTK-specific, non-layer-violating source code into WebCore-independent libPlatformGtk.la
        https://bugs.webkit.org/show_bug.cgi?id=112546

        Reviewed by Martin Robinson.

        * GNUmakefile.am: Reference the platform_webcore_cppflags and GTK, libsecret and libsoup dependencies' cflags amongst the
        libPlatformGtk2's CPPFLAGS.
        * Scripts/generate-forwarding-headers.pl: Remove the Platform framework from the list of the frameworks to be searched
        for forwarding headers, it's at the moment not necessary to be included.
        * Shared/gtk/ArgumentCodersGtk.cpp: Adjust the forwarding header for GtkVersioning.h that's been moved back under the
        WebCore framework.
        * Shared/gtk/WebEventFactory.cpp: Ditto.
        * UIProcess/API/gtk/WebKitWebViewBase.cpp: Ditto.
        * WebProcess/Plugins/Netscape/x11/NetscapePluginX11.cpp: Ditto.

2013-03-27  Tim Horton  <timothy_horton@apple.com>

        Unreviewed Qt build fix after http://trac.webkit.org/changeset/147067.

        * WebProcess/WebPage/WebPage.cpp:

2013-03-27  Tim Horton  <timothy_horton@apple.com>

        PDFPlugin: Enable PDFPlugin only if its dependencies exist on the system
        https://bugs.webkit.org/show_bug.cgi?id=113372
        <rdar://problem/12685301>

        Reviewed by Alexey Proskuryakov.

        * Shared/mac/PDFKitImports.h: Wrap in #if PLATFORM(MAC).
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::createPlugin): Use shouldUsePDFPlugin.
        (WebKit::WebPage::shouldUsePDFPlugin): If the PDFPlugin setting is enabled but PDFLayerController is not available, don't use PDFPlugin.
        * WebProcess/WebPage/WebPage.h:
        (WebPage): Add shouldUsePDFPlugin
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::platformPreferencesDidChange): Use shouldUsePDFPlugin.

2013-03-27  Sam Weinig  <sam@webkit.org>

        [WebKit2] Need SPI to determine whether a plug-in is blocked
        https://bugs.webkit.org/show_bug.cgi?id=113463

        Reviewed by Anders Carlsson.

        Add new SPI, WKContextCopyPlugInInfoForBundleIdetifier, to get data about a plug-in,
        including whether it is blocked by x-protect.

        * UIProcess/WebLoaderClient.cpp:
        * UIProcess/API/C/WKAPICast.h:
        (WebKit::toWKPluginLoadPolicy):
        (WebKit::toPluginModuleLoadPolicy):
        Move to a shared location.

        * UIProcess/API/C/mac/WKContextPrivateMac.h:
        * UIProcess/API/C/mac/WKContextPrivateMac.mm:
        (WKContextIsPlugInUpdateAvailable):
        (WKPlugInInfoPathKey):
        (WKPlugInInfoBundleIdentifierKey):
        (WKPlugInInfoVersionKey):
        (WKPlugInInfoLoadPolicyKey):
        (WKPlugInInfoUpdatePastLastBlockedVersionIsKnownAvailableKey):
        (WKContextCopyPlugInInfoForBundleIdetifier):
        Add new SPI and dictionary keys.

        * UIProcess/Plugins/PluginInfoStore.cpp:
        (WebKit::PluginInfoStore::findPluginWithBundleIdentifer):
        * UIProcess/Plugins/PluginInfoStore.h:
        * UIProcess/Plugins/mac/PluginInfoStoreMac.mm:
        (WebKit::PluginInfoStore::findPluginWithBundleIdentifer):
        Add function to lookup plug-ins by bundle identifier.

2013-03-27  Beth Dakin  <bdakin@apple.com>

        WKBundlePagePrivateMac.h is not being exported
        https://bugs.webkit.org/show_bug.cgi?id=113470
        -and corresponding-
        <rdar://problem/13522909>

        Reviewed by Sam Weinig.

        Mark it as private instead of project.
        * WebKit2.xcodeproj/project.pbxproj:

2013-03-26  Beth Dakin  <bdakin@apple.com>

        Need WK2 API to give a WebView a header and footer
        https://bugs.webkit.org/show_bug.cgi?id=113352
        -and corresponding-
        <rdar://problem/13383835>

        Reviewed by Simon Fraser.

        New API allows setting and getting layers for a header and footer.

        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/InjectedBundle/API/c/mac: Added.
        * WebProcess/InjectedBundle/API/c/mac/WKBundlePagePrivateMac.h: Added.
        * WebProcess/InjectedBundle/API/c/mac/WKBundlePagePrivateMac.mm: Added.
        (WKBundlePageGetHeaderLayer):
        (WKBundlePageSetHeaderLayer):
        (WKBundlePageGetFooterLayer):
        (WKBundlePageSetFooterLayer):
        * WebProcess/WebPage/WebPage.h:
        (WebPage):
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::setTopOverhangImage):
        (WebKit::WebPage::setBottomOverhangImage):
        (WebKit):
        (WebKit::WebPage::getHeaderLayer):
        (WebKit::WebPage::setHeaderLayerWithHeight):
        (WebKit::WebPage::getFooterLayer):
        (WebKit::WebPage::setFooterLayerWithHeight):

2013-03-27  Jer Noble  <jer.noble@apple.com>

        Going full screen and cancelling gets system into a weird state
        https://bugs.webkit.org/show_bug.cgi?id=113445

        Reviewed by Eric Carlson.

        Replace an array of BOOL member variables to track full screen state with a single enum, and
        add state tracking for the "waiting to enter" and "waiting to exit" states. Use this new,
        more specific enum to be more stringent about the state when responding to WebProcess
        messages. Also only set the placeholder view's target once in full screen mode.

        * UIProcess/mac/WKFullScreenWindowController.h:
        * UIProcess/mac/WKFullScreenWindowController.mm:
        (-[WKFullScreenWindowController isFullScreen]): Yes when in full screen, entering full screen,
            or waiting to enter full screen.
        (-[WKFullScreenWindowController cancelOperation:]): Only requestExitFullScreen() if a watchdog
            has not already been made active.
        (-[WKFullScreenWindowController enterFullScreen:]): Use the new state variable.
        (-[WKFullScreenWindowController beganEnterFullScreenWithInitialFrame:WebCore::finalFrame:WebCore::]): Ditto.
        (-[WKFullScreenWindowController finishedEnterFullScreenAnimation:]): Ditto. Set the placeholder target.
        (-[WKFullScreenWindowController exitFullScreen]): Ditto. Clear the placeholder target.
        (-[WKFullScreenWindowController beganExitFullScreenWithInitialFrame:WebCore::finalFrame:WebCore::]): Ditto.
        (-[WKFullScreenWindowController completeFinishExitFullScreenAnimationAfterRepaint]): Ditto.
        (-[WKFullScreenWindowController performClose:]): Ditto.
        (-[WKFullScreenWindowController close]): Ditto.
        (-[WKFullScreenWindowController _startEnterFullScreenAnimationWithDuration:]): Ditto.

2013-03-27  Brady Eidson  <beidson@apple.com>

        Blind attempt at fixing the release build.

        * NetworkProcess/mac/NetworkResourceLoaderMac.mm:
        (WebKit::NetworkResourceLoader::willCacheResponseAsync):

2013-03-27  Brady Eidson  <beidson@apple.com>

        Mem mapped resource data improvements.
        <rdar://problem/13196481> and https://bugs.webkit.org/show_bug.cgi?id=113422

        Reviewed by Alexey Proskuryakov (and looked over by Geoff Garen).

        Remove timer-based approach support code:
        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::NetworkResourceLoader):
        (WebKit::NetworkResourceLoader::abortInProgressLoad):
        (WebKit::NetworkResourceLoader::didFinishLoading):
        * NetworkProcess/NetworkResourceLoader.h:

        Add an object to encapsulate monitoring a resource going in to the disk cache.
        It listens for a callback on the cached response indicating it is disk backed
        and also sets a timeout so we don't keep the monitor alive and waiting forever.
        * NetworkProcess/mac/DiskCacheMonitor.h: Added.
        (WebKit::DiskCacheMonitor::destinationID):
        (WebKit::DiskCacheMonitor::connectionToWebProcess):
        (WebKit::DiskCacheMonitor::resourceRequest):
        * NetworkProcess/mac/DiskCacheMonitor.mm: Added.
        (CFCachedURLResponseSetBecameFileBackedCallBackBlock):
        (WebKit::monitorFileBackingStoreCreation):
        (WebKit::DiskCacheMonitor::DiskCachingMonitor):
        (WebKit::DiskCacheMonitor::connection):

        Refactoring and monitor certain cached responses:
        * NetworkProcess/mac/NetworkResourceLoaderMac.mm:
        (CFCachedURLResponseGetMemMappedData):
        (WebKit::NetworkResourceLoader::tryGetShareableHandleFromCFURLCachedResponse): Use CFCachedURLResponseGetMemMappedData
          to explicitly get an mem-mapped data object.
        (WebKit::NetworkResourceLoader::tryGetShareableHandleForResource):
        (WebKit::NetworkResourceLoader::willCacheResponseAsync): If the resource is over the minimum
          size then set up a disk caching monitor.

        * WebKit2.xcodeproj/project.pbxproj:

2013-03-26  Timothy Hatcher  <timothy@apple.com>

        Add support for dock-to-right of the Web Inspector in the Mac port.

        Unfortunately this requires Safari changes, so it is disabled in the nightly builds.

        https://webkit.org/b/113341
        rdar://problem/10368152

        Reviewed by Joseph Pecoraro.

        * Resources/Dock.pdf: Removed.
        * Resources/DockBottom.pdf: Added.
        * Resources/DockRight.pdf: Added.
        * Shared/WebPreferencesStore.h:
        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::WebInspectorProxy::WebInspectorProxy):
        (WebKit::WebInspectorProxy::attachBottom):
        (WebKit::WebInspectorProxy::attachRight):
        (WebKit::WebInspectorProxy::attach):
        (WebKit::WebInspectorProxy::detach):
        (WebKit::WebInspectorProxy::setAttachedWindowWidth):
        (WebKit::WebInspectorProxy::createInspectorPage):
        (WebKit::WebInspectorProxy::canAttach):
        * UIProcess/WebInspectorProxy.h:
        (WebInspectorProxy):
        * UIProcess/WebInspectorProxy.messages.in:
        * UIProcess/mac/WebInspectorProxyMac.mm:
        (-[WKWebInspectorProxyObjCAdapter attachRight:]):
        (-[WKWebInspectorProxyObjCAdapter attachBottom:]):
        (-[WKWebInspectorWindow _cursorForResizeDirection:]):
        (-[WKWebInspectorWindow _customTitleFrame]):
        (WebKit::createDockButton):
        (WebKit::WebInspectorProxy::createInspectorWindow):
        (WebKit::WebInspectorProxy::platformCreateInspectorPage):
        (WebKit::WebInspectorProxy::platformAttachAvailabilityChanged):
        (WebKit::WebInspectorProxy::inspectedViewFrameDidChange):
        (WebKit::WebInspectorProxy::platformInspectedWindowWidth):
        (WebKit::WebInspectorProxy::platformAttach):
        (WebKit::WebInspectorProxy::platformDetach):
        (WebKit::WebInspectorProxy::platformSetAttachedWindowHeight):
        (WebKit::WebInspectorProxy::platformSetAttachedWindowWidth):
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.cpp:
        (WebKit::WebInspectorFrontendClient::attachWindow):
        (WebKit::WebInspectorFrontendClient::setAttachedWindowWidth):
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.h:
        (WebInspectorFrontendClient):
        * WebProcess/WebPage/WebInspector.cpp:
        (WebKit::WebInspector::attachBottom):
        (WebKit::WebInspector::attachRight):
        (WebKit::WebInspector::setAttachedWindowWidth):
        (WebKit::WebInspector::attachedBottom):
        (WebKit::WebInspector::attachedRight):
        (WebKit::WebInspector::detached):
        * WebProcess/WebPage/WebInspector.h:
        (WebInspector):
        * WebProcess/WebPage/WebInspector.messages.in:

2013-03-27  Kondapally Kalyan  <kalyan.kondapally@intel.com>

        [CoordGfx] Support to share GraphicsSurface flags with client.
        https://bugs.webkit.org/show_bug.cgi?id=112982

        Reviewed by Noam Rosenthal.

        Covered by existing WebGL tests.

        This patch adds support to pass GraphicsSurface flags
        during it's client creation.

        * Shared/CoordinatedGraphics/CoordinatedGraphicsArgumentCoders.cpp:
        (CoreIPC::::encode):
        (CoreIPC::::decode):

2013-03-26  Hayato Ito  <hayato@chromium.org>

        Allow ShadowContents in HitTests by default.
        https://bugs.webkit.org/show_bug.cgi?id=113171

        Reviewed by Dimitri Glazkov.

        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::hitTest):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::highlightPotentialActivation):
        (WebKit::WebPage::findZoomableAreaForPoint):
        (WebKit::WebPage::determinePrimarySnapshottedPlugIn):
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::shouldDelayWindowOrderingEvent):
        (WebKit::WebPage::acceptsFirstMouse):

2013-03-26  Tim Horton  <timothy_horton@apple.com>

        [ca] Tell CA to clean up unused resources if a given WebProcess won't be drawing
        https://bugs.webkit.org/show_bug.cgi?id=107539
        <rdar://problem/13032692>

        Reviewed by Simon Fraser.

        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface): Update WebCoreSystemInterface.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::WebPage): Initially move the Page out of the window if necessary;
        Page defaults to in-window, which is wrong in many cases - we depend on
        Page::isInWindow being accurate to decide whether WebPage::setIsInWindow is actually
        a state change or not.
        (WebKit::WebPage::setIsInWindow):
        * WebProcess/WebProcess.cpp: Inform WebProcess when we go on/off screen.
        (WebKit::WebProcess::WebProcess):
        (WebKit::WebProcess::pageDidMoveOnscreen): Keep track of the number of on-screen pages in this process.
        (WebKit::WebProcess::pageWillMoveOffscreen): If the number of on-screen pages drops to zero,  clean up unused rendering resources.
        * WebProcess/WebProcess.h:

2013-03-26  Dean Jackson  <dino@apple.com>

        When a primary plugin is restarted, also start similar plugins
        https://bugs.webkit.org/show_bug.cgi?id=113265

        Reviewed by Tim Horton.

        Remember the origin of the primary plugin, so that we can
        autostart anything that is similar.

        * WebProcess/WebCoreSupport/WebPlugInClient.cpp:
        (WebKit::WebPlugInClient::WebPlugInClient): Keep a pointer to the WebPage.
        (WebKit::WebPlugInClient::shouldAutoStartFromOrigin): Pass the page onto the process.
        * WebProcess/WebCoreSupport/WebPlugInClient.h:
        (WebPlugInClient): New member variable for the WebPage we were created with.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::determinePrimarySnapshottedPlugIn): Remember the origin information
            for the primary plugin.
        (WebKit::WebPage::matchesPrimaryPlugIn): Returns true if we're seeing something that
            looks like the primary plugin.
        * WebProcess/WebPage/WebPage.h: New method matchesPrimaryPlugIn.
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::shouldPlugInAutoStartFromOrigin): Check if the page thinks this is
            the primary plugin.
        * WebProcess/WebProcess.h: Accept a reference to the page in shouldPlugInAutoStartFromOrigin.

2013-03-26  Alexey Proskuryakov  <ap@apple.com>

        Follow-up to:
        <rdar://problem/13194263> Crashes in NetworkProcess due to threading issues
        https://bugs.webkit.org/show_bug.cgi?id=113256

        Reviewed by Mark Rowe.

        * NetworkProcess/NetworkResourceLoader.h: Added some forgotten OVERRIDEs.

2013-03-26  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13194263> Crashes in NetworkProcess due to threading issues
        https://bugs.webkit.org/show_bug.cgi?id=113256

        Reviewed by Brady Eidson.

        Use asynchronous version of ResourceHandle/ResourceHandleClient in NetworkProcess.
        We now run WebCore code on main thread, so we can't block it.

        * DerivedSources.make:
        * NetworkProcess/NetworkConnectionToWebProcess.cpp:
        (WebKit::NetworkConnectionToWebProcess::didReceiveMessage):
        * NetworkProcess/NetworkResourceLoader.messages.in: Added.
        * WebKit2.xcodeproj/project.pbxproj:
        Made NetworkResourceLoader a message receiver. Messages that used to be sync are
        now async, and responses need to be sent to the loader.

        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::willSendRequestAsync): This now happens on main
        thread, and thus cannot be sync.
        (WebKit::NetworkResourceLoader::continueWillSendRequest): Notify the resource
        handle once a response is ready.
        (WebKit::NetworkResourceLoader::didSendData): Removed unnecessary WebCore prefixes.
        (WebKit::NetworkResourceLoader::didReceiveCachedMetadata): Ditto.
        (WebKit::NetworkResourceLoader::wasBlocked):  Ditto.
        (WebKit::NetworkResourceLoader::cannotShowURL): Ditto.
        (WebKit::NetworkResourceLoader::shouldUseCredentialStorageAsync): This function
        doesn't call through to WebProcess, so we can keep it synchronous. But we still
        need to implement the async version, since that's what ResourceHandle calls.
        (WebKit::NetworkResourceLoader::canAuthenticateAgainstProtectionSpaceAsync):
        Made async.
        (WebKit::NetworkResourceLoader::continueCanAuthenticateAgainstProtectionSpace):
        Notify ResourceHandle when response is ready.
        (WebKit::NetworkResourceLoader::didReceiveDataArray): Removed unnecessary WebCore prefixes.
        (WebKit::NetworkResourceLoader::willCacheResponseAsync): This matches default
        implementation, but we are overriding everything to make it clearer what's missing.
        (WebKit::NetworkResourceLoader::willStopBufferingData): Removed unnecessary WebCore prefixes.

        * NetworkProcess/NetworkResourceLoader.h: Updated to use async client methods.
        Keep ResourceRequest around while handling willSendRequest, as we need the original
        to recombine the request. Removed CFNet version of willCacheResponse for now,
        as we are not using it yet.

        * Shared/Authentication/AuthenticationManager.cpp: Assert that methods touching
        a global HashMap all run on main thread. Changed generateAuthenticationChallengeID()
        to use regular increment, as there is no need to run it from a secondary thread.

        * WebProcess/Network/NetworkProcessConnection.cpp:
        (WebKit::NetworkProcessConnection::didReceiveSyncMessage): We no longer have any
        sync messages.

        * WebProcess/Network/WebResourceLoader.h:
        * WebProcess/Network/WebResourceLoader.cpp:
        (WebKit::WebResourceLoader::willSendRequest):
        (WebKit::WebResourceLoader::canAuthenticateAgainstProtectionSpace):
        * WebProcess/Network/WebResourceLoader.messages.in:
        Changed to use async messages.

2013-03-26  Tim Horton  <timothy_horton@apple.com>

        [wk2] Don't send intrinsic content size updates more than once per runloop
        https://bugs.webkit.org/show_bug.cgi?id=113258
        <rdar://problem/13492038>

        Reviewed by Simon Fraser.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::mainFrameContentSizeChanged):
        Only start the zero-delay timer if it's not already active.

2013-03-26  Tony Chang  <tony@chromium.org>

        Autogenerate the scrollAnimatorEnabled setting in Settings.in
        https://bugs.webkit.org/show_bug.cgi?id=113253

        Reviewed by James Robinson.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::setUseFixedLayout): Update call to WebCore to use setScrollAnimatorEnabled(bool).
        (WebKit::WebPage::updatePreferences): Update call to WebCore to use setScrollAnimatorEnabled(bool).

2013-03-26  Andras Becsi  <andras.becsi@digia.com>

        [Qt][WK2] Fails to start QtWebProcess.exe if installed in a path containing spaces
        https://bugs.webkit.org/show_bug.cgi?id=113328

        Reviewed by Jocelyn Turcotte.

        Downstream bugreport: https://bugreports.qt-project.org/browse/QTBUG-30249

        We use QProcess::start() with a commandline string to start the web process
        and the string is treated by QProcess as a whitespace delimeted list of the
        command and the arguments, thus we have to escape the path to the process
        binaries so that if the path contains spaces we still run the appropriate
        command.

        * UIProcess/Launcher/qt/ProcessLauncherQt.cpp:
        (WebKit::ProcessLauncher::launchProcess):

2013-03-26  Andras Becsi  <andras.becsi@digia.com>

        [Qt][WK2] QML WebView asserts when double clicking a link
        https://bugs.webkit.org/show_bug.cgi?id=113329

        Reviewed by Jocelyn Turcotte.

        Downstream bugreport: https://bugreports.qt-project.org/browse/QTBUG-30288

        Remove an erroneous assert which is no longer valid if
        mouse gestures are enabled.

        * UIProcess/qt/QtWebPageEventHandler.cpp:
        (WebKit::QtWebPageEventHandler::handleInputEvent):

2013-03-26  Tim Horton  <timothy_horton@apple.com>

        [wk2] Don't send intrinsic content size updates more than once per runloop
        https://bugs.webkit.org/show_bug.cgi?id=113258
        <rdar://problem/13492038>

        Reviewed by Anders Carlsson.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
        (TiledCoreAnimationDrawingArea):
        Add a zero-delay timer for intrinsic content size updates.
        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::TiledCoreAnimationDrawingArea):
        Add a zero-delay timer for intrinsic content size updates.
        (WebKit::TiledCoreAnimationDrawingArea::mainFrameContentSizeChanged):
        Start our new one-shot zero-delay timer.
        (WebKit::TiledCoreAnimationDrawingArea::updateIntrinsicContentSizeTimerFired):
        Inform the WebPage that the intrinsic content size has changed.

2013-03-26  Simon Cooper  <scooper@apple.com>

        bundle-ids need to be sanitized before using them in filesystem paths
        https://bugs.webkit.org/show_bug.cgi?id=113030
        <rdar://problem/13300254>

        Reviewed by Alexey Proskuryakov.

        When choosing / looking for a specialized Sandbox for a Plugin the
        bundle-id needs to be sanitized before using it to construct a
        filesystem name to look up. The “/“ character should not be allowed
        and transformed into something else, in this case a “:”

        * PluginProcess/mac/PluginProcessMac.mm:
        (WebKit::loadSandboxProfile):

2013-03-26  Zeno Albisser  <zeno@webkit.org>

        [Qt] UIProcess should initialize WebCoreSystemInterface.
        https://bugs.webkit.org/show_bug.cgi?id=113300

        The WebCoreSystemInterface is necessary to detect supported
        mime types on Mac OS. In particular it is needed for download
        support.
        This patch fixes in particular the previously failing
        Qt API qmltest WebViewDownload::test_downloadRequest.
        The test was crashing when using QTKit, because functions
        in WebCoreSystemInterface could not be resolved on the UIProcess side.

        Reviewed by Jocelyn Turcotte.

        * UIProcess/qt/WebContextQt.cpp:
        (WebKit::WebContext::platformInitializeWebProcess):

2013-03-25  Kent Tamura  <tkent@chromium.org>

        Rename ENABLE_INPUT_TYPE_DATETIME
        https://bugs.webkit.org/show_bug.cgi?id=113254

        Reviewed by Kentaro Hara.

        Rename ENABLE_INPUT_TYPE_DATETIME to ENABLE_INPUT_TYPE_DATETIME_INCOMPLETE.
        Actually I'd like to remove the code, but we shouldn't remove it yet
        because we shipped products with it on some platforms.

        * Configurations/FeatureDefines.xcconfig:

2013-03-25  Dean Jackson  <dino@apple.com>

        Cleanup plugin snapshotting autostart decision making
        https://bugs.webkit.org/show_bug.cgi?id=113231

        Reviewed by Tim Horton.

        Two major changes to the way snapshotting plugins may autostart.

        The first is that previously WebCore was keeping a hash that
        represented the combination of page origin, plugin origin and
        mime type. WebKit was responsible for deciding if that particular
        hash should autostart. Now, WebKit keeps the hash, and WebCore
        just asks us whether the combination of origins and mimetype
        should start immediately. You can see this change the in WebPluginClient
        and WebProcess APIs.

        The second change is that we now keep two types of structures
        around to decide whether a plugin should autostart. One is the
        existing page + plugin origin combination. The other is simply
        the plugin origin, which allows plugins from major providers
        to autostart no matter what page they were embedded on.

        * Shared/WebProcessCreationParameters.cpp:
        (WebKit::WebProcessCreationParameters::encode): Encode the new parameter.
        (WebKit::WebProcessCreationParameters::decode): Decode the new parameter.
        * Shared/WebProcessCreationParameters.h: Also keep a list of strings around.

        * UIProcess/API/C/WKContext.cpp:
        (WKContextSetPlugInAutoStartOrigins): The C API to send the list of plugin
            origins over to the context.
        * UIProcess/API/C/WKContext.h:

        * UIProcess/Plugins/PlugInAutoStartProvider.cpp:
        (WebKit::PlugInAutoStartProvider::addAutoStartOriginHash): Renamed from addAutoStartOrigin.
            No functional change other than new names for members.
        (WebKit::PlugInAutoStartProvider::autoStartOriginHashesCopy): Ditto.
        (WebKit::PlugInAutoStartProvider::autoStartOriginsTableCopy): Ditto.
        (WebKit::PlugInAutoStartProvider::setAutoStartOriginsTable): Ditto.
        (WebKit::PlugInAutoStartProvider::setAutoStartOriginsArray): New method that converts the
            incoming ImmutableArray into a Vector of Strings.
        (WebKit::PlugInAutoStartProvider::didReceiveUserInteraction): Rename for new members.
        * UIProcess/Plugins/PlugInAutoStartProvider.h: Renaming member variables. Adding
            some typedefs to clean up code.
        (WebKit::PlugInAutoStartProvider::autoStartOrigins): New accessor.

        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::createNewWebProcess): Renaming, and copy the new parameter into the process creation.
        (WebKit::WebContext::addPlugInAutoStartOriginHash): Renaming.
        (WebKit::WebContext::setPlugInAutoStartOriginHashes): Renaming.
        (WebKit::WebContext::setPlugInAutoStartOrigins): New method.
        * UIProcess/WebContext.h: Adds the new setPlugInAutoStartOrigin method.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::didInitializePlugin): Drive-by fix that was attempting to restart plugins
            that were in the process of restarting.
        (WebKit::PluginView::pluginDidReceiveUserInteraction): Temporarily suspend update of
            expiration time if the user interacts with a plugin.

        * WebProcess/WebCoreSupport/WebPlugInClient.cpp:
        (WebKit::WebPlugInClient::shouldAutoStartFromOrigin): Renaming.
        (WebKit::WebPlugInClient::didStartFromOrigin): Ditto.
        * WebProcess/WebCoreSupport/WebPlugInClient.h: Renaming.

        * WebProcess/WebProcess.cpp: Drive-by - noticed that we forgot to count seconds in
            a timeout threshold.
        (WebKit::WebProcess::initializeWebProcess): Also add the list of origins when we initialize.
        (WebKit::addCaseFoldedCharacters): Copied from WebCore - adds a String to a hash input.
        (WebKit::hashForPlugInOrigin): Copied from WebCore - hashing function.
        (WebKit::WebProcess::isPlugInAutoStartOriginHash): Renaming.
        (WebKit::WebProcess::shouldPlugInAutoStartFromOrigin): Check the list of pure origins first. If
            that fails, fall back to the hash list of pairs.
        (WebKit::WebProcess::plugInDidStartFromOrigin): Renaming.
        (WebKit::WebProcess::didAddPlugInAutoStartOriginHash): Ditto.
        (WebKit::WebProcess::resetPlugInAutoStartOriginHashes): Ditto.
        (WebKit::WebProcess::plugInDidReceiveUserInteraction): Ditto.
        * WebProcess/WebProcess.h: Renaming some methods, but also adding the input of the new
            origin-only list.

        * WebProcess/WebProcess.messages.in: Renaming a message.

2013-03-25  Maxim Ermilov  <maxim.ermilov@canonical.com>

        [Qt] Qml WebKit needs preferences to change security knobs
        https://bugs.webkit.org/show_bug.cgi?id=111979

        Reviewed by Jocelyn Turcotte.

        * UIProcess/API/qt/qwebpreferences.cpp:
        (QWebPreferencesPrivate::testAttribute):
        (QWebPreferencesPrivate::setAttribute):
        (QWebPreferences::universalAccessFromFileURLsAllowed):
        (QWebPreferences::setUniversalAccessFromFileURLsAllowed):
        (QWebPreferences::fileAccessFromFileURLsAllowed):
        (QWebPreferences::setFileAccessFromFileURLsAllowed):
        * UIProcess/API/qt/qwebpreferences_p.h:
        * UIProcess/API/qt/qwebpreferences_p_p.h:

2013-03-23  Geoffrey Garen  <ggaren@apple.com>

        Added a setting for whether JavaScript markup is enabled
        https://bugs.webkit.org/show_bug.cgi?id=112999

        Rolled out a line from r146664 that was left over from before I adopted
        the Settings.in way of adding a new setting.

        Reviewed by Ryosuke Niwa.

        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::overrideBoolPreferenceForTestRunner): No need
        to initialize / override -- Settings.in settings do this automatically.

        Also, dydx noticed that this line of code had a typo, and was totaly wrong.

2013-03-21  Kiran Muppala  <cmuppala@apple.com>

        Add runtime setting for hidden page DOM timer throttling and CSS animation suspension
        https://bugs.webkit.org/show_bug.cgi?id=112308

        Reviewed by Gavin Barraclough.

        Add private preference for enabling/disabling hidden page DOM timer
        throttling and CSS animation suspension.  The preference should be
        enabled by default only on Mac, where WebKit2 is a private API and
        hence compatibility is less of a issue.

        * Shared/WebPreferencesStore.h:
        * UIProcess/API/C/WKPreferences.cpp:
        (WKPreferencesSetHiddenPageDOMTimerThrottlingEnabled):
        (WKPreferencesGetHiddenPageDOMTimerThrottlingEnabled):
        (WKPreferencesSetHiddenPageCSSAnimationSuspensionEnabled):
        (WKPreferencesGetHiddenPageCSSAnimationSuspensionEnabled):
        * UIProcess/API/C/WKPreferencesPrivate.h:
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::overrideBoolPreferenceForTestRunner): Allow
        WebKitTestRunner to override hiddenPageDOMTimerThrottlingEnabled.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::updatePreferences):

2013-03-22  Tim Horton  <timothy_horton@apple.com>

        Plugin Snapshotting: Auto-start dominant plugins
        https://bugs.webkit.org/show_bug.cgi?id=113111
        <rdar://problem/13475726>

        Reviewed by Dean Jackson.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::didInitializePlugin):
        (WebKit::PluginView::paint):
        (WebKit::PluginView::invalidateRect):
        (WebKit::PluginView::isAcceleratedCompositingEnabled):
        Acknowledge the new "Restarting" DisplayState.

2013-03-21  Jer Noble  <jer.noble@apple.com>

        After switching to another space and back, video races to catch up with audio
        https://bugs.webkit.org/show_bug.cgi?id=113006

        Reviewed by Anders Carlsson.

        Add an observer for the NSWorkspaceActiveSpaceDidChangeNotification notification, and trigger
        a visibility update when that notification is observed.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView dealloc]): Unregister the observer.
        (-[WKView _activeSpaceDidChange:]): Notify the view that its visibility may have changed.
        (-[WKView initWithFrame:contextRef:pageGroupRef:relatedToPage:]): Add the observer.

2013-03-21  Geoffrey Garen  <ggaren@apple.com>

        Added a setting for whether JavaScript markup is enabled
        https://bugs.webkit.org/show_bug.cgi?id=112999

        Reviewed by Maciej Stachowiak.

        This setting is useful for clients that want protection from script
        injection attacks.

        * Shared/WebPreferencesStore.h:
        * UIProcess/API/C/WKPreferences.cpp:
        (WKPreferencesGetJavaScriptMarkupEnabled):
        (WKPreferencesSetJavaScriptMarkupEnabled):
        (WKPreferencesGetJavaScriptEnabled):
        * UIProcess/API/C/WKPreferences.h:
        * UIProcess/API/mac/WKBrowsingContextGroup.mm:
        (-[WKBrowsingContextGroup allowsJavaScriptMarkup]):
        (-[WKBrowsingContextGroup setAllowsJavaScriptMarkup:]):
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::overrideBoolPreferenceForTestRunner):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::updatePreferences): Plumbed through to API.

2013-03-22  Mario Sanchez Prada  <mario.prada@samsung.com>

        [GTK] Include the right GL header for GLES2
        https://bugs.webkit.org/show_bug.cgi?id=113034

        Reviewed by Martin Robinson.

        Include GLES2/gl2.h when using GLES2.

        * WebProcess/WebPage/gtk/LayerTreeHostGtk.cpp:

2013-03-22  Timothy Hatcher  <timothy@apple.com>

        Fix an assert when opening the Web Inspector window for the first time.

        rdar://problem/13471765
        https://webkit.org/b/113053

        Reviewed by Eric Carlson.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::createInspectorWindow): Assign m_inspectorWindow
        earlier so it is ready for when center is called and windowDidMove: gets called.

2013-03-21  Tim Horton  <timothy_horton@apple.com>

        [wk2] Page Overlays: Don't create backing store until the client asks us to paint
        https://bugs.webkit.org/show_bug.cgi?id=112989
        <rdar://problem/13355759>

        Reviewed by Anders Carlsson.

        * WebProcess/WebCoreSupport/WebInspectorClient.cpp:
        (WebKit::WebInspectorClient::highlight):
        * WebProcess/WebPage/FindController.cpp:
        (WebKit::FindController::updateFindUIAfterPageScroll):
        Invalidate the entire overlay on installation, to maintain existing behavior
        on platforms where the fade-in animation is not performed by invalidating the overlay.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::installPageOverlay):
        Don't invalidate the overlay upon installation.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::setPageOverlayNeedsDisplay):
        Create backing store for the page overlay layer the first time it is painted into.
        (WebKit::TiledCoreAnimationDrawingArea::updateGeometry):
        Don't update the size of the page overlay layer unless we intend for it to have backing store.
        (WebKit::TiledCoreAnimationDrawingArea::createPageOverlayLayer):
        Don't create backing store when we create the page overlay layer.

2013-03-21  Brady Eidson  <beidson@apple.com>

        If a previously loaded resource is later stored to the disk cache, replace the buffer with MMAP'ed memory.
        <rdar://problem/13414154> and https://bugs.webkit.org/show_bug.cgi?id=112943

        Reviewed by Geoff Garen.

        Add a timer that will try to look up the disk cached buffer for the resource a few seconds after the load
        completes and - if the resource is disk backed - send it to the WebProcess for sharing:
        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::NetworkResourceLoader):
        (WebKit::NetworkResourceLoader::diskCacheTimerFired):
        (WebKit::NetworkResourceLoader::didReceiveResponse):
        (WebKit::NetworkResourceLoader::didReceiveData):
        (WebKit::NetworkResourceLoader::didFinishLoading):
        * NetworkProcess/NetworkResourceLoader.h:

        * NetworkProcess/mac/NetworkResourceLoaderMac.mm:
        (WebKit::NetworkResourceLoader::tryGetShareableHandleForResource):

        Refactor SharedMemory to remove the unnecessary vm_copy and only vm_allocate when an appropriate buffer
        doesn't already exist:
        * Platform/SharedMemory.h:
        * Platform/mac/SharedMemoryMac.cpp:
        (WebKit::SharedMemory::create):
        (WebKit::SharedMemory::createFromVMBuffer):
        (WebKit::SharedMemory::~SharedMemory):

        Give ShareableResource the ability to create a CFDataRef that wraps "this", and return it in a SharedBuffer:
        * Shared/ShareableResource.cpp:
        (WebKit::shareableResourceDeallocate):
        (WebKit::createShareableResourceDeallocator):
        (WebKit::ShareableResource::Handle::tryWrapInSharedBuffer):
        * Shared/ShareableResource.h:

        * Shared/WebCoreArgumentCoders.cpp: Encode/decode the cache partition for ResourceRequest.

        * WebProcess/Network/NetworkProcessConnection.cpp:
        (WebKit::NetworkProcessConnection::didReceiveMessage):
        (WebKit::NetworkProcessConnection::didCacheResource): Lookup the CachedResource in the WebCore memory cache
          and try to replace its encoded data with the shared mmap'ed buffer.
        * WebProcess/Network/NetworkProcessConnection.h:
        * WebProcess/Network/NetworkProcessConnection.messages.in:

        * WebProcess/Network/WebResourceLoader.cpp:
        (WebKit::WebResourceLoader::didReceiveResource):

2013-03-21  Tim Horton  <timothy_horton@apple.com>

        Unreviewed build fix, forgot to stage one file.

        * WebProcess/WebPage/DrawingArea.h:
        (WebKit::DrawingArea::didChangeScrollOffsetForAnyFrame):
        (DrawingArea):

2013-03-21  Tim Horton  <timothy_horton@apple.com>

        [wk2] Page overlays shouldn't dirty the entire layer when flushing if the main frame can't scroll
        https://bugs.webkit.org/show_bug.cgi?id=111662
        <rdar://problem/13355808>

        Reviewed by Dean Jackson.

        Instead of setNeedsDisplay()ing the whole page overlay layer every time through
        TCADA::flushLayers, do it at scroll time instead. Repainting on scroll is
        necessary to keep things painted in the right place when we scroll (the overlay
        is fixed to the size of the view), but is quite wasteful in apps that don’t scroll.

        This works with threaded scrolling because overlay installation forces us
        into main-thread scrolling mode.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::didChangeScrollOffset):
        Plumb scroll offset changes through to the drawing area, so it can invalidate the page overlay.
        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
        (TiledCoreAnimationDrawingArea):
        Add didChangeScrollOffsetForAnyFrame, for WebFrameLoaderClient to call us back when any frame scrolls.
        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::didChangeScrollOffsetForAnyFrame):
        Invalidate the page overlay when any frame scrolls, so that find indicators in subframes are kept in the right place.
        (WebKit::TiledCoreAnimationDrawingArea::flushLayers):
        Stop unconditionally invalidating the page overlay when we flush layers.

2013-03-21  Alexey Proskuryakov  <ap@apple.com>

        [Mac] Move NSOperationQueue out of NetworkingContext
        https://bugs.webkit.org/show_bug.cgi?id=112970

        Reviewed by Brady Eidson.

        * NetworkProcess/NetworkResourceLoader.h:
        * NetworkProcess/mac/RemoteNetworkingContext.h:
        * NetworkProcess/mac/RemoteNetworkingContext.mm:
        Tell ResourceHandle to use an operation queue in the new way.

2013-03-21  Timothy Hatcher  <timothy@apple.com>

        Support connecting the Web Inspector without showing it.

        This allows you to get the debugger attached in the background. When a breakpoint is hit
        the Inspector will open. This change also reduces some WebProcess messaging by removing
        the DidLoadInspectorPage message and stops sending the SetAttachedWindow message on close.

        https://bugs.webkit.org/show_bug.cgi?id=112445

        Reviewed by Sam Weinig.

        * UIProcess/API/C/WKInspector.cpp:
        (WKInspectorIsConnected): Added.
        (WKInspectorConnect): Added.
        (WKInspectorHide): Added.

        * UIProcess/API/C/WKInspector.h:
        Added new APIs.

        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::WebInspectorProxy::WebInspectorProxy):
        Initialize new state booleans.

        (WebKit::WebInspectorProxy::invalidate):
        Don't set state booleans that didClose already resets.

        (WebKit::WebInspectorProxy::connect): Added.
        (WebKit::WebInspectorProxy::show):
        Open if we are already connected. Call connect().

        (WebKit::WebInspectorProxy::hide): Added.

        (WebKit::WebInspectorProxy::close):
        Call didClose we can detach or close the window immediately instead of waiting for a
        message from the WebProcess.

        (WebKit::WebInspectorProxy::attach):
        (WebKit::WebInspectorProxy::detach):
        Check for !m_page to match other functions.

        (WebKit::WebInspectorProxy::createInspectorPage):
        (WebKit::WebInspectorProxy::didLoadInspectorPage):
        Removed. Moved logic to open().

        (WebKit::WebInspectorProxy::open): Added.

        (WebKit::WebInspectorProxy::didClose):
        Clear new state booleans. Don't perform work again if already closed. Use platformDetach()
        instead of detach() to avoid sending the SetAttachedWindow message.

        (WebKit::WebInspectorProxy::bringToFront):
        Call open() if we are not visible yet, otherwise platformBringToFront.

        * UIProcess/WebInspectorProxy.h:
        (WebKit::WebInspectorProxy::isConnected): Added.

        * UIProcess/WebInspectorProxy.messages.in: Removed DidLoadInspectorPage.

        * UIProcess/gtk/WebInspectorProxyGtk.cpp:
        (WebKit::WebInspectorProxy::platformHide): Added stub.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::platformHide): Added.

        * UIProcess/qt/WebInspectorProxyQt.cpp:
        (WebKit::WebInspectorProxy::platformHide): Added stub.

        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.cpp:
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.h:
        Removed frontendLoaded().

        * WebProcess/WebPage/WebInspector.cpp:
        * WebProcess/WebPage/WebInspector.h:
        Removed didLoadInspectorPage().

2013-03-21  Alexey Proskuryakov  <ap@apple.com>

        Build fix.

        * NetworkProcess/mac/NetworkResourceLoaderMac.mm: Include CurrentTime.h, as needed
        to call currentTime().

2013-03-21  Tim Horton  <timothy_horton@apple.com>

        Tiled page overlay layers don't create tiles until the first flush after they switch to being tiled
        https://bugs.webkit.org/show_bug.cgi?id=112860
        <rdar://problem/13468400>

        Reviewed by Simon Fraser.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
        (TiledCoreAnimationDrawingArea): Add storage for m_clipsToExposedRect.
        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::flushLayers):
        The page overlay layer will never have children, so we can use flushCompositingState instead of the ForThisLayerOnly variant.
        Pass the visible rect of the page overlay layer (computed by intersecting its bounds with the exposed
        rect that comes from the WKView) to flushCompositingState; don't bother setting the visible rect manually.
        (WebKit::TiledCoreAnimationDrawingArea::mainFrameScrollabilityChanged):
        Store m_clipsToExposedRect so we can use it in flushLayers.

2013-03-20  Benjamin Poulain  <bpoulain@apple.com>

        [WK2] Remove VIEW_MODE_CSS_MEDIA from WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=112849

        Reviewed by Sam Weinig.

        The code was added in r137148 for the sole purpose of testing,
        and it is not even being properly tested.

        Remove the code until someone actually implement the feature in WebKit2.

        * WebProcess/InjectedBundle/API/c/WKBundlePage.cpp:
        (WKBundlePageCanShowMIMEType):
        * WebProcess/InjectedBundle/API/c/WKBundlePagePrivate.h:
        * WebProcess/WebPage/WebPage.cpp:
        * WebProcess/WebPage/WebPage.h:
        (WebPage):

2013-03-20  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Build ANGLE sources into a separate library from libWebCore.la
        https://bugs.webkit.org/show_bug.cgi?id=112778

        Reviewed by Martin Robinson.

        * GNUmakefile.am: Add libLevelDB.la to the libwebkit2gtk library if using the OpenGL accelerated backend.

2013-03-20  Andras Becsi  <andras.becsi@digia.com>

        [Qt][WK2] Clean up sanity checks related to gesture recognition
        https://bugs.webkit.org/show_bug.cgi?id=112679

        Reviewed by Jocelyn Turcotte.

        The only callers of the panGestureActive and pinchGestureActive member
        functions of the page viewport controller client are event delivery
        related sanity check assers, thus they can be replaced by checking
        for the corresponding internal states and therefore the superfluous
        members can be removed.
        Also update other asserts in the page viewport controller client to
        be more accurate about the expected states.

        * UIProcess/qt/PageViewportControllerClientQt.cpp:
        (WebKit::PageViewportControllerClientQt::animateContentRectVisible):
        (WebKit::PageViewportControllerClientQt::touchBegin):
        (WebKit::PageViewportControllerClientQt::panGestureStarted):
        (WebKit::PageViewportControllerClientQt::pinchGestureStarted):
        * UIProcess/qt/PageViewportControllerClientQt.h:
        (PageViewportControllerClientQt):
        * UIProcess/qt/QtWebPageEventHandler.cpp:
        (WebKit::QtWebPageEventHandler::handleInputEvent):

2013-03-20  Andras Becsi  <andras.becsi@digia.com>

        [Qt][WK2] Refactor handling of content suspension to properly cover corner cases
        https://bugs.webkit.org/show_bug.cgi?id=111751

        Reviewed by Jocelyn Turcotte.

        The current suspend / resume infrastructure turned out to be insufficient to cover
        all corner cases during transitions between gestures of complex gesture chains.

        The requirements for robust suspend / resume handling are:
            - Keep the content suspended while the user is continuously interacting,
        eg. does not lift the finger between transition from a pan to a pinch gesture
        and vice versa.
            - The content should not be suspended unnecessarily (like for a tap gesture),
        only during panning and scroll animation (flick), as well as pinch zoom and scale
        animation (also includes double-tap-to-zoom).
            - The content should never end up stuck in suspended state after long gesture
        chains and continuous interaction.

        This patch reintroduces reference counting based suspension in form of a new
        ViewportInteractionTracker member class to make it possible to reliably control the
        suspend / resume cycles during scrolling and scaling.
        During continuous gestures, while the user is interacting, the reference count is
        increased without actually suspending the content to prevent resuming unnecessarily
        during continuous interaction. At the same time this also assures that the page is
        not suspended for simple tap gestures, which was a side-effect of the previous
        approach based on update deferrers.
        The newly added functionality replaces boolean members that tried to achive the
        above requirements.
        Additionally this patch also removes the redundant m_hasSuspendedContent member
        from the PageViewportController since WebPageProxy already keeps this information.

        * UIProcess/PageViewportController.cpp:
        (WebKit::PageViewportController::PageViewportController):
        (WebKit::PageViewportController::pageDidRequestScroll):
        (WebKit::PageViewportController::updateMinimumScaleToFit):
        * UIProcess/PageViewportController.h:
        (PageViewportController):
        * UIProcess/WebPageProxy.h:
        (WebKit::WebPageProxy::areActiveDOMObjectsAndAnimationsSuspended):
        * UIProcess/qt/PageViewportControllerClientQt.cpp:
        (WebKit::PageViewportControllerClientQt::PageViewportControllerClientQt):
        (WebKit::PageViewportControllerClientQt::ViewportInteractionTracker::begin):
        (WebKit):
        (WebKit::PageViewportControllerClientQt::ViewportInteractionTracker::end):
        (WebKit::PageViewportControllerClientQt::animateContentRectVisible):
        (WebKit::PageViewportControllerClientQt::flickMoveStarted):
        (WebKit::PageViewportControllerClientQt::flickMoveEnded):
        (WebKit::PageViewportControllerClientQt::pageItemPositionChanged):
        (WebKit::PageViewportControllerClientQt::scaleAnimationStateChanged):
        (WebKit::PageViewportControllerClientQt::touchBegin):
        (WebKit::PageViewportControllerClientQt::touchEnd):
        (WebKit::PageViewportControllerClientQt::zoomToAreaGestureEnded):
        (WebKit::PageViewportControllerClientQt::pinchGestureStarted):
        (WebKit::PageViewportControllerClientQt::pinchGestureRequestUpdate):
        (WebKit::PageViewportControllerClientQt::pinchGestureEnded):
        (WebKit::PageViewportControllerClientQt::pinchGestureCancelled):
        (WebKit::PageViewportControllerClientQt::didChangeContentsSize):
        * UIProcess/qt/PageViewportControllerClientQt.h:
        (ViewportInteractionTracker):
        (WebKit::PageViewportControllerClientQt::ViewportInteractionTracker::ViewportInteractionTracker):
        (WebKit::PageViewportControllerClientQt::ViewportInteractionTracker::inProgress):
        (PageViewportControllerClientQt):

2013-03-19  Kenneth Rohde Christiansen  <kenneth@webkit.org> and Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [EFL][WK2] Separate WebView further from EwkView
        https://bugs.webkit.org/show_bug.cgi?id=111591

        Reviewed by Caio Marcelo de Oliveira Filho.

        Main points are:
        - WKView API has no dependency on EFL types
        - WebView class does not store the Evas_Object

        * UIProcess/API/C/efl/WKView.cpp:
        (WKViewCreate):

            WKView creation does not require any EFL objects to be passed.

        * UIProcess/API/C/efl/WKView.h:
        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::EwkView):
        (EwkView::create):

            WKViewRef is passed to EwkView constructor from outside rather than
            created inside.

        (EwkView::webView):
        * UIProcess/API/efl/EwkView.h:
        (EwkView):
        (EwkView::wkView):
        (EwkView::page):

            EwkView keeps WKViewRef rather than pointer to WebView class.

        * UIProcess/API/efl/ewk_view_private.h: Added.
        (EWKViewCreate):
        (EWKViewGetWKView):

            Added private API to create ewk view evas object and return its WKViewRef.

        * UIProcess/API/efl/ewk_view.cpp:
        (ewkCreateEvasObject):
        (ewk_view_smart_add):
        (ewk_view_add):
        (ewk_view_add_with_context):
        * UIProcess/efl/WebInspectorProxyEfl.cpp:
        (WebKit::WebInspectorProxy::platformCreateInspectorPage):

            Updated accordingly to the new APIs.

        * UIProcess/efl/WebView.cpp:
        (WebKit::WebView::WebView):
        (WebKit::WebView::create):
        (WebKit):
        (WebKit::WebView::setEwkView):
        (WebKit::WebView::isViewFocused):
        (WebKit::WebView::isViewVisible):
        * UIProcess/efl/WebView.h:
        (WebView):

            Implementation of updated WKView API.

2013-03-19  Dean Jackson  <dino@apple.com>

        Allow PlugIn Snapshotting to be tested
        https://bugs.webkit.org/show_bug.cgi?id=98696

        Reviewed by Tim Horton.

        Use the new maximumPlugInSnapshotAttempts setting rather than a hardcoded
        value. At the same time, if this value is 0, then snapshot immediately
        (don't wait to get a snapshot and test it).

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::didInitializePlugin): Snapshot immediately if maximum attempts are 0.
        (WebKit::PluginView::pluginSnapshotTimerFired): Use setting rather than file local variable.

2013-03-19  Dean Jackson  <dino@apple.com>

        Restarting a snapshotted plugin should restart all plugins from the same domain on the page
        https://bugs.webkit.org/show_bug.cgi?id=112725

        Reviewed by Tim Horton.

        When we add a plugin domain hash to the list of sites that autostart, we
        send a message to our owning process. That message might not return before
        another plugin queries if it is in the list. So, before we send the message,
        add the current hash to the list with a very small timeout. That way the
        response will be to either extend the timeout, or not add the hash (in which
        case it will expire soon).

        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::addPlugInAutoStartOrigin):

2013-03-19  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Fix WebKit2 builds after r146193
        https://bugs.webkit.org/show_bug.cgi?id=112700

        Reviewed by Martin Robinson.

        Apply changes to the LayerTreeHostGtk class that are analogous to changes made in r146193
        to the LayerTreeHostMac class, namely introducing a PageOverlayLayersMap and using that as
        the source of GraphicsLayer objects that should be operated on, making it possible to
        support multiple page overlays.

        * WebProcess/WebPage/gtk/LayerTreeHostGtk.cpp:
        (WebKit::LayerTreeHostGtk::initialize):
        (WebKit::LayerTreeHostGtk::invalidate):
        (WebKit::LayerTreeHostGtk::setNonCompositedContentsNeedDisplay):
        (WebKit::LayerTreeHostGtk::setNonCompositedContentsNeedDisplayInRect):
        (WebKit::LayerTreeHostGtk::sizeDidChange):
        (WebKit::LayerTreeHostGtk::didInstallPageOverlay):
        (WebKit::LayerTreeHostGtk::didUninstallPageOverlay):
        (WebKit::LayerTreeHostGtk::setPageOverlayNeedsDisplay):
        (WebKit::LayerTreeHostGtk::paintContents):
        (WebKit::LayerTreeHostGtk::flushPendingLayerChanges):
        (WebKit::LayerTreeHostGtk::createPageOverlayLayer):
        (WebKit::LayerTreeHostGtk::destroyPageOverlayLayer):
        * WebProcess/WebPage/gtk/LayerTreeHostGtk.h:
        (LayerTreeHostGtk):

2013-03-19  Tim Horton  <timothy_horton@apple.com>

        [wk2] Should support multiple page overlays, like the API suggests
        https://bugs.webkit.org/show_bug.cgi?id=112505
        <rdar://problem/13424796>

        Reviewed by Simon Fraser.

        * WebProcess/WebPage/DrawingAreaImpl.h:
        * WebProcess/WebPage/LayerTreeHost.h:
        * WebProcess/WebPage/DrawingArea.h:
        (WebKit::DrawingArea::didInstallPageOverlay):
        (WebKit::DrawingArea::didUninstallPageOverlay):
        (WebKit::DrawingArea::setPageOverlayNeedsDisplay):
        (WebKit::DrawingArea::setPageOverlayOpacity):
        Add PageOverlay argument.

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::didInstallPageOverlay):
        (WebKit::DrawingAreaImpl::didUninstallPageOverlay):
        (WebKit::DrawingAreaImpl::setPageOverlayNeedsDisplay):
        (WebKit::DrawingAreaImpl::setPageOverlayOpacity):
        Add PageOverlay argument, forward it to LayerTreeHost.
        (WebKit::DrawingAreaImpl::display):
        Paint all of the PageOverlays that WebPage knows about.

        * WebProcess/WebPage/PageOverlay.cpp:
        (WebKit::PageOverlay::setNeedsDisplay):
        (WebKit::PageOverlay::fadeAnimationTimerFired):
        Pass the relevant PageOverlay into the DrawingArea methods that now take it.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::drawPageOverlay):
        Take the PageOverlay to draw as an argument.
        (WebKit::WebPage::installPageOverlay):
        (WebKit::WebPage::uninstallPageOverlay):
        Allow (un)installation of multiple PageOverlays.
        (WebKit::WebPage::mouseEvent):
        (WebKit::WebPage::mouseEventSyncForTesting):
        Hit-test PageOverlays in reverse order of installation (most recently installed should be topmost).

        * WebProcess/WebPage/WebPage.h:
        (WebKit::WebPage::drawPageOverlay): Take the PageOverlay to draw as an argument.
        (WebKit::WebPage::hasPageOverlay): Return true if we have any number of overlays.
        (WebKit::WebPage::pageOverlays): Return the whole vector of overlays.

        * WebProcess/WebPage/mac/LayerTreeHostMac.h:
        Add PageOverlay argument to a few methods.
        Add storage for a map of PageOverlay->GraphicsLayers.

        * WebProcess/WebPage/mac/LayerTreeHostMac.mm:
        (WebKit::LayerTreeHostMac::setNonCompositedContentsNeedDisplay):
        (WebKit::LayerTreeHostMac::setNonCompositedContentsNeedDisplayInRect):
        (WebKit::LayerTreeHostMac::sizeDidChange):
        (WebKit::LayerTreeHostMac::flushPendingLayerChanges):
        Operate on all installed PageOverlays, not just the most recently installed one.

        (WebKit::LayerTreeHostMac::didInstallPageOverlay):
        (WebKit::LayerTreeHostMac::didUninstallPageOverlay):
        Forward the passed-in PageOverlay on to createPageOverlayLayer/destroyPageOverlayLayer.

        (WebKit::LayerTreeHostMac::setPageOverlayNeedsDisplay):
        Look up the GraphicsLayer for the PageOverlay we need to dirty, and dirty it.

        (WebKit::LayerTreeHostMac::paintContents):
        Find the PageOverlay corresponding to the GraphicsLayer that we're painting, and ask WebPage to paint it.
        While not ideal (crawling the map), the vast majority of the time there will only be one entry.

        (WebKit::LayerTreeHostMac::initialize):
        Create layers for all of WebPage's active PageOverlays.
        
        (WebKit::LayerTreeHostMac::createPageOverlayLayer):
        Stick the newly-created GraphicsLayer into the m_pageOverlays map.
        Also, drive-by add support for accelerated overlays and debug borders/repaint counters in overlays.

        (WebKit::LayerTreeHostMac::destroyPageOverlayLayer):
        Remove the relevant overlay from the m_pageOverlays map and tear it down.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
        (TiledCoreAnimationDrawingArea):
        Add PageOverlay argument to a few methods.
        Add storage for a map of PageOverlay->GraphicsLayers.
        Add storage for a map of GraphicsLayer->CALayers.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::didInstallPageOverlay):
        Pass PageOverlay argument on to createPageOverlayLayer.
        
        (WebKit::TiledCoreAnimationDrawingArea::didUninstallPageOverlay):
        Pass PageOverlay argument on to destroyPageOverlayLayer.
        Refrain from re-enabling threaded scrolling if there are still more overlays installed.
        
        (WebKit::TiledCoreAnimationDrawingArea::setPageOverlayNeedsDisplay):
        Look up the GraphicsLayer for the PageOverlay we need to dirty, and dirty it.

        (WebKit::TiledCoreAnimationDrawingArea::paintContents):
        Find the PageOverlay corresponding to the GraphicsLayer that we're painting, and ask WebPage to paint it.
        While not ideal (crawling the map), the vast majority of the time there will only be one entry.

        (WebKit::TiledCoreAnimationDrawingArea::updatePreferences):
        (WebKit::TiledCoreAnimationDrawingArea::flushLayers):
        (WebKit::TiledCoreAnimationDrawingArea::setExposedRect):
        (WebKit::TiledCoreAnimationDrawingArea::mainFrameScrollabilityChanged):
        (WebKit::TiledCoreAnimationDrawingArea::updateGeometry):
        (WebKit::TiledCoreAnimationDrawingArea::setRootCompositingLayer):
        Operate on all installed PageOverlays, not just the most recently installed one.

        (WebKit::TiledCoreAnimationDrawingArea::createPageOverlayLayer):
        Stick the newly-created GraphicsLayer into the m_pageOverlays map.
        Also, add its platformLayer to our m_pageOverlayPlatformLayers map.

        (WebKit::TiledCoreAnimationDrawingArea::destroyPageOverlayLayer):
        Remove the relevant overlay from the m_pageOverlays and m_pageOverlayPlatformLayers maps and tear it down.

        (WebKit::TiledCoreAnimationDrawingArea::didCommitChangesForLayer):
        When we commit changes for the layer, if the GraphicsLayer's backing platform CALayer
        has changed out from under us (we have a reference to the previous one in the m_pageOverlayPlatformLayers map),
        the GraphicsLayer has probably switched to/from a tiled layer, and we need to swap out the
        layer we have inserted into the root layer. We need to keep the layer ordering consistent with
        installation order, as well.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::didInstallPageOverlay):
        Assert if we try to install more than one page overlay into a CoordinatedLayerTreeHost,
        as this patch does not implement multiple overlay support for Coordinated Graphics.
        Keep track of the current PageOverlay so that paintContents can hand WebPage the right one.
        (WebKit::CoordinatedLayerTreeHost::didUninstallPageOverlay): Remove our reference to the PageOverlay.
        (WebKit::CoordinatedLayerTreeHost::setPageOverlayNeedsDisplay): Add unused PageOverlay argument.
        (WebKit::CoordinatedLayerTreeHost::setPageOverlayOpacity): Add unused PageOverlay argument.
        (WebKit::CoordinatedLayerTreeHost::paintContents): Hand WebPage the PageOverlay we're currently displaying.
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.h:
        (CoordinatedLayerTreeHost): Add PageOverlay* argument to relevant functions, and storage for m_pageOverlay.

2013-03-19  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r146183.
        http://trac.webkit.org/changeset/146183
        https://bugs.webkit.org/show_bug.cgi?id=112673

        Caused a few dozens of editing tests to fail on Mac WK2
        (Requested by rniwa on #webkit).

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::didInstallPageOverlay):
        (WebKit::CoordinatedLayerTreeHost::didUninstallPageOverlay):
        (WebKit::CoordinatedLayerTreeHost::setPageOverlayNeedsDisplay):
        (WebKit::CoordinatedLayerTreeHost::setPageOverlayOpacity):
        (WebKit::CoordinatedLayerTreeHost::paintContents):
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.h:
        (CoordinatedLayerTreeHost):
        * WebProcess/WebPage/DrawingArea.h:
        (WebKit):
        (WebKit::DrawingArea::didInstallPageOverlay):
        (WebKit::DrawingArea::didUninstallPageOverlay):
        (WebKit::DrawingArea::setPageOverlayNeedsDisplay):
        (WebKit::DrawingArea::setPageOverlayOpacity):
        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::didInstallPageOverlay):
        (WebKit::DrawingAreaImpl::didUninstallPageOverlay):
        (WebKit::DrawingAreaImpl::setPageOverlayNeedsDisplay):
        (WebKit::DrawingAreaImpl::setPageOverlayOpacity):
        (WebKit::DrawingAreaImpl::display):
        * WebProcess/WebPage/DrawingAreaImpl.h:
        (DrawingAreaImpl):
        * WebProcess/WebPage/LayerTreeHost.h:
        (LayerTreeHost):
        (WebKit::LayerTreeHost::setPageOverlayOpacity):
        * WebProcess/WebPage/PageOverlay.cpp:
        (WebKit::PageOverlay::setNeedsDisplay):
        (WebKit::PageOverlay::fadeAnimationTimerFired):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::drawPageOverlay):
        (WebKit::WebPage::installPageOverlay):
        (WebKit::WebPage::uninstallPageOverlay):
        (WebKit::WebPage::mouseEvent):
        (WebKit::WebPage::mouseEventSyncForTesting):
        * WebProcess/WebPage/WebPage.h:
        (WebKit):
        (WebPage):
        (WebKit::WebPage::hasPageOverlay):
        * WebProcess/WebPage/mac/LayerTreeHostMac.h:
        (WebKit):
        (LayerTreeHostMac):
        * WebProcess/WebPage/mac/LayerTreeHostMac.mm:
        (WebKit::LayerTreeHostMac::setNonCompositedContentsNeedDisplay):
        (WebKit::LayerTreeHostMac::setNonCompositedContentsNeedDisplayInRect):
        (WebKit::LayerTreeHostMac::sizeDidChange):
        (WebKit::LayerTreeHostMac::didInstallPageOverlay):
        (WebKit::LayerTreeHostMac::didUninstallPageOverlay):
        (WebKit::LayerTreeHostMac::setPageOverlayNeedsDisplay):
        (WebKit::LayerTreeHostMac::paintContents):
        (WebKit::LayerTreeHostMac::initialize):
        (WebKit::LayerTreeHostMac::flushPendingLayerChanges):
        (WebKit::LayerTreeHostMac::createPageOverlayLayer):
        (WebKit::LayerTreeHostMac::destroyPageOverlayLayer):
        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
        (TiledCoreAnimationDrawingArea):
        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::didInstallPageOverlay):
        (WebKit::TiledCoreAnimationDrawingArea::didUninstallPageOverlay):
        (WebKit::TiledCoreAnimationDrawingArea::setPageOverlayNeedsDisplay):
        (WebKit::TiledCoreAnimationDrawingArea::updatePreferences):
        (WebKit::TiledCoreAnimationDrawingArea::paintContents):
        (WebKit::TiledCoreAnimationDrawingArea::flushLayers):
        (WebKit::TiledCoreAnimationDrawingArea::setExposedRect):
        (WebKit::TiledCoreAnimationDrawingArea::mainFrameScrollabilityChanged):
        (WebKit::TiledCoreAnimationDrawingArea::updateGeometry):
        (WebKit::TiledCoreAnimationDrawingArea::setRootCompositingLayer):
        (WebKit::TiledCoreAnimationDrawingArea::createPageOverlayLayer):
        (WebKit::TiledCoreAnimationDrawingArea::destroyPageOverlayLayer):
        (WebKit::TiledCoreAnimationDrawingArea::didCommitChangesForLayer):

2013-03-18  Tim Horton  <timothy_horton@apple.com>

        [wk2] Should support multiple page overlays, like the API suggests
        https://bugs.webkit.org/show_bug.cgi?id=112505
        <rdar://problem/13424796>

        Reviewed by Simon Fraser.

        * WebProcess/WebPage/DrawingAreaImpl.h:
        * WebProcess/WebPage/LayerTreeHost.h:
        * WebProcess/WebPage/DrawingArea.h:
        (WebKit::DrawingArea::didInstallPageOverlay):
        (WebKit::DrawingArea::didUninstallPageOverlay):
        (WebKit::DrawingArea::setPageOverlayNeedsDisplay):
        (WebKit::DrawingArea::setPageOverlayOpacity):
        Add PageOverlay argument.

        * WebProcess/WebPage/DrawingAreaImpl.cpp:
        (WebKit::DrawingAreaImpl::didInstallPageOverlay):
        (WebKit::DrawingAreaImpl::didUninstallPageOverlay):
        (WebKit::DrawingAreaImpl::setPageOverlayNeedsDisplay):
        (WebKit::DrawingAreaImpl::setPageOverlayOpacity):
        Add PageOverlay argument, forward it to LayerTreeHost.
        (WebKit::DrawingAreaImpl::display):
        Paint all of the PageOverlays that WebPage knows about.

        * WebProcess/WebPage/PageOverlay.cpp:
        (WebKit::PageOverlay::setNeedsDisplay):
        (WebKit::PageOverlay::fadeAnimationTimerFired):
        Pass the relevant PageOverlay into the DrawingArea methods that now take it.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::drawPageOverlay):
        Take the PageOverlay to draw as an argument.
        (WebKit::WebPage::installPageOverlay):
        (WebKit::WebPage::uninstallPageOverlay):
        Allow (un)installation of multiple PageOverlays.
        (WebKit::WebPage::mouseEvent):
        (WebKit::WebPage::mouseEventSyncForTesting):
        Hit-test PageOverlays in reverse order of installation (most recently installed should be topmost).

        * WebProcess/WebPage/WebPage.h:
        (WebKit::WebPage::drawPageOverlay): Take the PageOverlay to draw as an argument.
        (WebKit::WebPage::hasPageOverlay): Return true if we have any number of overlays.
        (WebKit::WebPage::pageOverlays): Return the whole vector of overlays.

        * WebProcess/WebPage/mac/LayerTreeHostMac.h:
        Add PageOverlay argument to a few methods.
        Add storage for a map of PageOverlay->GraphicsLayers.

        * WebProcess/WebPage/mac/LayerTreeHostMac.mm:
        (WebKit::LayerTreeHostMac::setNonCompositedContentsNeedDisplay):
        (WebKit::LayerTreeHostMac::setNonCompositedContentsNeedDisplayInRect):
        (WebKit::LayerTreeHostMac::sizeDidChange):
        (WebKit::LayerTreeHostMac::flushPendingLayerChanges):
        Operate on all installed PageOverlays, not just the most recently installed one.

        (WebKit::LayerTreeHostMac::didInstallPageOverlay):
        (WebKit::LayerTreeHostMac::didUninstallPageOverlay):
        Forward the passed-in PageOverlay on to createPageOverlayLayer/destroyPageOverlayLayer.

        (WebKit::LayerTreeHostMac::setPageOverlayNeedsDisplay):
        Look up the GraphicsLayer for the PageOverlay we need to dirty, and dirty it.

        (WebKit::LayerTreeHostMac::paintContents):
        Find the PageOverlay corresponding to the GraphicsLayer that we're painting, and ask WebPage to paint it.
        While not ideal (crawling the map), the vast majority of the time there will only be one entry.

        (WebKit::LayerTreeHostMac::initialize):
        Create layers for all of WebPage's active PageOverlays.
        
        (WebKit::LayerTreeHostMac::createPageOverlayLayer):
        Stick the newly-created GraphicsLayer into the m_pageOverlayLayers map.
        Also, drive-by add support for accelerated overlays and debug borders/repaint counters in overlays.

        (WebKit::LayerTreeHostMac::destroyPageOverlayLayer):
        Remove the relevant overlay from the m_pageOverlayLayers map and tear it down.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
        (TiledCoreAnimationDrawingArea):
        Add PageOverlay argument to a few methods.
        Add storage for a map of PageOverlay->GraphicsLayers.
        Add storage for a map of GraphicsLayer->CALayers.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::didInstallPageOverlay):
        Pass PageOverlay argument on to createPageOverlayLayer.
        
        (WebKit::TiledCoreAnimationDrawingArea::didUninstallPageOverlay):
        Pass PageOverlay argument on to destroyPageOverlayLayer.
        Refrain from re-enabling threaded scrolling if there are still more overlays installed.
        
        (WebKit::TiledCoreAnimationDrawingArea::setPageOverlayNeedsDisplay):
        Look up the GraphicsLayer for the PageOverlay we need to dirty, and dirty it.

        (WebKit::TiledCoreAnimationDrawingArea::paintContents):
        Find the PageOverlay corresponding to the GraphicsLayer that we're painting, and ask WebPage to paint it.
        While not ideal (crawling the map), the vast majority of the time there will only be one entry.

        (WebKit::TiledCoreAnimationDrawingArea::updatePreferences):
        (WebKit::TiledCoreAnimationDrawingArea::flushLayers):
        (WebKit::TiledCoreAnimationDrawingArea::setExposedRect):
        (WebKit::TiledCoreAnimationDrawingArea::mainFrameScrollabilityChanged):
        (WebKit::TiledCoreAnimationDrawingArea::updateGeometry):
        (WebKit::TiledCoreAnimationDrawingArea::setRootCompositingLayer):
        Operate on all installed PageOverlays, not just the most recently installed one.

        (WebKit::TiledCoreAnimationDrawingArea::createPageOverlayLayer):
        Stick the newly-created GraphicsLayer into the m_pageOverlayLayers map.
        Also, add its platformLayer to our m_pageOverlayPlatformLayers map.

        (WebKit::TiledCoreAnimationDrawingArea::destroyPageOverlayLayer):
        Remove the relevant overlay from the m_pageOverlayLayers and m_pageOverlayPlatformLayers maps and tear it down.

        (WebKit::TiledCoreAnimationDrawingArea::didCommitChangesForLayer):
        When we commit changes for the layer, if the GraphicsLayer's backing platform CALayer
        has changed out from under us (we have a reference to the previous one in the m_pageOverlayPlatformLayers map),
        the GraphicsLayer has probably switched to/from a tiled layer, and we need to swap out the
        layer we have inserted into the root layer. We need to keep the layer ordering consistent with
        installation order, as well.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::didInstallPageOverlay):
        Assert if we try to install more than one page overlay into a CoordinatedLayerTreeHost,
        as this patch does not implement multiple overlay support for Coordinated Graphics.
        Keep track of the current PageOverlay so that paintContents can hand WebPage the right one.
        (WebKit::CoordinatedLayerTreeHost::didUninstallPageOverlay): Remove our reference to the PageOverlay.
        (WebKit::CoordinatedLayerTreeHost::setPageOverlayNeedsDisplay): Add unused PageOverlay argument.
        (WebKit::CoordinatedLayerTreeHost::setPageOverlayOpacity): Add unused PageOverlay argument.
        (WebKit::CoordinatedLayerTreeHost::paintContents): Hand WebPage the PageOverlay we're currently displaying.
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.h:
        (CoordinatedLayerTreeHost): Add PageOverlay* argument to relevant functions, and storage for m_pageOverlay.

2013-03-18  Sam Weinig  <sam@webkit.org>

        Need a bundle SPI to generate a snapshot of a specific DOM node (like [DOMNode renderedImage])
        <rdar://problem/13148631>
        https://bugs.webkit.org/show_bug.cgi?id=110034

        Reviewed by Tim Horton.

        * WebProcess/InjectedBundle/API/c/WKBundleNodeHandle.cpp:
        (WKBundleNodeHandleCopySnapshotWithOptions):
        * WebProcess/InjectedBundle/API/c/WKBundleNodeHandlePrivate.h:
        Add WKBundleNodeHandleCopySnapshotWithOptions function.

        * WebProcess/InjectedBundle/API/mac/WKDOMNode.mm:
        * WebProcess/InjectedBundle/API/mac/WKDOMNodePrivate.h:
        Fix conversion method between WKDOMNode and WKBundleNodeHandleRef to have the same
        name in the header and implementation.

        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.cpp:
        (WebKit::imageForRect):
        (WebKit):
        (WebKit::InjectedBundleNodeHandle::renderedImage):
        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.h:
        Add implementation of WKBundleNodeHandleCopySnapshotWithOptions.

        * Shared/ImageOptions.h:
        (WebKit::snapshotOptionsToImageOptions):
        * WebProcess/WebPage/WebPage.cpp:
        Move snapshotOptionsToImageOptions conversion function to a location where
        it can be shared.

2013-03-18  Andreas Kling  <akling@apple.com>

        [WK2][Mac] Don't consider empty window frames cacheable.
        <http://webkit.org/b/112631>
        <rdar://problem/13384894>

        Reviewed by Anders Carlsson.

        If the UI client overrides getWindowFrame() and returns an empty rect, send that over
        to the web process and mark it as uncached. This forces the next ChromeClient::windowRect()
        call to synchronously retrieve the window frame from the other side.

        Fixes an issue with the Mac Web Inspector which uses empty rects to signify that there is
        no known window frame yet. In this case, we should not be falling back to the native frame.

        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::windowAndViewFramesChanged):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::windowAndViewFramesChanged):

2013-03-18  Brady Eidson  <beidson@apple.com>

        Mac build fix after http://trac.webkit.org/changeset/146088

        * NetworkProcess/mac/NetworkResourceLoaderMac.mm:
        (WebKit::NetworkResourceLoader::platformDidReceiveResponse):

2013-03-18  Brady Eidson  <beidson@apple.com>

        NetworkProcess should send vm_copied, mmap'ed memory to WebProcesses when a 
        resource is already in the disk cache.
        <rdar://problem/13414153> and https://bugs.webkit.org/show_bug.cgi?id=112387

        Reviewed by Geoff Garen.

        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::sendAbortingOnFailure):
        (WebKit::NetworkResourceLoader::didReceiveResponse): After notifying about the response,
          call platformDidReceiveResponse.
        * NetworkProcess/NetworkResourceLoader.h:

        * NetworkProcess/mac/NetworkResourceLoaderMac.mm: Added.
        (WebKit::NetworkResourceLoader::platformDidReceiveResponse): Attempt to pull a filesystem
          mmap'ed buffer from the CFNetwork cache and - if it exists - abort the traditional load
          and send that to the WebProcess instead.
        (WebKit::NetworkResourceLoader:: fileBackedResourceMinimumSize): For now, use the VM page size.

        * NetworkProcess/mac/NetworkProcessMac.mm:
        (WebKit::NetworkProcess::platformInitializeNetworkProcess): Set the threshold for what
          should be backed by a file on disk instead of stored in the database.

        Change SharedMemory to do a vm_copy if a previously existing buffer is being passed in:
        * Platform/SharedMemory.h:
        * Platform/mac/SharedMemoryMac.cpp:
        (WebKit::SharedMemory::create):
        (WebKit::SharedMemory::createWithVMCopy):

        * WebProcess/Network/WebResourceLoader.cpp:
        (WebKit::shareableResourceDeallocate):
        (WebKit::createShareableResourceDeallocator):
        (WebKit::WebResourceLoader::didReceiveResource): Create a special CFDataRef whose buffer is
          backed by a ShareableResource to send to the ResourceLoader in one chunk.

        * Shared/ShareableResource.h: Fix some comments.

        * WebKit2.xcodeproj/project.pbxproj:

2013-03-18  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [WK2][EFL] Fix code wrapping WKPageGroupRef
        https://bugs.webkit.org/show_bug.cgi?id=112364

        Reviewed by Alexey Proskuryakov.

        The patch fixes following problems in EWK2 WKPageGroupRef wrapping
        code: firstly it makes sure that there is only one EwkPageGroup
        instance per WKPageGroup instance, secondly it allows web page to
        to use the default page group (which is implicitly created inside
        web context).

        * UIProcess/API/C/efl/WKView.cpp:
        (createWKView):

            Now may pass '0' page group as a WebView creation argument so
            that the default page group is used.

        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::EwkView):
        (EwkView::createEvasObject):
        * UIProcess/API/efl/EwkView.h:
        (EwkView):

            Web view should be created before page group, so they are rearranged
            inside class declaration.

        * UIProcess/API/efl/ewk_page_group.cpp:
        (pageGroupMap):

            A map to track corresponding EwkPageGroup and WKPageGroup
            instances.

        (EwkPageGroup::findOrCreateWrapper):

            Returns the same EwkPageGroup instance for the same WKPageGroup
            instance.

        (EwkPageGroup::create):
        (EwkPageGroup::EwkPageGroup):

            Now there is only one constructor accepting WKPageGroupRef.

        (EwkPageGroup::~EwkPageGroup):
        * UIProcess/API/efl/ewk_page_group_private.h:
        (EwkPageGroup):
        * UIProcess/efl/WebInspectorProxyEfl.cpp:
        (WebKit::WebInspectorProxy::platformCreateInspectorPage):

2013-03-17  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Invalid charset encoding using when substituting a misspelled word in WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=112517

        Reviewed by Alexey Proskuryakov.

        The problem is that we are creating the WebContextMenuItemData
        with the GtkAction label as UTF-8.

        * UIProcess/gtk/WebContextMenuProxyGtk.cpp:
        (WebKit::contextMenuItemActivatedCallback): Use String::fromUTF8()
        to convert the GtkAction label to UTF-16.

2013-03-16  Pratik Solanki  <psolanki@apple.com>

        Disable High DPI Canvas on iOS
        https://bugs.webkit.org/show_bug.cgi?id=112511

        Reviewed by Joseph Pecoraro.

        * Configurations/FeatureDefines.xcconfig:

2013-03-15  Timothy Hatcher  <timothy@apple.com>

        Disable suppressesIncrementalRendering for the Web Inspector.

        This ends up causing the Inspector to show blank for a couple seconds before
        it does its first paint. During that time the bare window chrome is showing
        when the Inspector's background and other simple elements count be painting.
        This causes the Inspector to look like it is loading slower than reality.

        https://bugs.webkit.org/show_bug.cgi?id=112300
        rdar://problem/13412219

        Reviewed by Geoff Garen.

        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::createInspectorPageGroup): Disable suppressesIncrementalRendering.

2013-03-13  Timothy Hatcher  <timothy@apple.com>

        Delay creating the Inspector window so we don't cause a CoreIPC deadlock.

        Other changes include:
        * Create the Inspector WKView at the correct size so it does not need to
          resize later when added to the window.
        * Update the minimum and initial window sizes to better match the new UI.
        * Store the Inspector window frame in WebKit preferences so each page group
          can have different saved window frames. Handy for inspecting the Inspector.

        https://bugs.webkit.org/show_bug.cgi?id=112300
        rdar://problem/13412219

        Reviewed by Geoff Garen.

        * Shared/WebPreferencesStore.cpp:
        (WebKit::defaultValueForKey):
        Added FOR_EACH_WEBKIT_STRING_PREFERENCE_NOT_IN_WEBCORE.

        * Shared/WebPreferencesStore.h:
        (FOR_EACH_WEBKIT_STRING_PREFERENCE_NOT_IN_WEBCORE):
        Added. Needed to keep WebPage::updatePreferences for trying to set WebCore::Settings.

        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::WebInspectorProxy::minimumWindowWidth):
        (WebKit::WebInspectorProxy::initialWindowWidth):
        Bumped the values to work better with the new UI.

        * UIProcess/WebInspectorProxy.h:
        (WebKit::WebInspectorProxy::windowFrameDidChange):
        Added.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (-[WKWebInspectorProxyObjCAdapter windowDidMove:]):
        (-[WKWebInspectorProxyObjCAdapter windowDidResize:]):
        Call WebInspectorProxy::windowFrameDidChange.

        (WebKit::WebInspectorProxy::createInspectorWindow):
        Use the preferences for the page group to get the window frame.

        (WebKit::WebInspectorProxy::platformCreateInspectorPage):
        Stop calling platformAttach or createInspectorWindow, do it in platformOpen.

        (WebKit::WebInspectorProxy::platformOpen):
        Call platformAttach or createInspectorWindow here instead.

        (WebKit::WebInspectorProxy::windowFrameDidChange):
        Added. Store the frame in the page group's preferences.

        (WebKit::WebInspectorProxy::platformAttach):
        (WebKit::WebInspectorProxy::platformDetach):
        Remove code that called setHidden:. We don't need to do that anymore.

2013-03-15  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Enforce the C++11 standard when compiling WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=112169

        Reviewed by Gustavo Noronha Silva.

        With a limited set of supported compilers the WebKit2 source code can now
        be built with the C++11 language standard enforced.

        * GNUmakefile.am:
        * UIProcess/API/gtk/WebKitWebContext.cpp:
        (injectedBundleDirectory): Adjust the string literals concatenation, moving away from empty strings
        (which C++11 refuses to handle as concatenation operators) and using whitespace instead.
        * UIProcess/InspectorServer/gtk/WebInspectorServerGtk.cpp:
        (WebKit::WebInspectorServer::platformResourceForPath): Ditto.
        * UIProcess/gtk/WebInspectorProxyGtk.cpp:
        (WebKit::inspectorFilesBasePath): Ditto.

2013-03-15  Nate Chapin  <japhet@chromium.org>

        Hide MainResourceLoader from the outside world
        https://bugs.webkit.org/show_bug.cgi?id=109971

        Reviewed by Adam Barth.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::convertMainResourceLoadToDownload):
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.h:
        (WebFrameLoaderClient):
        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::convertMainResourceLoadToDownload):
        * WebProcess/WebPage/WebFrame.h:
        (WebFrame):

2013-03-15  Abhishek Arya  <inferno@chromium.org>

        Replace static_casts with to* helper functions.
        https://bugs.webkit.org/show_bug.cgi?id=112401

        Reviewed by Stephen Chenney.

        to* helper functions are preferred over static_cast calls since they
        help to catch bad casts easily on the testing infrastructure.

        * Shared/WebRenderObject.cpp:
        (WebKit::WebRenderObject::WebRenderObject):

2013-03-15  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [WK2][EFL] Get rid of WebPageProxy::viewWidget() method
        https://bugs.webkit.org/show_bug.cgi?id=112289

        Reviewed by Alexey Proskuryakov.

        Web page should not be aware of platform-specific view.

        * UIProcess/API/efl/EwkView.cpp:
        (wkPageToEvasObjectMap):
        (EwkView::EwkView):
        (EwkView::~EwkView):
        (EwkView::toEvasObject):

            EwkView::toEvasObject() relies on static map rather than on
            removed WebPageProxy::viewWidget() method.

        * UIProcess/API/efl/EwkView.h:
        * UIProcess/API/efl/ewk_text_checker.cpp:
        (uniqueSpellDocumentTag):
        * UIProcess/cairo/BackingStoreCairo.cpp:
        (WebKit::BackingStore::incorporateUpdate):

            Now uses EwkView::toEvasObject().

        * UIProcess/WebPageProxy.h:
        (WebPageProxy):
        * UIProcess/efl/WebPageProxyEfl.cpp:

            Removed WebPageProxy::viewWidget() method.

2013-03-14  Andreas Kling  <akling@apple.com>

        REGRESSION(r145169): [Mac][WK2] http/tests/security/cross-frame-access-put.html fails.
        <http://webkit.org/b/111815>
        <rdar://problem/13380145>

        Reviewed by Anders Carlsson.

        Call getWindowFrame() to see if the UI client wants to override the window frame before sending
        a WindowAndViewFramesChanged message to the web process.
        This fixes a glitch in WTR and the Web Inspector where incorrect window frames were being used.

        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::windowAndViewFramesChanged):

2013-03-14  Andy Estes  <aestes@apple.com>

        [WebKit2] Only preprocess sandbox profiles if we're building for the OS X SDK
        https://bugs.webkit.org/show_bug.cgi?id=112330

        Reviewed by David Kilzer.

        We shouldn't preprocess sandbox profiles just because the computer
        we're building on is a Mac. We should only do it if we're actually
        building for the OS X SDK.

        * DerivedSources.make: Check if $PLATFORM_NAME is macosx rather than if
        $OS is MACOS.

2013-03-14  Sam Weinig  <sam@webkit.org>

        Support private browsing on a per-page basis
        <rdar://problem/11969491>

        Reviewed by Timothy Horton.

        Adds WKPageSetOverridePrivateBrowsingEnabled and WKPageGetOverridePrivateBrowsingEnabled.

        * Shared/WebPageCreationParameters.cpp:
        (WebKit::WebPageCreationParameters::encode):
        (WebKit::WebPageCreationParameters::decode):
        * Shared/WebPageCreationParameters.h:
        (WebPageCreationParameters):
        * UIProcess/API/C/WKPage.cpp:
        (WKPageSetOverridePrivateBrowsingEnabled):
        (WKPageGetOverridePrivateBrowsingEnabled):
        * UIProcess/API/C/WKPagePrivate.h:
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::WebPageProxy):
        (WebKit::WebPageProxy::creationParameters):
        (WebKit::WebPageProxy::setOverridePrivateBrowsingEnabled):
        * UIProcess/WebPageProxy.h:
        (WebKit::WebPageProxy::overridePrivateBrowsingEnabled):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::WebPage):
        (WebKit::WebPage::updatePreferences):
        (WebKit::WebPage::setOverridePrivateBrowsingEnabled):
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/WebPage.messages.in:
        Pipe through.

2013-03-14  Abhishek Arya  <inferno@chromium.org>

        Replace static_casts with to* helper functions.
        https://bugs.webkit.org/show_bug.cgi?id=112296

        Reviewed by Kentaro Hara.

        to* helper functions are preferred over static_cast calls since they
        help to catch bad casts easily on the testing infrastructure.

        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.cpp:
        (WebKit::InjectedBundleNodeHandle::elementBounds):
        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::containsAnyFormElements):

2013-03-14  Jinwoo Song  <jinwoo7.song@samsung.com>

        [EFL][WK2] Add an API for adding and removing user style sheets from a page group
        https://bugs.webkit.org/show_bug.cgi?id=110728

        Reviewed by Gyuyoung Kim.

        This patch implements EwkPageGroup API to provide the interface of WKPageGroup. Using the EwkPageGroup,
        applications may create the views with a page group for the specific identifier. Also, this patch
        encapsulates the APIs WKPageGroupAddUserStyleSheet and WKPageGroupRemoveAllUserStyleSheets behind
        the EwkPageGroup class for adding and removing user style sheets from a page group. WKArrayCreateWithEinaList()
        is added as a generic WKArray creation API from Eina_List.

        * PlatformEfl.cmake:
        * UIProcess/API/C/efl/WKView.cpp:
        (createWKView):
        * UIProcess/API/efl/EWebKit2.h:
        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::EwkView):
        (EwkView::createEvasObject):
        * UIProcess/API/efl/EwkView.h:
        (EwkView::ewkPageGroup):
        (EwkView):
        * UIProcess/API/efl/ewk_view.cpp:
        (ewk_view_smart_add):
        (ewk_view_page_group_get):
        * UIProcess/API/efl/ewk_view.h:
        * UIProcess/API/efl/tests/UnitTestUtils/EWK2UnitTestBase.cpp:
        (EWK2UnitTest::EWK2UnitTestBase::SetUp):
        * UIProcess/API/efl/tests/UnitTestUtils/EWK2UnitTestBase.h:
        (EWK2UnitTest::EWK2UnitTestBase::setWebView):
        * UIProcess/API/efl/tests/test_ewk2_view.cpp:
        (TEST_F):
        * UIProcess/efl/WebInspectorProxyEfl.cpp:
        (WebKit::WebInspectorProxy::platformCreateInspectorPage):

2013-03-14  Simon Hausmann  <simon.hausmann@digia.com>

        [Qt] Improve the handling of mock geolocation, device orientation and motion clients

        Reviewed by Tor Arne Vestbø.

        The mock versions of these web facing features should be instantiated when
        running in DumpRenderTree only. In order for them to work, no extra Qt modules
        such as QtLocation are actually needed.

        This patch decouples enabling device orientation/motion and geolocation from
        the underlying Qt modules and makes them available in developer builds
        (!production_build) and backed by mock backends when running in drt.

        So if the Qt 5 modules are available, they'll be used (unless drtRun). For
        developers the web facing features are always enabled (although requests will
        time out) and the mock backends are enabled inside DRT, allowing for the layout
        tests to run with less dependencies.

        In addition this also enables the mock device motion client, which was
        previously never instantiated.

        * Target.pri:
        * UIProcess/qt/WebContextQt.cpp:
        (WebKit::WebContext::platformInitializeWebProcess):
        * UIProcess/qt/WebGeolocationProviderQt.cpp:
        * WebKit2.pri:
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::WebPage):

2013-03-14  Alice Liu  <alice.liu@apple.com>

        Add to HistoryItem a way to know if its underlying CachedPage has expired.
        https://bugs.webkit.org/show_bug.cgi?id=110652

        Reviewed by Brady Eidson.

        Hook up hasCachedPageExpired in InjectedBundle's BackForwardListItem.
        * WebProcess/InjectedBundle/API/c/WKBundleBackForwardListItem.cpp:
        (WKBundleBackForwardListItemHasCachedPageExpired):
        * WebProcess/InjectedBundle/API/c/WKBundleBackForwardListItem.h:
        * WebProcess/InjectedBundle/InjectedBundleBackForwardListItem.h:
        (WebKit::InjectedBundleBackForwardListItem::hasCachedPageExpired):

2013-03-13  Rik Cabanier  <cabanier@adobe.com>

        create runtime flags for CSS Compositing
        https://bugs.webkit.org/show_bug.cgi?id=111818

        Reviewed by Ryosuke Niwa.

        Added a preference to enable CSS compositing.

        * Shared/WebPreferencesStore.h:
        (WebKit):
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::overrideBoolPreferenceForTestRunner):
        (WebKit::InjectedBundle::setCSSCompositingEnabled):
        (WebKit):
        * WebProcess/InjectedBundle/InjectedBundle.h:
        (InjectedBundle):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::updatePreferences):

2013-03-13  Ryosuke Niwa  <rniwa@webkit.org>

        Threaded HTML Parser is missing feature define flags in all but Chromium port's build files
        https://bugs.webkit.org/show_bug.cgi?id=112277

        Reviewed by Adam Barth.

        * Configurations/FeatureDefines.xcconfig:

2013-03-13  Brady Eidson  <beidson@apple.com>

        Small ResourceLoader cleanups.
        https://bugs.webkit.org/show_bug.cgi?id=112279

        Reviewed by Geoff Garen.

        Replace the "bool allAtOnce" flag with a descriptive enum to make reading code easier.

        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::didReceiveData):

        * WebProcess/Network/WebResourceLoader.cpp:
        (WebKit::WebResourceLoader::didReceiveData):
        (WebKit::WebResourceLoader::didReceiveResource):
        * WebProcess/Network/WebResourceLoader.h:
        * WebProcess/Network/WebResourceLoader.messages.in: Get rid of the "allAtOnce" flag since it was always false.

2013-03-13  Abhishek Arya  <inferno@chromium.org>

        Replace static_casts with to* functions for document types.
        https://bugs.webkit.org/show_bug.cgi?id=112225

        Reviewed by Ryosuke Niwa.

        * WebProcess/InjectedBundle/API/mac/WKDOMDocument.mm: Remove the redundant helper.

2013-03-13  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Build fixes after 145552
        https://bugs.webkit.org/show_bug.cgi?id=112267

        Reviewed by Gustavo Noronha Silva.

        * GNUmakefile.am: Narrow down the dependency CFLAGS list to only ones that are actually needed
        to build the platformgtk_sources into libPlatformGtk2.la. At the moment this means only
        GTK+-2.0 CFLAGS are used.

2013-03-13  Antoine Quint  <graouts@apple.com>

        Calling WebInspectorClient::highlight() during a fade-out animation of the PageOverlay won't stop its animation
        https://bugs.webkit.org/show_bug.cgi?id=112271

        Reviewed by Tim Horton.

        Add a new stopFadeOutAnimation() on PageOverlay that we call when
        WebInspectorClient::highlight() is called and a page overlay
        is already available. This ensures that any fade-out animation
        is cleared before proceeding with showing the page overlay
        for the new highlight.

        * WebProcess/WebCoreSupport/WebInspectorClient.cpp:
        (WebKit::WebInspectorClient::highlight):
        * WebProcess/WebPage/PageOverlay.cpp:
        (WebKit::PageOverlay::stopFadeOutAnimation):
        (WebKit):
        * WebProcess/WebPage/PageOverlay.h:
        (PageOverlay):

2013-03-13  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: get rid of hiddenPanels filter
        https://bugs.webkit.org/show_bug.cgi?id=112252

        Reviewed by Vsevolod Vlasov.

        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.cpp:
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.h:
        (WebInspectorFrontendClient):

2013-03-13  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [WK2][Qt] Regression(145517) WebProcess asserts in debug build on WebKitTestRunner start
        https://bugs.webkit.org/show_bug.cgi?id=112223

        Reviewed by Simon Hausmann.

        We need to only enable the cookie jar and the disk cache conditionally
        in the web process since we removed default paths and WKTR doesn't provide
        them.

        * WebProcess/qt/WebProcessQt.cpp:
        (WebKit::WebProcess::platformSetCacheModel):
        (WebKit::WebProcess::platformInitializeWebProcess):

2013-03-12  Christophe Dumez  <ch.dumez@sisa.samsung.com>

        [EFL][WK2] ewk_popup_menu_close() does not work as intended
        https://bugs.webkit.org/show_bug.cgi?id=110209

        Reviewed by Laszlo Gombos.

        ewk_popup_menu_close() is called by the browser to notify WebKit that
        the popup menu was closed. However, the implementation was calling
        EwkView::closePopupMenu() which was asking the browser to close the
        popup menu via an Evas smart function. This patch fixes the behavior
        and ewk_popup_menu_close() now calls WKPopupMenuListenerSetSelection()
        C API so that the WebProcess is notified that the popup menu was
        hidden.

        * UIProcess/API/efl/ewk_popup_menu.cpp:
        (EwkPopupMenu::close):

2013-03-12  Huang Dongsung  <luxtella@company100.net>

        Coordinated Graphics: Remove CoordinatedGraphicsLayer::setRootLayer().
        https://bugs.webkit.org/show_bug.cgi?id=111835

        Reviewed by Luiz Agostini.

        Amend CoordinatedLayerTreeHost because
        CoordinatedGraphicsLayer::setRootLayer() is removed.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::CoordinatedLayerTreeHost):

2013-03-12  Dean Jackson  <dino@apple.com>

        Primary plugin hit detection needs to run after plugin creation
        https://bugs.webkit.org/show_bug.cgi?id=112206

        Reviewed by Tim Horton.

        On some pages, the plugins are created after the page has loaded, and
        thus our heuristic to determine the primary plugin fails. Run this
        heuristic more often: after each PluginView is created. It already exits
        early if it has found a primary. But we also need to make sure that it
        doesn't run before load.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::addPluginView): Run detection when view is added.
        (WebKit::WebPage::didFinishLoad): Remember that we have loaded.
        (WebKit::WebPage::determinePrimarySnapshottedPlugIn): Look at the PluginViews to see if we have a plugin.
        (WebKit::WebPage::resetPrimarySnapshottedPlugIn): Reset both flags.
        * WebProcess/WebPage/WebPage.h:
        (WebPage): New member variable, m_readyToFindPrimarySnapshottedPlugin.

2013-03-12  Beth Dakin  <bdakin@apple.com>

        WKView -printOperationWithPrintInfo:forFrame: doesn’t use the print info that is 
        passed in
        https://bugs.webkit.org/show_bug.cgi?id=112212
        -and corresponding-
        <rdar://problem/12994883>

        Reviewed by Anders Carlsson.

        We should call [NSPrintOperation printOperationWithView: printInfo:] to use the 
        printInfo parameter instead of [NSPrintOperation printOperationWithView:] which 
        will just use the sharedPrintInfo.
        * UIProcess/API/mac/WKView.mm:
        (-[WKView printOperationWithPrintInfo:forFrame:]):

2013-03-12  Geoffrey Garen  <ggaren@apple.com>

        Moved RunLoopTimer and SchedulePair to WTF
        https://bugs.webkit.org/show_bug.cgi?id=112171

        Reviewed by Oliver Hunt.

        This will allow us to use timers in lower level primitives without
        duplicating all the code.

        * WebProcess/WebCoreSupport/mac/WebFrameNetworkingContext.h:
        (WebFrameNetworkingContext):

2013-03-12  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Remove HILDON_CPPFLAGS and HILDON_CFLAGS references from GNUmakefiles
        https://bugs.webkit.org/show_bug.cgi?id=112163

        Reviewed by Martin Robinson.

        * GNUmakefile.am: The Hildon dependency doesn't exist anymore so there's no need for
        references to HILDON_CPPFLAGS and HILDON_CFLAGS.

2013-03-12  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Set up the libPlatformGtk.la library
        https://bugs.webkit.org/show_bug.cgi?id=111738

        Reviewed by Martin Robinson.

        * GNUmakefile.am: Reference platformgtk_cppflags variable, libPlatformGtk.la along with webcoregtk_cppflags variable, libWebCoreGtk.la.
        Adjust the path to GtkVersioning.c, the file has moved under Source/Platform.

2013-03-12  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [WK2][EFL] Fix EwkContext class API
        https://bugs.webkit.org/show_bug.cgi?id=111706

        Reviewed by Alexey Proskuryakov.

        * UIProcess/API/C/efl/WKView.cpp:
        (createWKView):
        * UIProcess/API/efl/ewk_context.cpp:
        (EwkContext::findOrCreateWrapper):

            Renamed from create() as it returns the same instance of EwkContext
            for the given WKContextRef if present.

        (EwkContext::create):
        (EwkContext::defaultContext):

            Returns raw pointer rather than PassRefPtr<EwkContext> as ownership
            is not transferred.

        (ewk_context_default_get):
        * UIProcess/API/efl/ewk_context_private.h:
        (EwkContext):
        * UIProcess/efl/WebInspectorProxyEfl.cpp:
        (WebKit::WebInspectorProxy::platformCreateInspectorPage):

2013-03-12  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Enable Web Audio in development builds
        https://bugs.webkit.org/show_bug.cgi?id=111831

        Reviewed by Philippe Normand.

        * GNUmakefile.am: Link the plugin process against libWebCoreModules.la as well.

2013-03-11  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [Qt][WK2] Layer QtDownloadManager on the C API
        https://bugs.webkit.org/show_bug.cgi?id=109562

        Reviewed by Simon Hausmann.
        Signed off for WebKit2 by Benjamin Poulain.

        * UIProcess/API/cpp/qt/WKURLQt.cpp:
        (WebKit::adoptToQString):
        (WebKit):
        (WebKit::adoptToQUrl):
        * UIProcess/API/cpp/qt/WKURLQt.h:
        (WebKit):
        * UIProcess/API/qt/qquickwebview.cpp:
        (QQuickWebViewPrivate::handleDownloadRequest):
        * UIProcess/qt/QtDownloadManager.cpp:
        (WebKit::toQtDownloadManager):
        (WebKit):
        (WebKit::QtDownloadManager::QtDownloadManager):
        (WebKit::QtDownloadManager::addDownload):
        (WebKit::QtDownloadManager::didReceiveResponse):
        (WebKit::QtDownloadManager::didCreateDestination):
        (WebKit::QtDownloadManager::didFinishDownload):
        (WebKit::QtDownloadManager::didFailDownload):
        (WebKit::QtDownloadManager::didReceiveDataForDownload):
        * UIProcess/qt/QtDownloadManager.h:
        (WebKit):
        (QtDownloadManager):
        * UIProcess/qt/QtWebContext.cpp:
        (WebKit::QtWebContext::QtWebContext):
        * UIProcess/qt/QtWebError.cpp:
        (WebKit::QtWebError::url):
        (WebKit::QtWebError::description):

2013-03-11  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [Qt][WK2] Layer QtWebIconDatabaseClient on the C API
        https://bugs.webkit.org/show_bug.cgi?id=109564

        Reviewed by Simon Hausmann.
        Signed off for WebKit2 by Benjamin Poulain.

        * Target.pri:
        * UIProcess/API/C/qt/WKIconDatabaseQt.cpp: Added.
        (WKIconDatabaseTryGetQImageForURL):
          - New API added to get a QImage from the IconDatabase.
            Based on WKIconDatabaseCG.h/cpp
        * UIProcess/API/C/qt/WKIconDatabaseQt.h: Added.
        * UIProcess/API/cpp/qt/WKURLQt.cpp:
        (WKURLCreateWithQString):
        (WKURLCopyQString):
        (WKURLCreateWithQUrl):
        (WKURLCopyQUrl):
          - The WKUrlRef behind the scene is a WTF::String and encoding it back and forth to
            a QUrl can slightly change its string representation. Allow converting a WKUrlRef
            to and from a QString to ensure this.
        * UIProcess/API/cpp/qt/WKURLQt.h:
        * UIProcess/API/qt/qwebiconimageprovider.cpp:
        (QWebIconImageProvider::iconURLForPageURLInContext):
          - The icon URL isn't accessible form the C API and shouldn't need to be.
            Use an ID incremented on each update to trigger an update of the QML Image component.
        (QWebIconImageProvider::requestImage):
          - The IconDatabase was previously assumed to resize the image to the requested size,
            but this parameter is ignored, as stated in a comment in WebIconDatabase::imageForPageURL.
            Explicitely do the resize after fetching the original icon to also be able to report
            the original size properly to QtQuick.
        * UIProcess/API/qt/qwebiconimageprovider_p.h:
        * UIProcess/API/qt/tests/qmltests/WebView/tst_favIconLoad.qml:
          - Set the image to load asynchronously to further test the possibility of threading issues
            in QtWebIconDatabaseClient::iconImageForPageURL
          - Add a few barriers to fix some issues where the load succeeded signal would be wrongly
            catched by init() before the next test.
        * UIProcess/qt/QtWebContext.cpp:
        (WebKit::QtWebContext::QtWebContext):
        * UIProcess/qt/QtWebIconDatabaseClient.cpp:
        (WebKit):
        (WebKit::QtWebIconDatabaseClient::QtWebIconDatabaseClient):
        (WebKit::QtWebIconDatabaseClient::~QtWebIconDatabaseClient):
        (WebKit::QtWebIconDatabaseClient::updateID):
        (WebKit::QtWebIconDatabaseClient::didChangeIconForPageURL):
        (WebKit::QtWebIconDatabaseClient::iconImageForPageURL):
          - Remove the Mutex. This mutex was useless given that it would only
            be locked from a single thread. Since the IconDatabase runs in its own thread,
            it already is thread-safe to access.
        (WebKit::QtWebIconDatabaseClient::retainIconForPageURL):
        (WebKit::QtWebIconDatabaseClient::releaseIconForPageURL):
        * UIProcess/qt/QtWebIconDatabaseClient.h:
        (QtWebIconDatabaseClient):
        * WebKit2.pri:

2013-03-11  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [Qt][WK2] Specify storage paths through the C API
        https://bugs.webkit.org/show_bug.cgi?id=111435

        Reviewed by Simon Hausmann.
        Signed off for WebKit2 by Benjamin Poulain.

        The WKIconDatabase should be opened through a call to
        WKContextSetIconDatabasePath. To avoid having some paths
        returned through WebContext::platformDefault* and some others
        through the C API, make sure that all those paths are set
        through the C API.

        * Shared/qt/QtDefaultDataLocation.cpp: Removed.
        * Shared/qt/QtDefaultDataLocation.h: Removed.
        * Target.pri:
        * UIProcess/Plugins/qt/PluginProcessProxyQt.cpp:
        (WebKit::cacheFile):
          - This part is left alone behind the C API.
            Since PluginProcessProxy have no knowledge of the WebContext
            it is rather difficult to fetch a configured directory that
            could be used for this purpose (like the disk cache storage).
            Hard-code a compatible logic to keep the current behavior.
        (WebKit::removeCacheFile):
        (WebKit):
        (WebKit::readMetaDataFromCacheFile):
        (WebKit::writeToCacheFile):
        (WebKit::tryReadPluginMetaDataFromCacheFile):
          - Update the code to better handle an empty cache file path.
        * UIProcess/qt/QtWebContext.cpp:
        (WebKit::QtWebContext::defaultContext):
        (WebKit::defaultLocation):
        (WebKit):
        (WebKit::QtWebContext::preparedStoragePath):
        * UIProcess/qt/QtWebContext.h:
        * UIProcess/qt/QtWebIconDatabaseClient.cpp:
        (WebKit::QtWebIconDatabaseClient::QtWebIconDatabaseClient):
        * UIProcess/qt/WebContextQt.cpp:
        (WebKit::WebContext::applicationCacheDirectory):
        (WebKit::WebContext::platformDefaultDatabaseDirectory):
        (WebKit::WebContext::platformDefaultIconDatabasePath):
        (WebKit::WebContext::platformDefaultLocalStorageDirectory):
        (WebKit::WebContext::platformDefaultDiskCacheDirectory):
        (WebKit::WebContext::platformDefaultCookieStorageDirectory):

2013-02-14  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [Qt] Properly layer QtWebContext on top of the C API
        https://bugs.webkit.org/show_bug.cgi?id=108475

        Reviewed by Simon Hausmann.
        Signed off for WebKit2 by Benjamin Poulain.

        * UIProcess/API/qt/qquickwebview.cpp:
        (QQuickWebViewPrivate::initialize):
        * UIProcess/qt/QtWebContext.cpp:
        (WebKit::initializeContextInjectedBundleClient):
        (WebKit::QtWebContext::QtWebContext):
        (WebKit::QtWebContext::create):
        (WebKit::QtWebContext::defaultContext):
        * UIProcess/qt/QtWebContext.h:
        (WebKit):
        (QtWebContext):
        (WebKit::QtWebContext::context):

2013-02-14  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [Qt][WK2] Allow QtWebContext to call directly to QQuickWebView with a WKPageRef
        https://bugs.webkit.org/show_bug.cgi?id=109829

        Reviewed by Allan Sandfeld Jensen.
        Signed off for WebKit2 by Benjamin Poulain.

        Instead of going through WebPageProxy and PageClient to forward
        injected bundle messages received by the context, maintain a static map
        of WKPageRef to QQuickWebViewPrivate.

        * UIProcess/API/qt/qquickwebview.cpp:
        (QQuickWebViewPrivate::get):
        (QQuickWebViewPrivate::~QQuickWebViewPrivate):
        (QQuickWebViewPrivate::initialize):
        (QQuickWebViewPrivate::didReceiveMessageFromNavigatorQtObject):
        * UIProcess/API/qt/qquickwebview_p_p.h:
        (QQuickWebViewPrivate):
        * UIProcess/API/qt/raw/qrawwebview.cpp:
        * UIProcess/API/qt/raw/qrawwebview_p_p.h:
        * UIProcess/PageClient.h:
        (PageClient):
        * UIProcess/WebPageProxy.h:
        (WebPageProxy):
        * UIProcess/qt/QtPageClient.cpp:
        * UIProcess/qt/QtPageClient.h:
        (QtPageClient):
        * UIProcess/qt/QtWebContext.cpp:
        (WebKit::didReceiveMessageFromInjectedBundle):
        * UIProcess/qt/WebPageProxyQt.cpp:

2013-02-14  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [Qt][WK2] Keep the WebContext alive during the whole application's lifetime
        https://bugs.webkit.org/show_bug.cgi?id=109827

        Reviewed by Simon Hausmann.
        Signed off for WebKit2 by Benjamin Poulain.

        The lifetime of the WebContext is difficult to manage because of a circular
        reference kept with the WebProcessProxy until it shuts itself down, 60
        seconds after the last page is closed. There was some notification
        in place to handle this in the upper layer, but having to go through the
        C API (done in a following patch) makes this quite awkward.

        Keeping the WebContext alive also includes the icon database which is
        quite heavy, in the future we should only enable it once the
        QQuickWebView::icon property is read.

        * UIProcess/API/qt/qquickwebview.cpp:
        (QQuickWebViewPrivate::QQuickWebViewPrivate):
        (QQuickWebViewPrivate::handleDownloadRequest):
        (QQuickWebViewPrivate::updateIcon):
        * UIProcess/API/qt/qquickwebview_p_p.h:
        (QQuickWebViewPrivate):
        * UIProcess/API/qt/qwebiconimageprovider.cpp:
        (QWebIconImageProvider::requestImage):
        * UIProcess/qt/QtWebContext.cpp:
        (WebKit):
        (WebKit::QtWebContext::QtWebContext):
        (WebKit::QtWebContext::~QtWebContext):
        (WebKit::QtWebContext::create):
        (WebKit::QtWebContext::defaultContext):
        * UIProcess/qt/QtWebContext.h:
        (QtWebContext):
        (WebKit::QtWebContext::downloadManager):
        (WebKit::QtWebContext::iconDatabase):
        * UIProcess/qt/WebContextQt.cpp:
        (WebKit::WebContext::platformInvalidateContext):

2013-02-14  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [Qt][WK2] Favor QUrl and QString over WTF::String in the Qt API layer
        https://bugs.webkit.org/show_bug.cgi?id=109468

        Reviewed by Allan Sandfeld Jensen.
        Signed off for WebKit2 by Benjamin Poulain.

        In preparation for patches using the C API types in some areas, remove the
        usage of WTF::String on the affected line.

        Use a QUrl for icon URL to avoid unnecessary conversion.
        Use a QString for the page URL to keep it compatible with WebPageProxy and
        WebIconDatabase and avoid QUrl parsing.

        * UIProcess/API/qt/qquickwebview.cpp:
        (QQuickWebViewPrivate::_q_onIconChangedForPageURL):
        (QQuickWebViewPrivate::updateIcon):
        (QQuickWebView::emitUrlChangeIfNeeded):
        (QQuickWebView::icon):
        * UIProcess/API/qt/qquickwebview_p_p.h:
        (QQuickWebViewPrivate):
        * UIProcess/API/qt/qwebiconimageprovider.cpp:
        (QWebIconImageProvider::iconURLForPageURLInContext):
        * UIProcess/API/qt/qwebiconimageprovider_p.h:
        * UIProcess/qt/QtWebIconDatabaseClient.cpp:
        (WebKit::QtWebIconDatabaseClient::iconForPageURL):
        (WebKit::QtWebIconDatabaseClient::iconImageForPageURL):
        (WebKit::QtWebIconDatabaseClient::retainIconForPageURL):
        (WebKit::QtWebIconDatabaseClient::releaseIconForPageURL):
        * UIProcess/qt/QtWebIconDatabaseClient.h:
        (QtWebIconDatabaseClient):

2013-03-12  Manuel Rego Casasnovas  <rego@igalia.com>

        [GTK][WK2] REGRESSION(r145081): Unit tests not working if locale is not English
        https://bugs.webkit.org/show_bug.cgi?id=111973

        Reviewed by Carlos Garcia Campos.

        The problem is that the UIProcess locale is reseted to C in
        gtk_test_init, however the WebProcess does not inherit the locale set in
        the UIProcess and it uses the system one (that could be different to
        English). So, there were problems in some tests that are comparing
        strings from both processes like WebKit2APITests/TestPrinting and
        WebKit2APITests/TestWebKitWebContext. The solution is to set the locale
        environment variable LC_ALL to C in order to reset WebProcess locale
        too.

        * UIProcess/API/gtk/tests/TestMain.cpp:
        (main): Set environment variable LC_ALL to C.

2013-03-11  Brady Eidson  <beidson@apple.com>

        Loads are never canceled in the NetworkProcess
        <rdar://problem/12890500> and https://bugs.webkit.org/show_bug.cgi?id=112103

        Reviewed by Alexey Proskuryakov.

        If a connection to a WebProcess is closed (gracefully or by crashing) then:
        - All scheduled loads for that connection should be forgotten.
        - All in-progress loads for that connection should be aborted asap.

        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::requestsToCleanupMutex): The "request to stop" mechanism is now called "request to cleanup"
        (WebKit::requestsToCleanup):
        (WebKit::NetworkResourceLoader::scheduleCleanupOnMainThread):
        (WebKit::NetworkResourceLoader::performCleanups):
        (WebKit::NetworkResourceLoader::cleanup):
        (WebKit::NetworkResourceLoader::didFinishLoading):
        (WebKit::NetworkResourceLoader::didFail):

        (WebKit::NetworkResourceLoader::connectionToWebProcessDidClose): If there is a resource handle, let
          the loading thread notice the connection is invalid. Otherwise request to cleanup the loader.
        (WebKit::NetworkResourceLoader::sendAbortingOnFailure):
        (WebKit::NetworkResourceLoader::sendSyncAbortingOnFailure):
        (WebKit::NetworkResourceLoader::abortInProgressLoad): Cancel the resource handle and schedule main thread cleanup.
        (WebKit::NetworkResourceLoader::didReceiveResponse): Use sendAbortingOnFailure instead of send.
        (WebKit::NetworkResourceLoader::didReceiveData): Ditto.

        (WebKit::NetworkResourceLoader::willSendRequest): Call abortInProgressLoad if the sync message failed.
        (WebKit::NetworkResourceLoader::canAuthenticateAgainstProtectionSpace): Ditto.
        * NetworkProcess/NetworkResourceLoader.h:

        Make connectionToWebProcessDidClose() pure virtual, moving its implementation to the subclasses:
        * NetworkProcess/SchedulableLoader.cpp:
        * NetworkProcess/SchedulableLoader.h:

        * NetworkProcess/SyncNetworkResourceLoader.cpp:
        (WebKit::SyncNetworkResourceLoader::start): Call cleanup().
        (WebKit::SyncNetworkResourceLoader::connectionToWebProcessDidClose): Call cleanup().
        (WebKit::SyncNetworkResourceLoader::cleanup): Factor out the sync loader cleanup code.
        * NetworkProcess/SyncNetworkResourceLoader.h:

2013-03-11  Tim Horton  <timothy_horton@apple.com>

        PDFPlugin: Return PDFKit's data instead of the original resource data for save/etc.
        https://bugs.webkit.org/show_bug.cgi?id=111956
        <rdar://problem/13352282>

        Reviewed by Alexey Proskuryakov.

        If we return the original resource data, we lose changes made to annotations.

        * WebProcess/Plugins/PDF/PDFPlugin.mm:
        (WebKit::PDFPlugin::pdfDocumentDidLoad): Adopt the renamed rawData().
        (WebKit::PDFPlugin::saveToPDF): Use liveData so that "Save to PDF" persists changes to annotations.
        (WebKit::PDFPlugin::openWithNativeApplication): Use liveData so that "Open With [native application]" persists changes to annotations.

        * WebProcess/Plugins/PDF/PDFPluginAnnotation.h:
        * WebProcess/Plugins/PDF/PDFPluginAnnotation.mm:
        (WebKit::PDFPluginAnnotation::commit): Added, inform PDFPlugin that we're mutating the document.
        * WebProcess/Plugins/PDF/PDFPluginChoiceAnnotation.mm:
        (WebKit::PDFPluginChoiceAnnotation::commit): Let PDFPluginAnnotation do what it needs to inform PDFPlugin that we're going to mutate the document.
        * WebProcess/Plugins/PDF/PDFPluginTextAnnotation.mm:
        (WebKit::PDFPluginTextAnnotation::commit): Let PDFPluginAnnotation do what it needs to inform PDFPlugin that we're going to mutate the document.

        * WebProcess/Plugins/PDF/SimplePDFPlugin.h:
        (WebKit::SimplePDFPlugin::didMutatePDFDocument): Added.
        (WebKit::SimplePDFPlugin::liveData): Added.
        (WebKit::SimplePDFPlugin::rawData): Renamed from data(). Return NSData for consistency.
